/*
Copyright (c) 2010, Geomatics and Cartographic Research Centre, 
Carleton University, Canada
All rights reserved.

Released under New BSD License.
Details at:
   https://svn.gcrc.carleton.ca/nunaliit2/trunk/sdk/license.txt
   
$Id: license.txt 8178 2012-06-04 20:46:29Z jpfiset $   
*/

;(function($,$n2){var _loc=function(str){return $n2.loc(str,'nunaliit2-couch');};function httpJsonError(XMLHttpRequest,defaultStr){if(!JSON||typeof(JSON.parse)!=='function'){return defaultStr;};var text=XMLHttpRequest.responseText;if(!text)return defaultStr;var error=JSON.parse(text);if(!error)return defaultStr;if(!error.reason)return defaultStr;return error.reason;};function fixUserName(userName){return userName.toLowerCase().replace(' ','');};var Session=$n2.Class({server:null,userDb:null,pathToSession:null,changedContextListeners:null,lastSessionContext:null,initialize:function(server_,userDb_){this.server=server_;this.userDb=userDb_;this.changedContextListeners=[];this.lastSessionContext=null;},getUrl:function(){return this.server.getSessionUrl();},getContext:function(){return this.lastSessionContext;},addChangedContextListener:function(listener){if(typeof(listener)==='function'){this.changedContextListeners.push(listener);if(this.lastSessionContext){listener(this.lastSessionContext);};};},changeContext:function(context){var _this=this;this.lastSessionContext=context;if(this.lastSessionContext){for(var i=0,e=this.changedContextListeners.length;i<e;++i){var listener=this.changedContextListeners[i];try{listener(this.lastSessionContext);}catch(e){};};if(!this.lastSessionContext.userDoc&&this.lastSessionContext.name){this.userDb.getUser({name:this.lastSessionContext.name,onError:function(){},onSuccess:function(userDoc){if(_this.lastSessionContext&&_this.lastSessionContext.name===userDoc.name){_this.lastSessionContext.userDoc=userDoc;_this.changeContext(_this.lastSessionContext);}}});};};},refreshContext:function(opts_){var opts=$.extend({onSuccess:function(context){},onError:$n2.reportErrorForced},opts_);var _this=this;var sessionUrl=this.getUrl();$.ajax({url:sessionUrl,type:'get',async:true,dataType:'json',success:function(res){if(res.ok){if(res&&res.info&&res.info.authentication_db){_this.userDb.setUserDbName(res.info.authentication_db);};var context=res.userCtx;_this.changeContext(context);opts.onSuccess(context);}else{opts.onError('Malformed context reported');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining context: '+errStr);}});},login:function(opts_){var opts=$.extend({name:null,password:null,onSuccess:function(context){},onError:$n2.reportErrorForced},opts_);var _this=this;var sessionUrl=this.getUrl();if(opts.name){var name=fixUserName(opts.name);}else{opts.onError('A name must be supplied when logging in');return;};$.ajax({url:sessionUrl,type:'post',async:true,data:{name:name,password:opts.password},contentType:'application/x-www-form-urlencoded',dataType:'json',success:function(info){if(info&&info.ok){_this.refreshContext({onSuccess:opts.onSuccess,onError:opts.onError});}else{opts.onError('Unknown error during log in');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during log in: '+errStr);}});},logout:function(opts_){var opts=$.extend({onSuccess:function(context){},onError:$n2.reportErrorForced},opts_);var _this=this;var sessionUrl=this.getUrl();$.ajax({url:sessionUrl,type:'DELETE',async:true,dataType:'json',success:function(info){if(info&&info.ok){_this.refreshContext({onSuccess:opts.onSuccess,onError:opts.onError});}else{opts.onError('Unknown error during log out');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during log out: '+errStr);}});}});var UserDb=$n2.Class({server:null,userDbName:null,initialize:function(server_){this.server=server_;this.userDbName='_users';},getUrl:function(){return this.server.getUserDbUrl();},getUserDbName:function(){return this.userDbName;},setUserDbName:function(userDbName_){this.userDbName=userDbName_;},createUser:function(opts_){var opts=$.extend({name:null,password:null,onSuccess:function(docInfo){},onError:$n2.reportErrorForced},opts_);var userDbUrl=this.getUrl();if(typeof(hex_sha1)!=='function'){opts.onError('SHA-1 must be installed');return;};if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to create database documents');return;};this.server.getUniqueId({onSuccess:onUuid});function onUuid(uuid){var id='org.couchdb.user:'+fixUserName(opts.name);var salt=uuid;var password_sha=hex_sha1(opts.password+salt);var doc={};for(var key in opts){if(key!=='name'&&key!=='password'&&key!=='onSuccess'&&key!=='onError'){doc[key]=opts[key];};};doc.type="user";doc.name=fixUserName(opts.name);doc.password_sha=password_sha;doc.salt=salt;if(!$n2.isArray(doc.roles)){doc.roles=[];};$.ajax({url:userDbUrl+id,type:'put',async:true,data:JSON.stringify(doc),contentType:'application/json',dataType:'json',success:opts.onSuccess,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during user creation: '+errStr);}});};},updateUser:function(options_){var opts=$.extend(true,{user:null,onSuccess:function(docInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var userDbUrl=this.getUrl();if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to update user documents');return;};if(!opts.user||!opts.user._id||!opts.user._rev){opts.onError('On update, a valid document with _id and _rev attributes must be supplied');return;};$.ajax({url:userDbUrl+opts.user._id,type:'PUT',async:true,data:JSON.stringify(opts.user),contentType:'application/json',dataType:'json',success:function(docInfo){opts.onSuccess(docInfo);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error updating user: '+errStr);}});},setUserPassword:function(options_){var opts=$.extend(true,{user:null,password:null,onSuccess:function(docInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var userDbUrl=this.getUrl();if(typeof(hex_sha1)!=='function'){opts.onError('SHA-1 must be installed');return;};if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to set user password');return;};if(!opts.user||!opts.user._id||!opts.user._rev){opts.onError('On password change, a valid user document with _id and _rev attributes must be supplied');return;};if(!opts.password){opts.onError('On password change, a valid password must be supplied');return;};this.server.getUniqueId({onSuccess:onUuid});function onUuid(uuid){var salt=uuid;var password_sha=hex_sha1(opts.password+salt);opts.user.password_sha=password_sha;opts.user.salt=salt;$.ajax({url:userDbUrl+opts.user._id,type:'PUT',async:true,data:JSON.stringify(opts.user),contentType:'application/json',dataType:'json',success:function(docInfo){opts.onSuccess(docInfo);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error changing user password: '+errStr);}});};},deleteUser:function(opts_){var opts=$.extend({user:null,id:null,rev:null,name:null,onSuccess:function(docInfo){},onError:$n2.reportErrorForced},opts_);var userDbUrl=this.getUrl();var id=null;var rev=null;if(opts.user){id=opts.user._id;rev=opts.user._rev;}
if(!id&&opts.id){id=opts.id;}
if(!id&&opts.name){id='org.couchdb.user:'+fixUserName(opts.name);}
if(!rev&&opts.rev){rev=opts.rev;}
$.ajax({url:userDbUrl+id+'?rev='+rev,type:'DELETE',async:true,dataType:'json',success:opts.onSuccess,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during user deletion: '+errStr);}});},getUser:function(options_){var opts=$.extend(true,{name:null,onSuccess:function(user){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var userDbUrl=this.getUrl();var id=opts._id;if(!id){var id='org.couchdb.user:'+fixUserName(opts.name);}
$.ajax({url:userDbUrl+id,type:'get',async:true,dataType:'json',success:function(res){opts.onSuccess(res);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining user for '+id+': '+errStr);}});},getUsers:function(options_){var opts=$.extend(true,{names:null,onSuccess:function(users){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var effectiveUrl=this.getUrl()+'_all_docs?include_docs=true';var userNames=[];if(!opts.names){opts.onError('Unable to query multiple users without the "names" parameter');return;}
for(var i=0,e=opts.names.length;i<e;++i){userNames.push('org.couchdb.user:'+fixUserName(opts.names[i]));};if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to query multiple users');return;};var data={keys:userNames};$.ajax({url:effectiveUrl,type:'POST',async:true,data:JSON.stringify(data),contentType:'application/json',dataType:'json',success:function(res){if(res.rows){var users=[];for(var i=0,e=res.rows.length;i<e;++i){var row=res.rows[i];if(row&&row.doc){users.push(row.doc);}};opts.onSuccess(users);}else{opts.onError('Unexpected response during query of multiple users');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during query of multiple users: '+errStr);}});},getAllUsers:function(opts_){var opts=$.extend({onSuccess:function(users){},onError:$n2.reportErrorForced},opts_);if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to query a view');return;};var viewUrl=this.getUrl()+'_all_docs';var data={startkey:JSON.stringify('org.couchdb.user:'),endkey:JSON.stringify('org.couchdb.user='),include_docs:true};$.ajax({url:viewUrl,type:'get',async:true,data:data,dataType:'json',success:function(queryResult){if(queryResult.rows){var users=[];for(var i=0,e=queryResult.rows.length;i<e;++i){var row=queryResult.rows[i];if(row&&row.doc){users.push(row.doc);}};opts.onSuccess(users);}else{opts.onError('Unexpected response during query of all users');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during query of all users: '+errStr);}});}});var designDoc=$n2.Class({ddUrl:null,ddName:null,initialize:function(opts_){$.extend(this,opts_);},getQueryUrl:function(opts_){var opts=$.extend(true,{viewName:null,listName:null},opts_);if(opts.listName){return this.ddUrl+'_list/'+opts.listName+'/'+opts.viewName;}else{return this.ddUrl+'_view/'+opts.viewName;};},queryView:function(options_){var opts=$.extend(true,{viewName:null,listName:null,viewUrl:null,startkey:null,endkey:null,keys:null,group:null,include_docs:null,limit:null,onlyRows:true,rawResponse:false,reduce:false,onSuccess:function(rows){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to query a view');};var viewUrl=opts.viewUrl;if(!viewUrl){if(opts.listName){viewUrl=this.ddUrl+'_list/'+opts.listName+'/'+opts.viewName;}else{viewUrl=this.ddUrl+'_view/'+opts.viewName;};};var data={};for(var k in opts){if(k==='viewName'||k==='listName'||k==='viewUrl'||k==='onlyRows'||k==='rawResponse'||k==='onSuccess'||k==='onError'||typeof(opts[k])==='undefined'||opts[k]===null){}else{data[k]=opts[k];};};var mustBePost=false;if(data.keys){mustBePost=true;};var dataType='json';if(opts.rawResponse){dataType='text';};if(mustBePost){var jsonData=JSON.stringify(data);$.ajax({url:viewUrl,type:'post',async:true,data:jsonData,contentType:'application/json',dataType:dataType,success:processResponse,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during view query '+opts.viewName+': '+errStr);}});}else{for(var key in data){data[key]=JSON.stringify(data[key]);};$.ajax({url:viewUrl,type:'GET',async:true,cache:false,data:data,dataType:dataType,success:processResponse,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during view query '+opts.viewName+': '+errStr);}});};function processResponse(queryResponse){if(opts.onlyRows){if(queryResponse.rows){opts.onSuccess(queryResponse.rows);}else{opts.onError('Unexpected response during view query '+opts.view);};}else{opts.onSuccess(queryResponse);};};}});var ChangeNotifier=$n2.Class({options:null,db:null,listeners:null,lastSequence:null,currentRequest:null,currentWait:null,onError:function(err){$n2.log(err);},initialize:function(db,opts_){this.options=$n2.extend({changeUrl:null,doNotReset:false,include_docs:false,pollInterval:5000,longPoll:false,timeout:20000,listeners:null,onSuccess:function(notifier){}},opts_);this.db=db;this.listeners=[];if(this.options.listeners){for(var i=0,e=this.options.listeners.length;i<e;++i){this.listeners.push(this.options.listeners[i]);};delete this.options.listeners;};var onSuccessFn=this.options.onSuccess;delete this.options.onSuccess;var _this=this;if(this.options.doNotReset){finishInitialization();}else{this.resetLastSequence({onSuccess:finishInitialization,onError:finishInitialization});};function finishInitialization(){_this.reschedule();_this.requestChanges();onSuccessFn(_this);};},addListener:function(listener){if(typeof(listener)==='function'){this.listeners.push(listener);this.requestChanges();};},resetLastSequence:function(opt_){var opt=$n2.extend({onSuccess:function(){},onError:function(err){}},opt_);var _this=this;this.db.getInfo({onSuccess:function(dbInfo){_this.lastSequence=dbInfo.update_seq;opt.onSuccess();},onError:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opt.onError('Error during a query of current update sequence: '+errStr);}});},getLastSequence:function(){return this.lastSequence;},_reportChanges:function(changes){if(changes.last_seq){this.lastSequence=changes.last_seq;};if(changes.results&&changes.results.length>0){for(var i=0,e=this.listeners.length;i<e;++i){this.listeners[i](changes);};};},requestChanges:function(){if(!this.listeners||this.listeners.length<1){return;};if(this.currentRequest){return;};if(this.currentWait){return;};var req={feed:'normal'};if(typeof(this.lastSequence)==='number'){req.since=this.lastSequence;};if(this.options.include_docs){req.include_docs=this.options.include_docs;};if(this.options.longPoll){req.feed='longpoll';req.timeout=this.options.timeout;};this.currentRequest=req;var _this=this;$.ajax({url:this.options.changeUrl,type:'GET',async:true,data:req,dataType:'json',success:function(changes){_this.currentRequest=null;_this._reportChanges(changes);_this.reschedule();},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);_this.onError('Error during a server notifications: '+errStr);_this.reschedule();}});},reschedule:function(){var now=Date.now();var expected=now+this.options.pollInterval;if(this.currentWait){if(this.currentWait.expected>expected){if(typeof(clearTimeout)==='function'){clearTimeout(this.currentWait.timerId);}
this.currentWait=null;}else{return;};};this.currentWait={delayInMs:this.options.pollInterval,expected:expected};var _this=this;this.currentWait.timerId=setTimeout(function(){_this.currentWait=null;_this.requestChanges();},this.currentWait.delayInMs);}});var Database=$n2.Class({dbUrl:null,dbName:null,server:null,initialize:function(opts_,server_){$.extend(this,opts_);this.server=server_;if(!this.dbUrl){var pathToServer=server_.getPathToServer();this.dbUrl=pathToServer+this.dbName+'/';};},getDesignDoc:function(opts_){var ddOpts=$.extend({ddUrl:null,ddName:null},opts_);if(!ddOpts.ddUrl){ddOpts.ddUrl=this.dbUrl+'_design/'+ddOpts.ddName+'/';};return new designDoc(ddOpts);},getChangeNotifier:function(opt_){var opt=$n2.extend({onSuccess:function(notifier){}},opt_);var changeNotifier=new ChangeNotifier(this,{changeUrl:this.dbUrl+'_changes',onSuccess:opt.onSuccess});return changeNotifier;},getChanges:function(opt_){var opt=$n2.extend({since:null,limit:null,descending:false,include_docs:false,onSuccess:function(changes){},onError:function(msg){$n2.reportErrorForced(msg);}},opt_);var req={feed:'normal'};if(opt.since){req.since=opt.since;};if(opt.limit){req.limit=opt.limit;};if(opt.descending){req.descending=opt.descending;};if(opt.include_docs){req.include_docs=opt.include_docs;};var changeUrl=this.dbUrl+'_changes';var _this=this;$.ajax({url:changeUrl,type:'GET',async:true,data:req,dataType:'json',success:opt.onSuccess,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining database changes: '+errStr);}});},getDocumentUrl:function(doc){if(typeof(doc)==='string'){var docId=doc;}else{docId=doc._id;};return this.dbUrl+docId;},getDocumentRevision:function(opts_){var opts=$.extend({docId:null,onSuccess:function(info){},onError:function(msg){$n2.reportErrorForced(msg);}},opts_);if(!opts.docId){opts.onError('No docId set. Can not retrieve document information');};$.ajax({url:this.dbUrl+'_all_docs',type:'get',async:true,data:{startkey:'"'+opts.docId+'"',endkey:'"'+opts.docId+'"',include_docs:false},dataType:'json',success:function(res){if(res.rows&&res.rows[0]&&res.rows[0].value&&res.rows[0].value.rev){opts.onSuccess(res.rows[0].value.rev);}else{opts.onError('Malformed document revision for: '+opts.docId);};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining document revision for '+opts.docId+': '+errStr);}});},buildUploadFileForm:function(jQuerySet,options_){var _this=this;var opts=$.extend({docId:null,rev:null,doc:null,onSuccess:function(res){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);jQuerySet.empty();if(!$.fn.ajaxSubmit){opts.onError('Can not perform file uploads unless jquery.form.js is included');};if(null==opts.docId){if(opts.doc)opts.docId=opts.doc._id;};if(null==opts.docId){opts.onError('Must specify document id when performing file uploads');};if(null==opts.rev){if(opts.doc)opts.rev=opts.doc._rev;};if(null==opts.rev){this.getDocumentRevision({docId:opts.docId,onSuccess:function(docRev){jQuerySet.each(function(i,elem){installForm(elem,opts.docId,docRev);});},onError:opts.onError});}else{jQuerySet.each(function(i,elem){installForm(elem,opts.docId,opts.rev);});};function installForm(elem,docId,docRev){var $elem=$(elem),$form=$('<form method="post"></form>'),$button=$('<input class="n2CouchInputButton" type="button"/>');$form.append($('<input class="n2CouchInputFile" type="file" name="_attachments"/>'));$form.append($('<input type="hidden" name="_rev" value="'+docRev+'"/>'));$button.val(_loc('Upload'));$form.append($button);$elem.append($form);$button.click(function(){$form.ajaxSubmit({type:'post',url:_this.dbUrl+docId,dataType:'json',success:function(res){$elem.find('*').removeAttr('disabled');if(res.error){opts.onError(_loc('Error while uploading: ')+res.error,options_);}else{opts.onSuccess(res,options_);}},error:function(xhr,status,err){$elem.find('*').removeAttr('disabled');opts.onError(_loc('Error while uploading: ')+err,options_);}});$elem.find('.n2CouchInputButton').attr('disabled','disabled');});};},createDocument:function(options_){var opts=$.extend(true,{data:{},onSuccess:function(docInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to create database documents');};var _s=this;var docId=opts.data._id;if(docId){onUuid(docId);}else{this.server.getUniqueId({onSuccess:onUuid,onError:opts.onError});};function onUuid(docId){$.ajax({url:_s.dbUrl+docId,type:'put',async:true,data:JSON.stringify(opts.data),contentType:'application/json',dataType:'json',success:function(docInfo){opts.onSuccess(docInfo);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error creating document: '+errStr);}});};},updateDocument:function(options_){var opts=$.extend(true,{data:null,onSuccess:function(docInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to update database documents');return;};if(!opts.data||!opts.data._id||!opts.data._rev){opts.onError('On update, a valid document with _id and _rev attributes must be supplied');return;};var _s=this;$.ajax({url:_s.dbUrl+opts.data._id,type:'PUT',async:true,data:JSON.stringify(opts.data),contentType:'application/json',dataType:'json',success:function(docInfo){opts.onSuccess(docInfo);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error updating document: '+errStr);}});},deleteDocument:function(options_){var opts=$.extend(true,{data:null,onSuccess:function(docInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(!JSON||typeof(JSON.stringify)!=='function'){opts.onError('json.js is required to delete database documents');return;};if(!opts.data||!opts.data._id||!opts.data._rev){opts.onError('On delete, a valid document with _id and _rev attributes must be supplied');return;};var _s=this;$.ajax({url:_s.dbUrl+opts.data._id+'?rev='+opts.data._rev,type:'DELETE',async:true,dataType:'json',success:function(docInfo){opts.onSuccess(docInfo);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error deleting document: '+errStr);}});},bulkDocuments:function(documents,options_){var opts=$.extend(true,{onSuccess:function(docInfos){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to create database documents');};var data=JSON.stringify({docs:documents});var _s=this;$.ajax({url:_s.dbUrl+'_bulk_docs',type:'POST',async:true,data:data,contentType:'application/json',dataType:'json',success:function(docInfos){opts.onSuccess(docInfos);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error on bulk document operation: '+errStr);}});},getDocument:function(options_){var opts=$.extend(true,{docId:null,rev:null,revs_info:false,revisions:false,conflicts:false,onSuccess:function(doc){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(!opts.docId){opts.onError('No docId set. Can not retrieve document');};var data={};if(opts.rev){data.rev=opts.rev;};if(opts.revs_info){data.revs_info='true';};if(opts.revisions){data.revs='true';};if(opts.conflicts){data.conflicts='true';};$.ajax({url:this.dbUrl+opts.docId+'/',type:'get',async:true,data:data,dataType:'json',success:function(res){opts.onSuccess(res);},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining document content for '+opts.docId+': '+errStr);}});},getDocuments:function(opts_){var opts=$.extend(true,{docIds:null,onSuccess:function(docs){},onError:function(errorMsg){$n2.log(errorMsg);}},opts_);if(JSON&&JSON.stringify){}else{opts.onError('json.js is required to query multiple documents');return;};if(!opts.docIds){opts.onError('No docIds set. Can not retrieve documents');return;};var viewUrl=this.dbUrl+'_all_docs?include_docs=true';var data={keys:opts.docIds};$.ajax({url:viewUrl,type:'POST',async:true,data:JSON.stringify(data),contentType:'application/json',dataType:'json',success:function(queryResult){if(queryResult.rows){var docs=[];for(var i=0,e=queryResult.rows.length;i<e;++i){var row=queryResult.rows[i];if(row&&row.doc){docs.push(row.doc);}};opts.onSuccess(docs);}else{opts.onError('Unexpected response during query of multiple documents');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during query of multiple documents: '+errStr);}});},listAllDocuments:function(opts_){var opts=$.extend(true,{onSuccess:function(docIds){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);var viewUrl=this.dbUrl+'_all_docs?include_docs=false';$.ajax({url:viewUrl,type:'GET',async:true,dataType:'json',success:function(queryResult){if(queryResult.rows){var docIds=[];for(var i=0,e=queryResult.rows.length;i<e;++i){var row=queryResult.rows[i];if(row&&row.id){docIds.push(row.id);}};opts.onSuccess(docIds);}else{opts.onError('Unexpected response during listing of all documents');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during listing of all documents: '+errStr);}});},getAllDocuments:function(opts_){var opts=$.extend(true,{onSuccess:function(docs){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);var viewUrl=this.dbUrl+'_all_docs?include_docs=true';$.ajax({url:viewUrl,type:'GET',async:true,dataType:'json',success:function(queryResult){if(queryResult.rows){var docs=[];for(var i=0,e=queryResult.rows.length;i<e;++i){var row=queryResult.rows[i];if(row&&row.doc){docs.push(row.doc);}};opts.onSuccess(docs);}else{opts.onError('Unexpected response during retrieval of all documents');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during retrieval of all documents: '+errStr);}});},getInfo:function(opts_){var opts=$.extend(true,{onSuccess:function(dbInfo){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},opts_);$.ajax({url:this.dbUrl,type:'GET',async:true,dataType:'json',success:function(dbInfo){if(dbInfo.error){opts.onError(dbInfo.error);}else{opts.onSuccess(dbInfo);};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during databse infro: '+errStr);}});},queryTemporaryView:function(opts_){var opts=$n2.extend({map:null,reduce:null,onSuccess:function(rows){},onError:$n2.reportErrorForced},opts_);if(!opts.map){opts.onError('"map" must be provided in temporary view');};var data={map:opts.map};if(opts.reduce){data.reduce=opts.reduce;};var viewUrl=this.dbUrl+'_temp_view';$.ajax({url:viewUrl,type:'post',async:true,dataType:'json',data:JSON.stringify(data),contentType:'application/json',success:function(queryResult){if(queryResult.rows){opts.onSuccess(queryResult.rows);}else{opts.onError('Unexpected response during query of temporary view');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error during query temporary view: '+errStr);}});}});var Server=$n2.Class({options:null,isInitialized:false,uuids:null,userDb:null,session:null,initListeners:null,initialize:function(options_,initListeners_){this.options=$n2.extend({pathToServer:'../',pathToSession:null,pathToUserDb:null,pathToUuids:null,pathToReplicate:null,pathToActiveTasks:null,pathToAllDbs:null,version:null,skipSessionInitialization:false,onSuccess:function(){},onError:function(err){}},options_);this.isInitialized=false;this.uuids=[];this.userDb=null;this.session=null;this.initListeners=initListeners_;if(!this.initListeners){this.initListeners=[];};var _this=this;getServerVersion();function getServerVersion(){if(_this.options.version){refreshContext();}else{$.ajax({url:_this.options.pathToServer,type:'get',async:true,dataType:'json',success:function(res){if(res.version){_this.options.version=res.version;refreshContext();}else{errorInitialize('Malformed database welcome message.');};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);errorInitialize('Error obtaining database welcome: '+errStr);}});};};function refreshContext(){if(_this.options.skipSessionInitialization){finishInitialize();}else{_this.getSession().refreshContext({onSuccess:finishInitialize,onError:errorInitialize});};};function finishInitialize(){_this.isInitialized=true;for(var i=0,e=_this.initListeners;i<e;++i){var listener=_this.initListeners[i];try{listener();}catch(e){}};_this.initListeners=[];_this.options.onSuccess(_this);delete _this.options['onSuccess'];delete _this.options['onError'];};function errorInitialize(err){_this.options.onError(err);delete _this.options['onSuccess'];delete _this.options['onError'];};},getPathToServer:function(){return this.options.pathToServer;},getVersion:function(){return this.options.version;},getReplicateUrl:function(){if(null==this.options.pathToReplicate){return this.options.pathToServer+'_replicate';}
return this.options.pathToReplicate;},getActiveTasksUrl:function(){if(null==this.options.pathToActiveTasks){return this.options.pathToServer+'_active_tasks';}
return this.options.pathToActiveTasks;},getUserDbUrl:function(){var result=this.options.pathToUserDb;if(!result){var userDbName=this.getUserDb().getUserDbName();result=this.options.pathToServer+userDbName+'/';};return result;},getSessionUrl:function(){var result=this.options.pathToSession;if(!result){result=this.options.pathToServer+'_session';};return result;},getUniqueId:function(options_){var opts=$.extend({onSuccess:function(uuid){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);if(this.uuids.length>0){var uuid=this.uuids.pop();opts.onSuccess(uuid);return;};var pathUUids=this.options.pathToUuids;if(!pathUUids){pathUUids=this.options.pathToServer+'_uuids';};$.ajax({url:pathUUids,type:'get',async:true,data:{count:10},dataType:'json',success:function(res){if(res.uuids){this.uuids=res.uuids;var uuid=this.uuids.pop();opts.onSuccess(uuid);return;}
opts.onError('Malformed uuids from database.');},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining new uuids from database: '+errStr);}});},listDatabases:function(options_){var opts=$.extend({onSuccess:function(dbNameArray){},onError:function(errorMsg){$n2.reportErrorForced(errorMsg);}},options_);var pathToAllDbs=this.options.pathToAllDbs;if(!pathToAllDbs){pathToAllDbs=this.options.pathToServer+'_all_dbs';};$.ajax({url:pathToAllDbs,type:'get',async:true,dataType:'json',success:opts.onSuccess,error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error obtaining list of databases: '+errStr);}});},getUserDb:function(){if(!this.userDb){this.userDb=new UserDb(this);};return this.userDb;},getSession:function(){if(!this.session){var userDb=this.getUserDb();this.session=new Session(this,userDb);};return this.session;},getDb:function(opts){return new Database(opts,this);},createDb:function(opts_){var opts=$n2.extend({dbName:null,onSuccess:function(db){},onError:$n2.reportErrorForced},opts_);if(!opts.dbName){opts.onError('"dbName" must be provided when creating a database');return;};var dbUrl=this.getPathToServer()+opts.dbName;var _s=this;$.ajax({url:dbUrl,type:'put',async:true,dataType:'json',success:function(creationInfo){if(creationInfo.ok){var db=_s.getDb({dbUrl:dbUrl});opts.onSuccess(db);}else{opts.onError('Error occurred when creating database: '+creationInfo.error);};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error creating database: '+errStr);}});},deleteDb:function(opts_){var opts=$n2.extend({dbName:null,onSuccess:function(){},onError:$n2.reportErrorForced},opts_);if(!opts.dbName){opts.onError('"dbName" must be provided when deleting a database');return;};var dbUrl=this.getPathToServer()+opts.dbName;var _s=this;$.ajax({url:dbUrl,type:'DELETE',async:true,dataType:'json',success:function(info){if(info.ok){opts.onSuccess();}else{opts.onError('Error occurred when deleting database: '+info.error);};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error deleting database: '+errStr);}});},replicate:function(opts_){var opts=$n2.extend({source:null,target:null,filter:null,docIds:null,continuous:false,onSuccess:function(db){},onError:$n2.reportErrorForced},opts_);if(!opts.source){opts.onError('"source" must be provided for replication');return;};if(!opts.target){opts.onError('"target" must be provided for replication');return;};var request={source:opts.source,target:opts.target};if(opts.filter){request.filter=opts.filter;};if(opts.continuous){request.continuous=true;};if(opts.docIds){request.doc_ids=opts.docIds;};var serverPath=this.getReplicateUrl();$.ajax({url:serverPath,type:'POST',async:true,data:JSON.stringify(request),contentType:'application/json',dataType:'json',success:function(res){if(res.ok){opts.onSuccess();}else{opts.onError('Error while initiating replication: '+res.error);};},error:function(XMLHttpRequest,textStatus,errorThrown){var errStr=httpJsonError(XMLHttpRequest,textStatus);opts.onError('Error initiating replication: '+errStr);}});},addInitializedListener:function(listener){if(typeof(listener)==='function'){if(this.isInitialized){try{listener();}catch(e){}}else{this.initListeners.push(listener);};};}});function addAttachmentToDocument(opts_){var opts=$n2.extend({doc:null,data:null,attachmentName:null,contentType:'application/binary'},opts_);if(!opts.doc||!opts.data||!opts.attachmentName){return'Invalid parameters';};if(typeof($n2.Base64)=='undefined'){return'Base64 not included';};if(!opts.doc._attachments){opts.doc._attachments={};};opts.doc._attachments[opts.attachmentName]={};opts.doc._attachments[opts.attachmentName].content_type=opts.contentType;opts.doc._attachments[opts.attachmentName].data=$n2.Base64.encode(opts.data);return null;};$n2.couch=$.extend({},{getServer:function(opt_){return new Server(opt_);},DefaultServer:null,defaultInitializeListeners:[],getPathToServer:function(){return $n2.couch.DefaultServer.getPathToServer();},addInitializedListener:function(listener){if($n2.couch.DefaultServer){$n2.couch.DefaultServer.addInitializedListener(listener);}else{if(typeof(listener)==='function'){$n2.couch.defaultInitializeListeners.push(listener);};};},initialize:function(opts_){$n2.couch.DefaultServer=new Server(opts_,$n2.couch.defaultInitializeListeners);},getVersion:function(){return $n2.couch.DefaultServer.getVersion();},getSession:function(){return $n2.couch.DefaultServer.getSession();},getUserDb:function(){return $n2.couch.DefaultServer.getUserDb();},getReplicateUrl:function(){return $n2.couch.DefaultServer.getReplicateUrl();},getActiveTasksUrl:function(){return $n2.couch.DefaultServer.getActiveTasksUrl();},getDb:function(opts){return $n2.couch.DefaultServer.getDb(opts);},getUniqueId:function(options_){$n2.couch.DefaultServer.getUniqueId();},addAttachmentToDocument:addAttachmentToDocument});$.fn.couchUploadFile=function(opts){var db=$n2.couch.getDb(opts);db.buildUploadFileForm(this,opts);return this;};})(jQuery,nunaliit2);;(function($,$n2){var defaultOptions={db:null,designDoc:null,viewNameSchemas:'schemas',viewNameRootSchemas:'schemas-root'};var options=defaultOptions;$n2.schema.DefaultRepository.loadSchemasFn=function(opt_){var opt=$n2.extend({names:null,rootSchemas:false,onSuccess:function(schemaDefinitions){},onError:function(err){$n2.reportError(err);}},opt_);var viewRequest={viewName:options.viewNameSchemas,include_docs:true,onSuccess:function(rows){var defs=[];for(var i=0,e=rows.length;i<e;++i){defs.push(rows[i].doc);};opt.onSuccess(defs);},onError:opt.onError};if(opt.names){viewRequest.keys=opt.names;};if(opt.rootSchemas){viewRequest.viewName=options.viewNameRootSchemas;};options.designDoc.queryView(viewRequest);};$n2.schema.CouchSchemaConfigure=function(options_){options=$n2.extend({},defaultOptions,options_);};$n2.schema.CouchPreload=function(options_){var opts=$n2.extend({onSuccess:function(){},onError:function(){}},defaultOptions,options,options_);opts.designDoc.queryView({viewName:opts.viewNameSchemas,include_docs:true,onSuccess:function(rows){var defs=[];for(var i=0,e=rows.length;i<e;++i){defs.push(rows[i].doc);};$n2.schema.DefaultRepository.addSchemas({schemas:defs,onSuccess:function(){opts.onSuccess(defs);},onError:opts.onError});$n2.schema.DefaultRepository.rootSchemasQueried=true;},onError:opts.onError});};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str){return $n2.loc(str,'nunaliit2-couch');};function Configure(options_){var options=$n2.extend({couchServerUrl:null,atlasDbUrl:null,atlasDesignName:'atlas',progressServerUrl:null,mediaUrl:null,uploadServerUrl:null,exportServerUrl:null,onSuccess:function(config){}},options_);var configuration={directory:{}};configuration.directory.dispatchService=new $n2.dispatch.Dispatcher();$.cometd={init:function(){},subscribe:function(){},publish:function(){}};$n2.couch.initialize({pathToServer:options.couchServerUrl,onSuccess:couchInitialized});function couchInitialized(){configuration.couchServer=$n2.couch.DefaultServer;configuration.directory.couchServer=configuration.couchServer;$.NUNALIIT_AUTH.init({onSuccess:authInitialized,autoAnonymousLogin:false,directory:configuration.directory});};function authInitialized(){configuration.auth=$.NUNALIIT_AUTH;configuration.directory.authService=configuration.auth;configuration.atlasDb=configuration.couchServer.getDb({dbUrl:options.atlasDbUrl});configuration.atlasDesign=configuration.atlasDb.getDesignDoc({ddName:options.atlasDesignName});configuration.directory.schemaRepository=$n2.schema.DefaultRepository;configuration.atlasDb.getChangeNotifier({onSuccess:function(notifier){configuration.atlasNotifier=notifier;configuration.directory.notifierService=notifier;notifierInitialized();}});};function notifierInitialized(){$n2.couchL10n.Configure({db:configuration.atlasDb,designDoc:configuration.atlasDesign});configuration.progressServer=new $n2.progress.ProgressServer({url:options.progressServerUrl});configuration.uploadServer=new $n2.upload.Upload({url:options.uploadServerUrl,progressServer:configuration.progressServer});configuration.directory.uploadService=configuration.uploadServer;configuration.directory.exportService=new $n2.couchExport.Export({url:options.exportServerUrl});configuration.searchServer=new $n2.couchSearch.SearchServer({designDoc:configuration.atlasDesign,db:configuration.atlasDb});configuration.directory.searchService=configuration.searchServer;configuration.mediaRelativePath=options.mediaUrl;configuration.cacheService=new $n2.cache.CacheService();$n2.cache.defaultCacheService=configuration.cacheService;configuration.directory.cacheService=configuration.cacheService;configuration.requests=new $n2.couchRequests({db:configuration.atlasDb,userDb:$n2.couch.getUserDb(),designDoc:configuration.atlasDesign,cacheService:configuration.cacheService,directory:configuration.directory});configuration.directory.requestService=configuration.requests;configuration.directory.dispatchSupport=new $n2.couchDispatchSupport.DispatchSupport({directory:configuration.directory});configuration.show=new $n2.couchShow.Show({db:configuration.atlasDb,designDoc:configuration.atlasDesign,serviceDirectory:configuration.directory});configuration.directory.showService=configuration.show;configuration.couchEditor=new $n2.CouchEditor.Editor({db:configuration.atlasDb,serviceDirectory:configuration.directory});configuration.directory.schemaEditorService=new $n2.CouchEditor.SchemaEditorService({serviceDirectory:configuration.directory});configuration.contributions=new $n2.couchContributions({db:configuration.atlasDb,designDoc:configuration.atlasDesign,showService:configuration.show,uploads:configuration.uploadServer});configuration.popupHtmlFn=function(opt_){var doc=opt_.feature.data;var $div=$('<span></span>');configuration.show.displayBriefDescription($div,{},doc);var $wrapper=$('<div></div>');$wrapper.append($div);var html=$wrapper.html();opt_.onSuccess(html);};configuration.serverSideNotifier=new $n2.couchServerSide.Notifier({dbChangeNotifier:configuration.atlasNotifier,directory:configuration.directory});configuration.directory.serverSideNotifier=configuration.serverSideNotifier;configuration.hoverSoundService=new $n2.couchSound.HoverSoundService({db:configuration.atlasDb,serviceDirectory:configuration.directory});$n2.hoverSoundService=configuration.hoverSoundService;configuration.directory.hoverSoundService=configuration.hoverSoundService;$n2.schema.CouchSchemaConfigure({db:configuration.atlasDb,designDoc:configuration.atlasDesign});$n2.schema.CouchPreload({onSuccess:callCustomConfiguration});};function callCustomConfiguration(){if(window&&window.nunaliit_custom&&typeof(window.nunaliit_custom.configuration)==='function'){window.nunaliit_custom.configuration(configuration,configurationDone);}else{configurationDone();};};function configurationDone(){options.onSuccess(configuration);};};$n2.couchConfiguration={Configure:Configure};})(jQuery,nunaliit2);;(function($,$n2){$n2.couchGeom=$.extend({},{getCouchGeometry:function(geom){var bounds=geom.getBounds();var wkt=geom.toString();return{nunaliit_type:'geometry',wkt:wkt,bbox:[bounds.left,bounds.bottom,bounds.right,bounds.top]};},adjustBboxOnCouchGeom:function(couchGeom){if(OpenLayers&&OpenLayers.Geometry&&OpenLayers.Geometry.fromWKT){var olGeom=OpenLayers.Geometry.fromWKT(couchGeom.wkt);var bounds=olGeom.getBounds();couchGeom.bbox=[bounds.left,bounds.bottom,bounds.right,bounds.top];};},getOpenLayersGeometry:function(options_){var opts=$.extend({couchGeom:null,onError:function(errorMsg){$n2.reportError(errorMsg);}},options_);if(OpenLayers&&OpenLayers.Geometry&&OpenLayers.Geometry.fromWKT){var olGeom=OpenLayers.Geometry.fromWKT(opts.couchGeom.wkt);return olGeom;}else{opts.onError('OpenLayers must be installed to update document geometries');};},updateDocumentWithWktGeometry:function(doc,options_){var opts=$.extend({wkt:null,onError:function(errorMsg){$n2.reportError(errorMsg);}},options_);if(!opts.wkt){opts.onError('Attribute "wkt" not provided while updating a geometry document');return;}
if(OpenLayers&&OpenLayers.Geometry&&OpenLayers.Geometry.fromWKT){var olGeom=OpenLayers.Geometry.fromWKT(opts.wkt);}else{opts.onError('OpenLayers must be installed to update document geometries');return;};var couchGeom=$n2.couchGeom.getCouchGeometry(olGeom);doc.nunaliit_geom=couchGeom;},selectTileViewFomBounds:function(viewOptions,bb,layer,fids){var views=[{tile:$n2.tiles.format4326_25M,name:'geom-tile25m',list:'noduplicate',layer:false,fid:false},{tile:$n2.tiles.format4326_25M,name:'geom-layer-tile25m',list:'noduplicate',layer:true,fid:false},{tile:$n2.tiles.format4326_65K,name:'geom-tile65k',list:'noduplicate',layer:false,fid:false},{tile:$n2.tiles.format4326_65K,name:'geom-layer-tile65k',list:'noduplicate',layer:true,fid:false},{tile:$n2.tiles.format4326_200,name:'geom-tile200',list:'noduplicate',layer:false,fid:false},{tile:$n2.tiles.format4326_200,name:'geom-layer-tile200',list:'noduplicate',layer:true,fid:false},{tile:null,name:'geom-layer-fid',layer:true,fid:true},{tile:null,name:'geom-layer',layer:true,fid:false},{tile:null,name:'geom',layer:false,fid:true}];if(bb&&fids)bb=null;for(var i=0,e=views.length;i<e;++i){var v=views[i];if(bb&&v.tile&&layer&&v.layer){if($n2.tiles.getApproxTilesForBounds(v.tile,bb[0],bb[1],bb[2],bb[3])<500){viewOptions.viewName=v.name;var tiles=$n2.tiles.getTilesFromBounds(v.tile,bb[0],bb[1],bb[2],bb[3]);viewOptions.keys=[];for(var j=0,k=tiles.length;j<k;++j){viewOptions.keys.push([layer,tiles[j]]);};if(v.list)viewOptions.listName=v.list;return true;};}else if(bb&&v.tile&&!layer&&!v.layer){if($n2.tiles.getApproxTilesForBounds(v.tile,bb[0],bb[1],bb[2],bb[3])<500){viewOptions.viewName=v.name;viewOptions.keys=$n2.tiles.getTilesFromBounds(v.tile,bb[0],bb[1],bb[2],bb[3]);if(v.list)viewOptions.listName=v.list;return true;};}else if(fids&&v.fid&&layer&&v.layer){viewOptions.viewName=v.name;viewOptions.keys=[];for(var j=0,k=fids.length;j<k;++j){viewOptions.keys.push([layer,fids[j]]);};if(v.list)viewOptions.listName=v.list;return true;}else if(fids&&v.fid&&!layer&&!v.layer){viewOptions.viewName=v.name;viewOptions.keys=fids;if(v.list)viewOptions.listName=v.list;return true;}else if(!fids&&!v.fid&&layer&&v.layer){viewOptions.viewName=v.name;viewOptions.keys=[layer];if(v.list)viewOptions.listName=v.list;return true;}else if(!bb&&!fids&&!layer&&!v.fid&&!v.layer&&!v.tile){viewOptions.viewName=v.name;if(v.list)viewOptions.listName=v.list;return true;};};return false;},queryGeometries:function(atlasDesignDoc,viewOptions){var bounds=null;var data={};data.viewName='geom';data.listName='noduplicate';for(var key in viewOptions){if(key==='bounds'){bounds=viewOptions[key];}else{data[key]=viewOptions[key];};};if(bounds){$n2.couchGeom.selectTileViewFomBounds(data,bounds);};atlasDesignDoc.queryView(data);}});})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str){return $n2.loc(str,'nunaliit2-couch');};var couchUserPrefix='org.couchdb.user:';function noop(){};var DomStyler=$n2.Class({options:null,showService:null,initialize:function(options_,showService_){this.options=options_;this.showService=showService_;},fixElementAndChildren:function($elem,opt,contextDoc){var _this=this;$elem.find('.n2_localize').each(function(){var $jq=$(this);_this._localize($jq,opt);$jq.removeClass('n2_localize').addClass('n2_localized');});$elem.find('.n2s_localize').each(function(){var $jq=$(this);_this._localize($jq,opt);$jq.removeClass('n2s_localize').addClass('n2_localized');});$elem.find('.n2s_preserveSpaces').each(function(){var $jq=$(this);_this._preserveSpaces($jq,opt);$jq.removeClass('n2s_preserveSpaces').addClass('n2s_preservedSpaces');});$elem.find('.n2_briefDisplay').each(function(){var $jq=$(this);_this._briefDisplay($jq,opt);$jq.removeClass('n2_briefDisplay').addClass('n2_briefDisplayed');});$elem.find('.n2s_referenceLink').each(function(){var $jq=$(this);_this._insertReferenceLink($jq,opt);$jq.removeClass('n2s_referenceLink').addClass('n2s_insertedReferenceLink');});$elem.find('.n2s_insertTime').each(function(){var $jq=$(this);_this._insertTime($jq,opt);$jq.removeClass('n2s_insertTime').addClass('n2s_insertedTime');});$elem.find('.n2s_insertUserName').each(function(){var $jq=$(this);_this._insertUserName($jq,opt);$jq.removeClass('n2s_insertUserName').addClass('n2s_insertedUserName');});$elem.find('.n2s_insertMediaView').each(function(){var $jq=$(this);_this._insertMediaView(contextDoc,$jq,opt);$jq.removeClass('n2s_insertMediaView').addClass('n2s_insertedMediaView');});$elem.find('.n2s_insertHoverSoundIcon').each(function(){var $jq=$(this);_this._insertHoverSoundIcon(contextDoc,$jq,opt);$jq.removeClass('n2s_insertHoverSoundIcon').addClass('n2s_insertedHoverSoundIcon');});$elem.find('.n2s_externalMediaLink').each(function(){var $jq=$(this);_this._insertExternalMediaLink(contextDoc,$jq,opt);$jq.removeClass('n2s_externalMediaLink').addClass('n2s_insertedExternalMediaLink');});$elem.find('.n2s_clickFindGeometryOnMap').each(function(){var $jq=$(this);_this._clickFindGeometryOnMap(contextDoc,$jq,opt);$jq.removeClass('n2s_clickFindGeometryOnMap').addClass('n2s_findGeometryOnMap');});$elem.find('.n2s_clickAddLayerFromDefinition').each(function(){var $jq=$(this);_this._clickAddLayerFromDefinition(contextDoc,$jq,opt);$jq.removeClass('n2s_clickAddLayerFromDefinition').addClass('n2s_addLayerFromDefinition');});$elem.find('.n2s_clickEdit').each(function(){var $jq=$(this);_this._clickEdit(contextDoc,$jq,opt);$jq.removeClass('n2s_clickEdit').addClass('n2s_edit');});$elem.find('.n2s_clickDelete').each(function(){var $jq=$(this);_this._clickDelete(contextDoc,$jq,opt);$jq.removeClass('n2s_clickDelete').addClass('n2s_delete');});$elem.find('.n2s_handleHover').each(function(){var $jq=$(this);_this._handleHover(contextDoc,$jq,opt);$jq.removeClass('n2s_handleHover').addClass('n2s_handledHover');});if($elem.hasClass('n2s_handleHover')){_this._handleHover(contextDoc,$elem,opt);$elem.removeClass('n2s_handleHover').addClass('n2s_handledHover');};},_localize:function($jq,opt_){var _this=this;var text=$jq.text();var locText=_loc(text);if(locText){$jq.text(locText);};},_preserveSpaces:function($jq,opt_){var _this=this;var text=$jq.text();var lines=text.split('\n');if(lines.length>0){$jq.empty();for(var i=0,e=lines.length;i<e;++i){var $p=$('<p></p>');$p.text(lines[i]);$jq.append($p);};};},_briefDisplay:function($jq,opt_){var _this=this;var docId=$jq.text();this.showService.printBriefDescription($jq,docId);},_insertReferenceLink:function($jq,opt_){var _this=this;var docId=$jq.text();this.showService.printBriefDescription($jq,docId);$jq.click(function(){var dispatchService=_this.showService.getDispatchService();if(dispatchService){var dispatchHandle=_this.showService.dispatchHandle;dispatchService.send(dispatchHandle,{type:'selected',docId:docId});};if(_this.options.displayFunction){_this.options.displayFunction(docId,opt_);};return false;});},_insertTime:function($jq,opt_){var _this=this;var time=1*$jq.text();var timeStr=(new Date(time)).toString();$jq.text(timeStr);},_insertUserName:function($jq,opt_){var _this=this;var userName=$jq.text();this.showService.printUserName($jq,userName,{showHandle:true});},_insertMediaView:function(data,$insertView,opt_){var attachmentName=$insertView.text();$insertView.empty();var file=null;if(data&&data.nunaliit_attachments&&data.nunaliit_attachments.files){file=data.nunaliit_attachments.files[attachmentName];};if(file&&data._attachments&&data._attachments[attachmentName]){var docUrl=this.options.db.getDocumentUrl(data);var linkDiv=null;if(file.fileClass==='image'&&file.thumbnail&&data._attachments[file.thumbnail]){linkDiv=$('<div class="n2Show_icon_wrapper"><img src="'+docUrl+'/'+file.thumbnail+'"/></div>');}else if(file.fileClass==='image'){linkDiv=$('<div class="n2Show_icon_wrapper"><div class="n2Show_icon_image"></div></div>');}else if(file.fileClass==='audio'){linkDiv=$('<div class="n2Show_icon_wrapper"><div class="n2Show_icon_audio"></div></div>');}else if(file.fileClass==='video'&&file.thumbnail&&data._attachments[file.thumbnail]){linkDiv=$('<div class="n2Show_icon_wrapper"><img src="'+docUrl+'/'+file.thumbnail+'"/></div>');}else if(file.fileClass==='video'){linkDiv=$('<div class="n2Show_icon_wrapper"><div class="n2Show_icon_video"></div></div>');};if(null!=linkDiv){$insertView.append(linkDiv);var cb=createMediaCallback(file.fileClass,docUrl,data,attachmentName);linkDiv.click(cb);};};function createMediaCallback(uploadType,docUrl,doc,attachmentName){return function(evt){var mediaOptions={url:docUrl+'/'+attachmentName};var attachment=null;if(doc._attachments&&doc._attachments[attachmentName]){attachment=doc._attachments[attachmentName];};if(attachment){mediaOptions.mimeType=attachment.content_type;};var fileDescriptor=doc.nunaliit_attachments.files[attachmentName];if(fileDescriptor&&fileDescriptor.data&&fileDescriptor.data.title){mediaOptions.title=fileDescriptor.data.title;}else if(doc.nunaliit_contribution&&doc.nunaliit_contribution.title){mediaOptions.title=doc.nunaliit_contribution.title;};if(fileDescriptor&&fileDescriptor.data&&fileDescriptor.data.description){mediaOptions.description=fileDescriptor.data.description;}else if(doc.nunaliit_contribution&&doc.nunaliit_contribution.description){mediaOptions.description=doc.nunaliit_contribution.description;};if(doc.nunaliit_created&&doc.nunaliit_created.name){mediaOptions.author=doc.nunaliit_created.name;};if(uploadType==='image'){mediaOptions.type='image';$n2.mediaDisplay.displayMedia(mediaOptions);}else if(uploadType==='video'){mediaOptions.type='video';$n2.mediaDisplay.displayMedia(mediaOptions);}else if(uploadType==='audio'){mediaOptions.type='audio';$n2.mediaDisplay.displayMedia(mediaOptions);};return false;};};},_insertHoverSoundIcon:function(data,$insertHoverSoundIcon,opt_){var _this=this;var playSound=false;if($n2.couchSound&&$n2.couchSound.DocumentContainsHoverSound&&$n2.couchSound.DocumentContainsHoverSound(data)){$insertHoverSoundIcon.append($('<div class="n2Show_icon_wrapper"><div class="n2Show_icon_speaker"></div></div>'));$insertHoverSoundIcon.find('.n2Show_icon_speaker').click(function(){toggleHoverSound();return false;});};function toggleHoverSound(){var dispatchService=_this.showService.getDispatchService();if(dispatchService){var dispatchHandle=_this.showService.dispatchHandle;if(!playSound){dispatchService.send(dispatchHandle,{type:'playHoverSoundOn',doc:data});playSound=true;}else{dispatchService.send(dispatchHandle,{type:'playHoverSoundOff',doc:data});playSound=false;};};};},_insertExternalMediaLink:function(data,$externalLink,opt_){var attachmentName=$externalLink.attr('href');var file=null;if(data&&data.nunaliit_attachments&&data.nunaliit_attachments.files){file=data.nunaliit_attachments.files[attachmentName];};if(file&&data._attachments&&data._attachments[attachmentName]){var docUrl=this.options.db.getDocumentUrl(data);var linkUrl=docUrl+'/'+attachmentName;$externalLink.attr('href',linkUrl);$externalLink.click(function(e){if(confirm(_loc('You are about to leave this page. Do you wish to continue?'))){return true;};return false;});}else{$externalLink.click(function(e){alert(_loc('File is not currently available'));return false;});};},_clickFindGeometryOnMap:function(contextDoc,$jq,opt){var _this=this;if(this.options.findGeometryFunction){if(contextDoc&&contextDoc.nunaliit_geom){var x=(contextDoc.nunaliit_geom.bbox[0]+contextDoc.nunaliit_geom.bbox[2])/2;var y=(contextDoc.nunaliit_geom.bbox[1]+contextDoc.nunaliit_geom.bbox[3])/2;$jq.click(function(){_this.options.findGeometryFunction(contextDoc,x,y,opt);return false;});}else{$jq.remove();};}else{$jq.remove();};},_clickAddLayerFromDefinition:function(contextDoc,$jq,opt){var _this=this;var viewLayerFunction=this.options.viewLayerFunction;var dispatchService=_this.showService.getDispatchService();if(viewLayerFunction||dispatchService){if(contextDoc&&contextDoc.nunaliit_layer_definition){$jq.click(function(){var layerDefinition=contextDoc.nunaliit_layer_definition;if(viewLayerFunction){viewLayerFunction(contextDoc);};if(dispatchService){var layer={id:layerDefinition.id,name:layerDefinition.name,couchDb:{viewName:'geom',layerName:layerDefinition.id,db:_this.options.db,designDoc:_this.options.designDoc}};var dispatchHandle=_this.showService.dispatchHandle;dispatchService.send(dispatchHandle,{type:'addLayerToMap',layer:layer,options:{setExtent:{bounds:layerDefinition.bbox,crs:'EPSG:4326'}}});};return false;});}else{$jq.remove();};}else{$jq.remove();};},_clickEdit:function(contextDoc,$jq,opt){var _this=this;if(this.options.editFunction){$jq.click(function(){_this.options.editFunction(contextDoc,opt);return false;});}else{$jq.empty();};},_clickDelete:function(contextDoc,$jq,opt){var _this=this;if(this.options.deleteFunction){$jq.click(function(){_this.options.deleteFunction(contextDoc,opt);return false;});}else{$jq.empty();};},_handleHover:function(contextDoc,$jq,opt){var dispatchService=this.showService.getDispatchService();if(dispatchService){var dispatchHandle=this.showService.dispatchHandle;$jq.hover(function(){dispatchService.send(dispatchHandle,{type:'focusOn',docId:contextDoc._id});},function(){dispatchService.send(dispatchHandle,{type:'focusOff',docId:contextDoc._id});});};}});var Show=$n2.Class({options:null,domStyler:null,dispatchHandle:null,initialize:function(opts_){this.options=$n2.extend({db:null,designDoc:null,serviceDirectory:null,defaultSchema:null,displayFunction:null,editFunction:null,deleteFunction:null,findGeometryFunction:null,viewLayerFunction:null,preprocessDocument:function(doc){return doc;},eliminateDeniedMedia:false,eliminateNonApprovedMedia:false},opts_);var _this=this;this.domStyler=new DomStyler(this.options,this);var requestService=this.getRequestService();if(requestService){requestService.addUserListener(function(userDoc){_this._displayUserDocument(userDoc);});requestService.addDocumentListener(function(doc){_this._displayDocument(doc);});};var notifierService=this.getNotifierService();if(notifierService){notifierService.addListener(function(change){_this._notifierUpdate(change);});};var dispatchService=this.getDispatchService();if(dispatchService){this.dispatchHandle=dispatchService.getHandle('n2.couchShow');};},getRequestService:function(){if(this.options.requestService){return this.options.requestService;};if(this.options.serviceDirectory&&this.options.serviceDirectory.requestService){return this.options.serviceDirectory.requestService;};return null;},getNotifierService:function(){if(this.options.notifierService){return this.options.notifierService;};if(this.options.serviceDirectory&&this.options.serviceDirectory.notifierService){return this.options.serviceDirectory.notifierService;};return null;},getDispatchService:function(){if(this.options.serviceDirectory&&this.options.serviceDirectory.dispatchService){return this.options.serviceDirectory.dispatchService;};return null;},getSchemaRepository:function(){if(this.options.schemaRepository){return this.options.schemaRepository;};if(this.options.serviceDirectory&&this.options.serviceDirectory.schemaRepository){return this.options.serviceDirectory.schemaRepository;};return null;},fixElementAndChildren:function($elem,opt,contextDoc){this.domStyler.fixElementAndChildren($elem,opt,contextDoc);},displayBriefDescription:function($elem,opt,doc){var _this=this;var schema=null;if(doc&&doc._id){$elem.addClass('n2ShowUpdateDoc_'+$n2.utils.stringToHtmlId(doc._id));$elem.addClass('n2ShowDocBrief');};this._displayDocumentBrief($elem,doc);},displayDocument:function($elem,opt,doc){var _this=this;var schema=null;if(doc&&doc._id){$elem.addClass('n2ShowUpdateDoc_'+$n2.utils.stringToHtmlId(doc._id));};this._displayDocumentFull($elem,doc,opt);},printUserName:function($elem,userName,opts){$elem.addClass('n2ShowUser_'+$n2.utils.stringToHtmlId(userName));if(opts.showHandle){$elem.addClass('n2ShowUserDisplayAndHandle');}else{$elem.addClass('n2ShowUserDisplay');};$elem.text('('+userName+')');this._requestUser(userName);},printBriefDescription:function($elem,docId,opts){$elem.addClass('n2ShowDoc_'+$n2.utils.stringToHtmlId(docId));$elem.addClass('n2ShowDocBrief');$elem.text(docId);this._requestDocument(docId);},printDocument:function($elem,docId,opts_){var opts=$n2.extend({eliminateNonApprovedMedia:false,eliminateDeniedMedia:false},opts_);$elem.addClass('n2ShowDoc_'+$n2.utils.stringToHtmlId(docId));if(opts.eliminateNonApprovedMedia){$elem.addClass('n2NoShowNonApprovedMedia');};if(opts.eliminateDeniedMedia){$elem.addClass('n2NoShowDenied');};$elem.text(docId);this._requestDocument(docId);},_displayUserDocument:function(userDoc){var id=userDoc._id;var displayName=userDoc.display;var userName=null;if(id.substr(0,couchUserPrefix.length)===couchUserPrefix){userName=id.substr(couchUserPrefix.length);};if(userName){$('.n2ShowUser_'+$n2.utils.stringToHtmlId(userName)).each(function(i,elem){var $elem=$(elem);if($elem.hasClass('n2ShowUserDisplay')){if(displayName){$elem.text(displayName);};}else if($elem.hasClass('n2ShowUserDisplayAndHandle')){if(displayName&&userName){$elem.text(displayName+' ('+userName+')');};}else{if(displayName){$elem.text(displayName);};};});};},_displayDocument:function(doc){var _this=this;var id=doc._id;var showClass='n2ShowDoc_'+$n2.utils.stringToHtmlId(id);$('.'+showClass).each(function(i,elem){var $elem=$(elem);$elem.removeClass(showClass).addClass('n2ShowUpdateDoc_'+$n2.utils.stringToHtmlId(id));if(_this.options.eliminateNonApprovedMedia){if($n2.couchMap.documentContainsMedia(doc)&&false==$n2.couchMap.documentContainsApprovedMedia(doc)){$elem.empty();return;};}else if(_this.options.eliminateDeniedMedia){if($n2.couchMap.documentContainsMedia(doc)&&true==$n2.couchMap.documentContainsDeniedMedia(doc)){$elem.empty();return;};};if($elem.hasClass('n2ShowDocBrief')){_this._displayDocumentBrief($elem,doc);return;};_this._displayDocumentFull($elem,doc);});},_updateDocument:function(doc){var _this=this;var id=doc._id;var updateClass='n2ShowUpdateDoc_'+$n2.utils.stringToHtmlId(id);$('.'+updateClass).each(function(i,elem){var $elem=$(elem);if($elem.hasClass('n2ShowDocBrief')){_this._displayDocumentBrief($elem,doc);return;};_this._displayDocumentFull($elem,doc);});},_displayDocumentBrief:function($elem,doc){var _this=this;var schema=null;doc=this.options.preprocessDocument(doc);if(doc.nunaliit_schema){_this.getSchemaRepository().getSchema({name:doc.nunaliit_schema,onSuccess:function(schema_){schema=schema_;printBrief();},onError:function(){schema=_this.options.defaultSchema;printBrief();}});}else if(_this.options.defaultSchema){schema=_this.options.defaultSchema;printBrief();};function printBrief(){if(schema){schema.brief(doc,$elem);_this.fixElementAndChildren($elem,{},doc);};};},_displayDocumentFull:function($elem,doc,opt_){var opt=$n2.extend({onDisplayed:function($elem,doc,opt_){}},opt_);var _this=this;doc=this.options.preprocessDocument(doc);if(doc.nunaliit_schema){_this.getSchemaRepository().getSchema({name:doc.nunaliit_schema,onSuccess:function(schema){displaySchema($elem,schema);},onError:function(){displayError($elem);}});}else if(_this.options.defaultSchema){displaySchema($elem,_this.options.defaultSchema);}else{displayError($elem);};function displaySchema($elem,schema){schema.display(doc,$elem);_this.fixElementAndChildren($elem,{},doc);opt.onDisplayed($elem,doc,schema,opt_);};function displayError($elem){$elem.text(_loc('Unable to display document'));};},_requestUser:function(userName){var requestService=this.getRequestService();if(requestService){requestService.requestUser(userName);};},_requestDocument:function(docId,cbFn){var requestService=this.getRequestService();if(requestService){requestService.requestDocument(docId,cbFn);};},_notifierUpdate:function(change){var _this=this;var updatedDocIds={};var deletedDocIds={};if(change&&change.results&&change.results.length){for(var i=0,e=change.results.length;i<e;++i){var docId=change.results[i].id;var isDeleted=false;if(change.results[i].deleted){isDeleted=true;};if(isDeleted){deletedDocIds[docId]=true;if(updatedDocIds[docId]){delete updatedDocIds[docId];};}else{updatedDocIds[docId]=true;};};};for(var docId in deletedDocIds){var escaped=$n2.utils.stringToHtmlId(docId);$('.n2ShowDoc_'+escaped).remove();$('.n2ShowUpdateDoc_'+escaped).remove();};var requestDocIds=[];for(var docId in updatedDocIds){var $elems=$('.n2ShowUpdateDoc_'+$n2.utils.stringToHtmlId(docId));if($elems.length>0){requestDocIds.push(docId);};};for(var i=0,e=requestDocIds.length;i<e;++i){this._requestDocument(requestDocIds[i],function(doc){_this._updateDocument(doc);});};}});$n2.couchShow={Show:Show};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str){return $n2.loc(str,'nunaliit2-couch');};function getDefaultCouchProjection(){var defaultCouchProj=null;if(typeof(OpenLayers)!=='undefined'&&OpenLayers.Projection){defaultCouchProj=new OpenLayers.Projection('EPSG:4326');};return defaultCouchProj;};function isKeyEditingAllowed(obj,selectors,data){if(!selectors)return false;if(selectors[0]==='_id')return false;if(selectors[0]==='_rev')return false;return true;}
function isValueEditingAllowed(obj,selectors,data){if(!selectors)return false;if(selectors[0]==='_id')return false;if(selectors[0]==='_rev')return false;return true;}
function isKeyDeletionAllowed(obj,selectors,data){if(!selectors)return false;if(selectors[0]==='_id')return false;if(selectors[0]==='_rev')return false;return true;}
var CouchDocumentEditorDefaultOptions={panelName:'side',initialLayers:['public'],selectAudioFn:function(feature_,cbFn){alert('Feature not supported');},onFeatureInsertedFn:function(fid,feature){},onFeatureUpdatedFn:function(fid,feature){},onFeatureDeletedFn:function(fid,feature){},onCancelFn:function(feature){},onCloseFn:function(){}};var CouchDocumentEditor=$n2.Class({options:null,treeEditor:null,slideEditor:null,editedDocument:null,editedFeature:null,editedLayer:null,originalData:null,originalGeometry:null,originalStyle:null,currentGeometryWkt:null,editorContainerId:null,isInsert:null,modifyFeatureControl:null,mapControls:null,featureModifiedCallback:null,userButtons:null,initialize:function(parentOptions_,ownOptions_){this.options=$n2.extend({},CouchDocumentEditorDefaultOptions,parentOptions_,ownOptions_);this.userButtons=[];var label='button';for(var key in this.options){if(key.substr(0,label.length)===label){this.userButtons.push(this.options[key]);};};},_getUploadService:function(){if(this.options.serviceDirectory&&this.options.serviceDirectory.uploadService){return this.options.serviceDirectory.uploadService;};return null;},_getSearchService:function(){if(this.options.serviceDirectory&&this.options.serviceDirectory.searchService){return this.options.serviceDirectory.searchService;};return null;},_getShowService:function(){if(this.options.serviceDirectory&&this.options.serviceDirectory.showService){return this.options.serviceDirectory.showService;};return null;},_getSchemaEditorService:function(){if(this.options.serviceDirectory&&this.options.serviceDirectory.schemaEditorService){return this.options.serviceDirectory.schemaEditorService;};return null;},_getSchemaRepository:function(){if(this.options.serviceDirectory&&this.options.serviceDirectory.schemaRepository){return this.options.serviceDirectory.schemaRepository;};return null;},startFeatureEditing:function(feature_,modifyFeatureControl_,mapControls_){var _this=this;this.featureModifiedCallback=function(evt){_this.featureModified(evt);}
this.modifyFeatureControl=modifyFeatureControl_;this.mapControls=mapControls_;this.editedFeature=feature_;this.editedDocument=feature_.data;this.editedLayer=this.editedFeature.layer;this.originalGeometry=this.editedFeature.geometry.clone();this.originalStyle=this.editedFeature.style;this.originalData=$.extend(true,{},this.editedFeature.data);this.currentGeometryWkt=null;if(this.editedDocument&&this.editedDocument[this.options.geomName]){this.currentGeometryWkt=this.editedDocument[this.options.geomName].wkt;};this.editedLayer.events.register('featuremodified',this.editedFeature,this.featureModifiedCallback);this.isInsert=(typeof(this.editedFeature.fid)==='undefined'||this.editedFeature.fid===null);if(this.isInsert){var geom=this.convertFeatureGeometryForDb(this.editedFeature);var g=$n2.couchGeom.getCouchGeometry(geom);this.editedDocument[this.options.geomName]=g;if(this.options.initialLayers&&this.options.initialLayers.length>0){this.editedDocument.nunaliit_layers=this.options.initialLayers;};};this._selectSchema(schemaSelected);function schemaSelected(schema){if(_this.isInsert){if(schema){var template=schema.createObject({});$n2.extend(true,_this.editedDocument,template);};var geom=_this.convertFeatureGeometryForDb(_this.editedFeature);var g=$n2.couchGeom.getCouchGeometry(geom);_this.editedDocument[_this.options.geomName]=g;if(_this.options.initialLayers&&_this.options.initialLayers.length>0){_this.editedDocument.nunaliit_layers=_this.options.initialLayers;};};_this._displayEditor(schema);};},startDocumentEditing:function(doc_){var _this=this;this.editedDocument=doc_;this.isInsert=(typeof(this.editedDocument._id)==='undefined'||this.editedDocument._id===null);this._selectSchema(schemaSelected);function schemaSelected(schema){if(_this.isInsert){if(schema){var template=schema.createObject({});$n2.extend(true,_this.editedDocument,template);};};_this._displayEditor(schema);};},_selectSchema:function(callbackFn){var _this=this;if(this.editedDocument.nunaliit_schema){this._getSchemaRepository().getSchema({name:this.editedDocument.nunaliit_schema,onSuccess:function(schema){callbackFn(schema);},onError:function(err){$n2.log('Error fetching schema: '+_this.editedDocument.nunaliit_schema,err);callbackFn(null);}});}else if(this.options.schema&&this.isInsert){if($n2.CouchEditor.Constants.ALL_SCHEMAS===this.options.schema){this._getSchemaRepository().getRootSchemas({onSuccess:function(schemas){selectFromSchemas(schemas);},onError:function(err){$n2.log('Error fetching root schemas',err);callbackFn(null);}});}else if($n2.isArray(this.options.schema)){selectFromSchemas(this.options.schema);}else{callbackFn(this.options.schema);};}else if(this.options.defaultEditSchema&&!this.isInsert){callbackFn(this.options.defaultEditSchema);}else{callbackFn(null);};function selectFromSchemas(schemas){if(schemas.length<1){callbackFn(null);return;}else if(schemas.length==1){callbackFn(schemas[0]);return;};var dialogId=$n2.getUniqueId();var selectId=$n2.getUniqueId();var $dialog=$('<div id="'+dialogId+'" class="editorSelectSchemaDialog">'
+'<label for="'+selectId+'">'+_loc('Select a schema:')+'</label>'
+'<select id="'+selectId+'"></select>'
+'<div><button>'+_loc('OK')+'</button><button>'+_loc('Cancel')+'</button></div>'
+'</div>');var $select=$dialog.find('select');for(var i=0,e=schemas.length;i<e;++i){$select.append($('<option>'+schemas[i].name+'</option>'));}
$dialog.find('button').first().button({icons:{primary:'ui-icon-check'}}).click(function(){var $dialog=$('#'+dialogId);var $select=$dialog.find('select');var schemaName=$select.val();$n2.log('schemaName',schemaName);_this._getSchemaRepository().getSchema({name:schemaName,onSuccess:function(schema){callbackFn(schema);},onError:function(err){reportError('Unable to get selected schema: '+err);_this.cancelEditing();}});$dialog.dialog('close');return false;}).next().button({icons:{primary:'ui-icon-cancel'}}).click(function(){var $dialog=$('#'+dialogId);$dialog.dialog('close');_this.cancelEditing();return false;});var dialogOptions={autoOpen:true,title:_loc('Select Document Schema'),modal:true,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};$dialog.dialog(dialogOptions);};},_displayEditor:function(selectedSchema){var _this=this;var attributeForm=null;var data=this.editedDocument;if($n2.couchMap&&$n2.couchMap.adjustDocument){$n2.couchMap.adjustDocument(data);};var attributeDialog=$('#'+this.options.panelName);attributeDialog.empty();this.editorContainerId=$n2.getUniqueId();var $editorContainer=$('<div id="'+this.editorContainerId+'" class="n2CouchEditor_container"></div>');attributeDialog.append($editorContainer);var schemaEditorService=this._getSchemaEditorService();if(selectedSchema&&schemaEditorService){$n2.schema.GlobalAttributes.disableKeyUpEvents=true;var $schemaHeader=$('<h3><a href="#">'+_loc('Form View')+'</a></h3>');var $schemaContainer=$('<div class="n2CouchEditor_schema"></div>');$editorContainer.append($schemaHeader).append($schemaContainer);this.schemaEditor=schemaEditorService.editDocument({doc:data,schema:selectedSchema,$div:$schemaContainer,onChanged:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.treeEditor){_this.treeEditor.refresh();};if(_this.slideEditor){_this.slideEditor.refresh();};_this.onEditorObjectChanged(data);}});};var $treeHeader=$('<h3><a href="#">'+_loc('Tree View')+'</a></h3>');var $treeContainer=$('<div class="n2CouchEditor_tree"></div>');$editorContainer.append($treeHeader).append($treeContainer);var editorOptions={onObjectChanged:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.slideEditor){_this.slideEditor.refresh();};if(_this.schemaEditor){_this.schemaEditor.refresh();};_this.onEditorObjectChanged(data);},isKeyEditingAllowed:isKeyEditingAllowed,isValueEditingAllowed:isValueEditingAllowed,isKeyDeletionAllowed:isKeyDeletionAllowed};var objectTree=new $n2.tree.ObjectTree($treeContainer,data,editorOptions);this.treeEditor=new $n2.tree.ObjectTreeEditor(objectTree,data,editorOptions);var $slideHeader=$('<h3><a href="#">'+_loc('Editor View')+'</a></h3>');var $slideContainer=$('<div class="n2CouchEditor_slide"></div>');$editorContainer.append($slideHeader).append($slideContainer);var slideEditorOptions={onObjectChanged:function(){_this._adjustInternalValues(_this.editedDocument);if(_this.treeEditor){_this.treeEditor.refresh();};if(_this.schemaEditor){_this.schemaEditor.refresh();};_this.onEditorObjectChanged(data);},isKeyEditingAllowed:isKeyEditingAllowed,isValueEditingAllowed:isValueEditingAllowed,isKeyDeletionAllowed:isKeyDeletionAllowed};this.slideEditor=new $n2.slideEditor.Editor($slideContainer,data,slideEditorOptions);$editorContainer.accordion({collapsible:true});if(null!=this._getUploadService()){$editorContainer.append($('<div class="editorAttachFile"></div>'));};var formButtons=$('<div class="editorButtons"></div>');$editorContainer.append(formButtons);var saveBtn=$('<button class="save">'+_loc('Save')+'</button>');formButtons.append(saveBtn);saveBtn.button({icons:{primary:'ui-icon-check'}});saveBtn.click(save);if(!this.isInsert&&$n2.couchMap.canDeleteDoc(data)){var deleteBtn=$('<button class="delete">'+_loc('Delete')+'</button>');formButtons.append(deleteBtn);deleteBtn.button({icons:{primary:'ui-icon-trash'}});deleteBtn.click(function(evt){if(confirm(_loc('Do you really want to delete this feature?'))){deletion(data);};return false;});};if(null!=this._getUploadService()){var attachBtn=$('<button class="file">'+_loc('Add File')+'</button>');formButtons.append(attachBtn);attachBtn.button({icons:{primary:'ui-icon-plusthick'}});attachBtn.click(function(){_this._addFile();return false;});};var cancelBtn=$('<button class="cancel">'+_loc('Cancel')+'</button>');formButtons.append(cancelBtn);cancelBtn.button({icons:{primary:'ui-icon-cancel'}});cancelBtn.click(function(){_this.cancelEditing();return false;});for(var i=0,e=this.userButtons.length;i<e;++i){var userButton=this.userButtons[i];var $uBtn=$('<button>'+_loc(''+userButton.label)+'</button>');if(userButton.buttonClass){$uBtn.addClass(userButton.buttonClass);};if(userButton.before){var $anchor=formButtons.find('button.'+userButton.before);$anchor.before($uBtn);}else if(userButton.after){var $anchor=formButtons.find('button.'+userButton.after);$anchor.after($uBtn);}else{formButtons.append($uBtn);};$uBtn.button(userButton.options);installUserButtonClick($uBtn,userButton);};function save(){if(null!=_this._getUploadService()){var uploadForms=[];var $editorContainer=$('#'+_this.editorContainerId);$editorContainer.find('.editorAddFileForm').each(function(i,elem){uploadForms.push(elem);});_this._disableControls();_this._getUploadService().getWelcome({onSuccess:function(){save2(uploadForms);},onError:function(err){_this._enableControls();$n2.reportError('Server is not available: '+err);}});}else{save2([]);};return false;};function save2(uploadForms){if(_this.isInsert){_this.options.db.createDocument({data:_this.editedDocument,onSuccess:function(docInfo){_this.editedDocument._id=docInfo.id;_this.editedDocument._rev=docInfo.rev;save3(uploadForms,_this.editedDocument,true);},onError:function(err){_this._enableControls();$n2.reportError('Unable to submit document: '+err);}});}else{_this.options.db.updateDocument({data:_this.editedDocument,onSuccess:function(docInfo){_this.editedDocument._rev=docInfo.rev;save3(uploadForms,_this.editedDocument,false);},onError:function(err){_this._enableControls();$n2.reportError('Unable to submit document: '+err);}});};};function save3(uploadForms,editedDocument,inserted){if(null==uploadForms||uploadForms.length<1){save4(editedDocument,inserted);}else{var $form=$(uploadForms.pop());$form.prepend($('<input type="hidden" name="id" value="'+editedDocument._id+'"/>'));$form.prepend($('<input type="hidden" name="rev" value="'+editedDocument._rev+'"/>'));_this._getUploadService().submitForm({form:$form,onSuccess:function(){save3(uploadForms,editedDocument,inserted);},onError:function(err){_this._enableControls();$n2.reportError('Error uploading file: '+err);}});};};function save4(editedDocument,inserted){var discardOpts={saved:true};if(inserted){_this.options.onFeatureInsertedFn(editedDocument._id,_this.editedFeature);discardOpts.inserted=true;}else{_this.options.onFeatureUpdatedFn(editedDocument._id,_this.editedFeature);discardOpts.updated=true;};_this._discardAttributeForm(discardOpts);};function deletion(editedDocument){_this.options.db.deleteDocument({data:_this.editedDocument,onSuccess:function(){_this.options.onFeatureDeletedFn(editedDocument._id,_this.editedFeature);_this._discardAttributeForm({deleted:true});_this._dispatch({type:'documentDeleted',docId:editedDocument._id});},onError:function(err){_this._enableControls();$n2.reportError('Unable to delete document: '+err);}});};function installUserButtonClick($uBtn,userButton){$uBtn.click(function(){if(userButton.click){return userButton.click(_this.editedDocument,_this,userButton);};return false;});};},cancelEditing:function(){if(null==this.editedDocument){return;};this.options.onCancelFn(this.editedFeature);if(this.editedFeature&&this.originalGeometry){if(this.editedFeature.layer){this.editedFeature.layer.eraseFeatures([this.editedFeature]);};this.editedFeature.geometry=this.originalGeometry;};if(this.editedFeature&&this.originalData){this.editedFeature.data=this.originalData;};this._dispatch({type:'editCancel',doc:this.editedDocument});this._discardAttributeForm({cancelled:true});},_discardAttributeForm:function(opts_){var opts=$n2.extend({saved:false,inserted:false,updated:false,deleted:false,cancelled:false},opts_);if(null==this.editedDocument){return;};var $editorContainer=this._getEditorContainer();$editorContainer.remove();if(null!=this.editedFeature){this.editedLayer.events.unregister('featuremodified',this.editedFeature,this.featureModifiedCallback);if(null!==this.editedFeature.layer&&false==this.isInsert){this.editedFeature.style=this.originalStyle;this.editedFeature.layer.drawFeature(this.editedFeature);};};this.options.onCloseFn(this.editedDocument,this);this._dispatch({type:'editClosed',doc:this.editedDocument,saved:opts.saved,inserted:opts.inserted,updated:opts.updated,deleted:opts.deleted,cancelled:opts.cancelled});this.editedDocument=null;this.editedFeature=null;this.editedLayer=null;this.originalGeometry=null;this.originalStyle=null;this.originalData=null;this.modifyFeatureControl=null;this.mapControls=null;this.editorContainerId=null;},refresh:function(){this._adjustInternalValues(this.editedDocument);if(this.treeEditor){this.treeEditor.refresh();};if(this.slideEditor){this.slideEditor.refresh();};if(this.schemaEditor){this.schemaEditor.refresh();};this.onEditorObjectChanged(this.editedDocument);},_adjustInternalValues:function(obj){if(typeof(OpenLayers)!=='undefined'){var geomData=obj[this.options.geomName];if(geomData){if(this.currentGeometryWkt!=geomData.wkt){$n2.couchGeom.adjustBboxOnCouchGeom(geomData);};};};},onEditorObjectChanged:function(obj){var geomData=obj[this.options.geomName];if(!geomData)return;if(typeof(OpenLayers)==='undefined')return;if(this.currentGeometryWkt!=geomData.wkt){this.currentGeometryWkt=geomData.wkt;var olGeom=$n2.couchGeom.getOpenLayersGeometry({couchGeom:geomData});if(this.editedFeature){var mapProj=this.editedFeature.layer.map.projection;if(mapProj.getCode()!=this.options.couchProj.getCode()){olGeom.transform(this.options.couchProj,mapProj);};};if(this.modifyFeatureControl&&this.editedFeature){this.modifyFeatureControl.unselectFeature(this.editedFeature);this.editedFeature.layer.eraseFeatures([this.editedFeature]);this.editedFeature.geometry=olGeom;this.editedFeature.layer.drawFeature(this.editedFeature);this.modifyFeatureControl.selectFeature(this.editedFeature);}else if(this.editedFeature){this.editedFeature.layer.eraseFeatures([this.editedFeature]);this.editedFeature.geometry=olGeom;this.editedFeature.layer.drawFeature(this.editedFeature);};};},convertFeatureGeometryForDb:function(feature){var mapProj=feature.layer.map.projection;if(mapProj.getCode()!=this.options.couchProj.getCode()){var geom=feature.geometry.clone();geom.transform(mapProj,this.options.couchProj);return geom;};return feature.geometry;},featureModified:function(evt_){var feature=evt_.feature;var geom=this.convertFeatureGeometryForDb(feature);var geomData=this.editedFeature.data[this.options.geomName];geomData.wkt=geom.toString();this.currentGeometryWkt=geomData.wkt;if(this.schemaEditor){this.schemaEditor.refresh();};if(this.treeEditor){this.treeEditor.refresh();};if(this.slideEditor){this.slideEditor.refresh();};},_addFile:function(){var _this=this;var $attachment=$('#'+_this.editorContainerId).find('.editorAttachFile');if($attachment.length>0){var addFileFormId=$n2.getUniqueId();var reportFileNameId=$n2.getUniqueId();var $addFileDialog=$('<div class="editorAddFileDialog"></div>');var $addFileForm=$('<form id="'+addFileFormId+'" class="editorAddFileForm"></form>');$addFileDialog.append($addFileForm);var $table=$('<table></table>');$addFileForm.append($table);var $deleteFormTr=$('<tr class="editorAddFileFormEditorLine"><td><button>'+_loc('Remove')+'</button></td><td id="'+reportFileNameId+'"></td></tr>');$table.append($deleteFormTr);$deleteFormTr.find('button').button({icons:{primary:'ui-icon-cancel'},text:false}).click(function(){$('#'+addFileFormId).remove();return false;});$table.append('<tr class="editorAddFileFormDialogLine"><td>'+_loc('Title')+':</td><td><input type="text" name="title"/></td></tr>');$table.append('<tr class="editorAddFileFormDialogLine"><td>'+_loc('Description')+':</td><td><textarea name="description"></textarea></td></tr>');var $fileRow=$('<tr class="editorAddFileFormDialogLine"><td>'+_loc('File')+':</td></tr>');var $fileTd=$('<td></td>');$fileRow.append($fileTd);var $fileInput=$('<input class="editorAddFileInput" type="file" name="media"/>');$fileTd.append($fileInput);$fileInput.change(function(){var $fileInput=$(this);var filename=$fileInput.val();$('#'+reportFileNameId).text(_loc('File')+': '+filename);});$table.append($fileRow);var $btnRow=$('<tr class="editorAddFileFormDialogLine"><td></td></tr>');$table.append($btnRow);var $btnTd=$('<td></td>');$btnRow.append($btnTd);var $addBtn=$('<button>'+_loc('Attach')+'</button>');$btnTd.append($addBtn);$addBtn.button({icons:{primary:'ui-icon-plusthick'}});$addBtn.click(function(){var $addFileForm=$('#'+addFileFormId);var $attachment=$('#'+_this.editorContainerId).find('.editorAttachFile');$attachment.append($addFileForm);$addFileDialog.dialog('close');return false;});var $cancelBtn=$('<button>'+_loc('Cancel')+'</button>');$btnTd.append($cancelBtn);$cancelBtn.button({icons:{primary:'ui-icon-cancel'}});$cancelBtn.click(function(){$addFileDialog.dialog('close');return false;});var addFileDialogOptions={autoOpen:true,title:_loc('Add File'),modal:true,width:740,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};$addFileDialog.dialog(addFileDialogOptions);};},_getEditorContainer:function(){var $editorContainer=$('#'+this.editorContainerId);return $editorContainer;},_disableControls:function(){var $editorContainer=this._getEditorContainer();$editorContainer.find('button').attr('disabled','disabled');$editorContainer.find('input:text').attr('disabled','disabled');$editorContainer.find('.editorAttachFile').find('input:text').removeAttr('disabled');},_enableControls:function(){var $editorContainer=this._getEditorContainer();$editorContainer.find('button').removeAttr('disabled');$editorContainer.find('input:text').removeAttr('disabled');},_getDispatchService:function(){var d=null;if(this.options&&this.options.serviceDirectory){d=this.options.serviceDirectory.dispatchService;};return d;},_dispatch:function(m){var dispatcher=this._getDispatchService();if(dispatcher){var h=dispatcher.getHandle('n2.couchEdit');dispatcher.send(h,m);};}});var CouchEditorDefaultOptions={db:null,geomName:'nunaliit_geom',couchProj:null,schema:null,defaultEditSchema:null,serviceDirectory:null};var CouchEditor=$n2.Class({options:null,isFormEditor:null,currentEditor:null,initialize:function(options_){this.options=$.extend({},CouchEditorDefaultOptions,options_);this.isFormEditor=true;if(!this.options.couchProj){this.options.couchProj=getDefaultCouchProjection();};},showAttributeForm:function(feature_,modifyFeatureControl_,mapControls_,editorOptions_){if(null!=this.currentEditor){this.currentEditor.cancelEditing();this.currentEditor=null;};this.currentEditor=new CouchDocumentEditor(this.options,editorOptions_);this.currentEditor.startFeatureEditing(feature_,modifyFeatureControl_,mapControls_);},showDocumentForm:function(document_,editorOptions_){if(null!=this.currentEditor){this.currentEditor.cancelEditing();this.currentEditor=null;};this.currentEditor=new CouchDocumentEditor(this.options,editorOptions_);this.currentEditor.startDocumentEditing(document_);},cancelAttributeForm:function(){this.cancelDocumentForm();},cancelDocumentForm:function(){if(null!=this.currentEditor){this.currentEditor.cancelEditing();this.currentEditor=null;};}});var SchemaEditor=$n2.Class({doc:null,schema:null,$div:null,onChanged:null,formEditor:null,postProcessFns:null,initialize:function(options_){var options=$.extend({doc:null,schema:null,$div:null,onChanged:null,funcMap:null,postProcessFns:null},options_);var _this=this;this.doc=options.doc;this.schema=options.schema;this.$div=options.$div;this.onChanged=options.onChanged;this.postProcessFns=options.postProcessFns;this.formEditor=this.schema.form(this.doc,this.$div,{},function(){_this.onChanged();},options.funcMap);this._performPostProcess();},refresh:function(){this.formEditor.refresh();this._performPostProcess();},_performPostProcess:function(){for(var i=0,e=this.postProcessFns.length;i<e;++i){var fn=this.postProcessFns[i];if(typeof(fn)==='function'){fn(this.doc,this.$div);};};}});var _defaultOnChanged=function(){};var SchemaEditorService=$n2.Class({serviceDirectory:null,funcMap:null,postProcessFunctions:null,initialize:function(options_){var options=$.extend({funcMap:{},postProcessFn:null,serviceDirectory:null},options_);var _this=this;this.serviceDirectory=options.serviceDirectory;this.postProcessFunctions=[];this.funcMap={};for(var key in options.funcMap){var fn=options.funcMap[key];if(typeof(fn)==='function'){this.funcMap[key]=fn;};};if(!this.funcMap['getDocumentId']){this.funcMap['getDocumentId']=function(cb,resetFn){_this._searchForDocumentId(cb,resetFn);};};if(options.postProcessFn){this.postProcessFunctions.push(options.postProcessFn);};},editDocument:function(opts_){var opts=$n2.extend({doc:null,schema:null,$div:null,onChanged:_defaultOnChanged},opts_);var editor=new SchemaEditor({doc:opts.doc,schema:opts.schema,$div:opts.$div,onChanged:opts.onChanged,funcMap:this.funcMap,postProcessFns:this.postProcessFunctions});return editor;},addFunctionMap:function(fnName,fn){if(typeof(fn)==='function'){this.funcMap[fnName]=fn;};},addPostProcessFunction:function(fn){if(typeof(fn)==='function'){this.postProcessFunctions.push(fn);};},_getSearchService:function(){if(this.serviceDirectory&&this.serviceDirectory.searchService){return this.serviceDirectory.searchService;};return null;},_getShowService:function(){if(this.serviceDirectory&&this.serviceDirectory.showService){return this.serviceDirectory.showService;};return null;},_searchForDocumentId:function(cb,resetFn){var _this=this;var shouldReset=true;var searchServer=this._getSearchService();var showService=this._getShowService();var dialogId=$n2.getUniqueId();var inputId=$n2.getUniqueId();var searchButtonId=$n2.getUniqueId();var displayId=$n2.getUniqueId();var $dialog=$('<div id="'+dialogId+'" class="editorSelectDocumentDialog">'
+'<div><label for="'+inputId+'">'+_loc('Search:')+'</label>'
+'<input id="'+inputId+'" type="text"/>'
+'<button id="'+searchButtonId+'">'+_loc('Search')+'</button></div>'
+'<div  class="editorSelectDocumentDialogResults" id="'+displayId+'"></div>'
+'<div><button class="cancel">'+_loc('Cancel')+'</button></div>'
+'</div>');$dialog.find('button.cancel').button({icons:{primary:'ui-icon-cancel'}}).click(function(){var $dialog=$('#'+dialogId);$dialog.dialog('close');return false;});var dialogOptions={autoOpen:true,title:_loc('Select Document'),modal:true,width:370,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();if(shouldReset){if(typeof(resetFn)==='function'){resetFn();};};}};$dialog.dialog(dialogOptions);var searchInput=searchServer.installSearch({textInput:$('#'+inputId),searchButton:$('#'+searchButtonId),displayFn:displaySearch,onlyFinalResults:true});function displaySearch(displayData){if(!displayData){reportError('Invalid search results returned');}else if('wait'===displayData.type){$('#'+displayId).empty();}else if('results'===displayData.type){var $table=$('<table></table>');$('#'+displayId).empty().append($table);for(var i=0,e=displayData.list.length;i<e;++i){var docId=displayData.list[i].id;var $tr=$('<tr></tr>');$table.append($tr);$td=$('<td class="olkitSearchMod2_'+(i%2)+'">'
+'<a href="#'+docId+'" alt="'+docId+'"></a></td>');$tr.append($td);if(showService){showService.printBriefDescription($td.find('a'),docId);}else{$td.find('a').text(docId);};$td.find('a').click(createClickHandler(docId));};}else{reportError('Invalid search results returned');};};function createClickHandler(docId){return function(e){cb(docId);shouldReset=false;var $dialog=$('#'+dialogId);$dialog.dialog('close');return false;};};}});$n2.CouchEditor={Editor:CouchEditor,SchemaEditorService:SchemaEditorService,Constants:{ALL_SCHEMAS:{}}};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str){return $n2.loc(str,'nunaliit2-couch');};var CreateRelatedDocProcess=$n2.Class({options:null,initialize:function(options_){this.options=$n2.extend({db:null,schemaRepository:null,uploadService:null},options_);},addRelatedDocumentFromSchemaNames:function(opt_){var _this=this;if($.NUNALIIT_AUTH){if(false==$.NUNALIIT_AUTH.isLoggedIn()){$.NUNALIIT_AUTH.login({onSuccess:function(result,options){_this.addRelatedDocumentFromSchemaNames(opt_);}});return;};};var opt=$n2.extend({docId:null,relatedSchemaNames:[],onSuccess:function(docId){},onError:$n2.reportError,onCancel:function(){}},opt_);this.selectSchemaDialog({schemaNames:opt.relatedSchemaNames,onSuccess:selectedSchemaName,onError:opt.onError,onCancel:opt.onCancel});function selectedSchemaName(schemaName){_this.options.schemaRepository.getSchema({name:schemaName,onSuccess:selectedSchema,onError:function(err){opt.onError(_loc('Unable to fetch schema'));}});};function selectedSchema(schema){_this.addRelatedDocumentFromSchema({docId:opt.docId,schema:schema,onSuccess:opt.onSuccess,onError:opt.onError,onCancel:opt.onCancel});};},addRelatedDocumentFromSchema:function(opt_){var _this=this;if($.NUNALIIT_AUTH){if(false==$.NUNALIIT_AUTH.isLoggedIn()){$.NUNALIIT_AUTH.login({onSuccess:function(result,options){_this.addRelatedDocumentFromSchema(opt_);}});return;};};var opt=$n2.extend({docId:null,schema:null,onSuccess:function(docId){},onError:$n2.reportError,onCancel:function(){}},opt_);if(opt.schema&&opt.schema.isSchema){}else{opt.onError(_loc('A valid schema must be provided'));return;};this.options.uploadService.checkWelcome({onSuccess:uploadServiceAvailable,onError:function(err){alert(_loc('Upload service can not be reached. Unable to submit a related document.'));}});function uploadServiceAvailable(){var obj=opt.schema.createObject();obj.nunaliit_source={nunaliit_type:'reference',doc:opt.docId,category:'attachment'};new Editor({db:_this.options.db,uploadService:_this.options.uploadService,obj:obj,schema:opt.schema,onSuccess:opt.onSuccess,onError:opt.onError,onCancel:opt.onCancel});};},selectSchemaDialog:function(opt_){var opt=$n2.extend({schemaNames:[],onSuccess:function(schemaName){},onError:$n2.reportError,onCancel:function(){}},opt_);if(!opt.schemaNames.length){opt.onCancel();return;}
if(opt.schemaNames.length==1){opt.onSuccess(opt.schemaNames[0]);return;}
var diagId=$n2.getUniqueId();var $dialog=$('<div id="'+diagId+'"></div>');var $label=$('<span></span>');$label.text(_loc('Select schema')+': ');$dialog.append($label);var $select=$('<select></select>');$dialog.append($select);for(var i=0,e=opt.schemaNames.length;i<e;++i){var schemaName=opt.schemaNames[i];var $option=$('<option></option>');$option.text(schemaName);$select.append($option);};$dialog.append($('<br/>'));var $ok=$('<button></button>');$ok.text(_loc('OK'));$ok.button({icons:{primary:'ui-icon-check'}});$dialog.append($ok);$ok.click(function(){var $diag=$('#'+diagId);var schemaName=$diag.find('select').val();$diag.dialog('close');opt.onSuccess(schemaName);return false;});var $cancel=$('<button></button>');$cancel.text(_loc('Cancel'));$cancel.button({icons:{primary:'ui-icon-cancel'}});$dialog.append($cancel);$cancel.click(function(){$('#'+diagId).dialog('close');opt.onCancel();return false;});var dialogOptions={autoOpen:true,title:_loc('Select a schema'),modal:true,width:740,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};$dialog.dialog(dialogOptions);}});var Editor=$n2.Class({options:null,diagId:null,uploadFileFormId:null,uploadData:null,initialize:function(options_){this.options=$n2.extend({db:null,uploadService:null,obj:null,schema:null,onSuccess:function(docId){},onError:$n2.reportError,onCancel:function(){}},options_);var _this=this;var diagId=$n2.getUniqueId();this.diagId=diagId;var $dialog=$('<div id="'+diagId+'"></div>');var obj=this.options.obj;var schema=this.options.schema;var $form=$('<div></div>');$dialog.append($form);schema.form(obj,$form);var $fileElement=$('<div></div>');$dialog.append($fileElement);this._addFileElement($fileElement)
var $ok=$('<button></button>');$ok.text(_loc('OK'));$ok.button({icons:{primary:'ui-icon-check'}});$dialog.append($ok);$ok.click(function(){_this._clickOK();return false;});var $cancel=$('<button></button>');$cancel.text(_loc('Cancel'));$cancel.button({icons:{primary:'ui-icon-cancel'}});$dialog.append($cancel);$cancel.click(function(){_this._clickCancel();return false;});var dialogOptions={autoOpen:true,title:_loc('Fill Out Related Document'),modal:true,width:740,close:function(event,ui){var diag=$('#'+diagId);diag.remove();}};$dialog.dialog(dialogOptions);},_addFileElement:function($attachment){var _this=this;var obj=this.options.obj;if(!obj.nunaliit_attachments){return;};var formId=$n2.getUniqueId();this.uploadFileFormId=formId;var $form=$('<form id="'+formId+'"></form>');$attachment.append($form);var $fileInput=$('<input class="relatedDocFileInput" type="file" name="media"/>');$form.append($fileInput);$fileInput.change(function(){var $fileInput=$(this);});},_getUploadForm:function(){var formId=this.uploadFileFormId;if(!formId){return $('#_not_a_valid_id');}else{return $('#'+formId);}},_clickOK:function(){var _this=this;var obj=this.options.obj;var $uploadForm=this._getUploadForm();if($uploadForm.length<1){this._saveObj();}else{var compulsory=true;if(obj&&obj.nunaliit_attachments&&typeof(obj.nunaliit_attachments._compulsory)!=='undefined'){compulsory=obj.nunaliit_attachments._compulsory;};var $fileInput=$uploadForm.find('.relatedDocFileInput');var filename=$fileInput.val();if(compulsory&&(filename==null||''===filename)){alert('A file must be selected');}else{this._saveObj();};};},_clickCancel:function(){$('#'+this.diagId).dialog('close');this.options.onCancel();},_saveObj:function(){var _this=this;var obj=this.options.obj;$n2.couchMap.adjustDocument(obj);if(obj.nunaliit_attachments){this.uploadData=obj.nunaliit_attachments;delete obj.nunaliit_attachments;if(typeof(this.uploadData._compulsory)!=='undefined'){delete this.uploadData._compulsory;};};this.options.db.createDocument({data:obj,onSuccess:function(docInfo){_this._uploadFile(docInfo);},onError:function(err){_this.options.onError('Unable to reach database to submit document: '+err);}});},_uploadFile:function(docInfo){var _this=this;var formId=this.uploadFileFormId;if(!formId){done();}else{var $form=$('#'+formId);if($form.length<1){done();}else{var $fileInput=$form.find('.relatedDocFileInput');var filename=$fileInput.val();if(filename!==null&&''!==filename){$form.prepend($('<input type="hidden" name="id" value="'+docInfo.id+'"/>'));$form.prepend($('<input type="hidden" name="rev" value="'+docInfo.rev+'"/>'));if(this.uploadData&&this.uploadData.files){for(var fileName in this.uploadData.files){var file=this.uploadData.files[fileName];if(file&&file.data){for(var key in file.data){var value=file.data[key];var $hidden=$('<input type="hidden"/>')
$hidden.attr('name',key);$hidden.attr('value',value);$form.prepend($hidden);};};};};this.options.uploadService.submitForm({form:$form,onSuccess:done,onError:function(err){_this.options.onError('Error uploading file: '+err);}});}else{done();};};};function done(){_this._success(docInfo.id);};},_success:function(docId){$('#'+this.diagId).dialog('close');this.options.onSuccess(docId);}});$n2.couchRelatedDoc={CreateRelatedDocProcess:CreateRelatedDocProcess};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str){return $n2.loc(str,'nunaliit2-couch');};function docCreationTimeSort(lhs,rhs){var timeLhs=0;var timeRhs=0;if(lhs&&lhs.doc&&lhs.doc.nunaliit_created&&lhs.doc.nunaliit_created.time){timeLhs=lhs.doc.nunaliit_created.time;}
if(rhs&&rhs.doc&&rhs.doc.nunaliit_created&&rhs.doc.nunaliit_created.time){timeRhs=rhs.doc.nunaliit_created.time;}
if(timeLhs<timeRhs)return-1;if(timeLhs>timeRhs)return 1;return 0;};var defaultOptions={db:null,designDoc:null,displayPanelName:null,showService:null,editor:null,uploadService:null,serviceDirectory:null,postProcessDisplayFunction:null,displayRelatedInfoFunction:null,translateCallback:null,classDisplayFunctions:{}};$n2.couchDisplay=$n2.Class({options:null,mapAndControl:null,currentFeature:null,createRelatedDocProcess:null,requestService:null,defaultSchema:null,postProcessDisplayFns:null,dispatchHandle:null,initialize:function(options_){var _this=this;this.options=$n2.extend({},defaultOptions,options_);this.postProcessDisplayFns=[];if(typeof(this.options.postProcessDisplayFunction)==='function'){this.postProcessDisplayFns.push(this.options.postProcessDisplayFunction);};var dispatcher=this._getDispatcher();if(dispatcher){this.dispatchHandle=dispatcher.getHandle('n2.couchDisplay');var f=function(msg){_this._handleDispatch(msg);};dispatcher.register(this.dispatchHandle,'selected',f);dispatcher.register(this.dispatchHandle,'searchResults',f);dispatcher.register(this.dispatchHandle,'editClosed',f);dispatcher.register(this.dispatchHandle,'documentDeleted',f);};var requestService=this._getRequestService();if(requestService){requestService.addDocumentListener(function(doc){_this._receiveRequestedDocument(doc);});};if(!this.options.displayRelatedInfoFunction){this.options.displayRelatedInfoFunction=function(opts_){_this._displayRelatedInfo(opts_);}};this.createRelatedDocProcess=new $n2.couchRelatedDoc.CreateRelatedDocProcess({db:this.options.db,schemaRepository:$n2.schema.DefaultRepository,uploadService:this.options.uploadService});},shouldSuppressNonApprovedMedia:function(){return this._getShowService().options.eliminateNonApprovedMedia;},shouldSuppressDeniedMedia:function(){return this._getShowService().options.eliminateDeniedMedia;},setSchema:function(schema){this.defaultSchema=schema;},getDisplayDivName:function(){var divId=null;if(this.options.displayPanelName){divId=this.options.displayPanelName;}else if(this.mapAndControl){divId=this.mapAndControl.getSidePanelName();};return divId;},getDisplayDiv:function(){var divId=this.getDisplayDivName();return $('#'+divId);},_getShowService:function(){if(this.options.showService){return this.options.showService;};return this.options.serviceDirectory.showService;},_getRequestService:function(){return this.options.serviceDirectory.requestService;},addPostProcessDisplayFunction:function(fn){if(typeof(fn)==='function'){this.postProcessDisplayFns.push(fn);};},_getSchemaRepository:function(){var repository=null;if(this.options&&this.options.serviceDirectory){repository=this.options.serviceDirectory.schemaRepository;};return repository;},_displayObject:function($side,data,opt_){var _this=this;var opt=$n2.extend({onUpdated:function(){},onDeleted:function(){},suppressContributionReferences:false,showContributionReplyButton:false,showAddContributionButton:false,showRelatedContributions:false},opt_);var docId=data._id;var $elem=$('<div class="couchDisplay_'+$n2.utils.stringToHtmlId(docId)+'"></div>');$side.append($elem);var $sElem=$('<div class="n2s_handleHover"></div>');$elem.append($sElem);this._getShowService().displayDocument($sElem,{onDisplayed:onDisplayed},data);function onDisplayed($sElem,data,schema,opt_){$sElem.find('.n2s_referenceLink').each(function(){var $jq=$(this);_this._insertReferenceLink(data,$jq,opt);$jq.removeClass('n2s_referenceLink').addClass('n2s_insertedReferenceLink');});$sElem.find('.n2s_clickFindGeometryOnMap').each(function(){var $jq=$(this);_this._clickFindGeometryOnMap(data,$jq,opt);$jq.removeClass('n2s_clickFindGeometryOnMap');});$sElem.find('.n2s_clickAddContribution').each(function(){var $jq=$(this);_this._clickAddContribution(data,$jq,opt);$jq.removeClass('n2s_clickAddContribution');});$sElem.find('.n2s_clickEdit').each(function(){var $jq=$(this);_this._clickEdit(data,$jq,opt);$jq.removeClass('n2s_clickEdit');});$sElem.find('.n2s_clickDelete').each(function(){var $jq=$(this);_this._clickDelete(data,$jq,opt);$jq.removeClass('n2s_clickDelete');});$sElem.find('.n2s_clickAddLayerFromDefinition').each(function(){var $jq=$(this);_this._clickAddLayerFromDefinition(data,$jq,opt);$jq.removeClass('n2s_clickAddLayerFromDefinition');});if(_this.options.classDisplayFunctions){for(var className in _this.options.classDisplayFunctions){var fn=_this.options.classDisplayFunctions[className];var jqCallback=eachFunctionForClass(className,fn,data,opt);$sElem.find('.'+className).each(jqCallback);};};for(var i=0,e=_this.postProcessDisplayFns.length;i<e;++i){var fn=_this.postProcessDisplayFns[i];fn(data,$sElem);};_this._addButtons($elem,data,{schema:schema,related:true,geom:true,edit:true,'delete':true});var relatedInfoId=$n2.getUniqueId();var $div=$('<div id="'+relatedInfoId+'"></div>');$elem.append($div);_this.options.displayRelatedInfoFunction({divId:relatedInfoId,doc:data,schema:schema});};function eachFunctionForClass(className,fn,data,opt){return function(){var $jq=$(this);fn(data,$jq,opt);$jq.removeClass(className);};};},_addButtons:function($elem,data,opt_){var _this=this;var opt=$n2.extend({schema:null,focus:false,related:false,geom:false,edit:false,'delete':false},opt_);var $buttons=$('<div class="nunaliit_form_linkset"></div>');$elem.append($buttons);var firstButton=true;if(opt.focus&&data&&data._id){if(firstButton){firstButton=false;}else{$buttons.append($('<span>&nbsp;</span>'));};var $focusButton=$('<a href="#"></a>');var focusText=_loc('Focus');$focusButton.text(focusText);$buttons.append($focusButton);$focusButton.click(function(){_this.DisplayClickedDocument(data._id);return false;});addClasses($focusButton,focusText);};if(opt.edit&&$n2.couchMap.canEditDoc(data)){if(firstButton){firstButton=false;}else{$buttons.append($('<span>&nbsp;</span>'));};var $editButton=$('<a href="#"></a>');var editText=_loc('Edit');$editButton.text(editText);$buttons.append($editButton);$editButton.click(function(){_this.performDocumentEdit(data,opt);return false;});addClasses($editButton,editText);};if(opt['delete']&&$n2.couchMap.canDeleteDoc(data)){if(firstButton){firstButton=false;}else{$buttons.append($('<span>&nbsp;</span>'));};var $deleteButton=$('<a href="#"></a>');var deleteText=_loc('Delete');$deleteButton.text(deleteText);$buttons.append($deleteButton);$deleteButton.click(function(){_this.performDocumentDelete(data,opt);return false;});addClasses($deleteButton,deleteText);};if(opt.related&&opt.schema&&opt.schema.relatedSchemaNames&&opt.schema.relatedSchemaNames.length){if(firstButton){firstButton=false;}else{$buttons.append($('<span>&nbsp;</span>'));};var $addRelatedButton=$('<a href="#"></a>');var addRelatedText=_loc('Add Related');$addRelatedButton.text(addRelatedText);$buttons.append($addRelatedButton);$addRelatedButton.click(function(){_this.addRelatedDocument(data._id,opt.schema.relatedSchemaNames);return false;});addClasses($addRelatedButton,addRelatedText);};if(opt.geom&&data&&data.nunaliit_geom&&this.mapAndControl&&this.mapAndControl.centerMapOnFeatureId){if(firstButton){firstButton=false;}else{$buttons.append($('<span>&nbsp;</span>'));};var $findGeomButton=$('<a href="#"></a>');var findGeomText=_loc('Find on Map');$findGeomButton.text(findGeomText);$buttons.append($findGeomButton);var x=(data.nunaliit_geom.bbox[0]+data.nunaliit_geom.bbox[2])/2;var y=(data.nunaliit_geom.bbox[1]+data.nunaliit_geom.bbox[3])/2;$findGeomButton.click(function(){_this.mapAndControl.centerMapOnFeatureId({fid:data._id},x,y);return false;});addClasses($findGeomButton,findGeomText);};function addClasses(elem,tag){elem.addClass('nunaliit_form_link');var compactTag=tag;var spaceIndex=compactTag.indexOf(' ');while(-1!==spaceIndex){compactTag=compactTag.slice(0,spaceIndex)+'_'+
compactTag.slice(spaceIndex+1);spaceIndex=compactTag.indexOf(' ');};elem.addClass('nunaliit_form_link_'+compactTag.toLowerCase());};},_insertReferenceLink:function(data,$referenceLink,opt_){var _this=this;var refDocId=$referenceLink.text();$referenceLink.click(function(){var $div=_this.getDisplayDiv();_this.DisplayDocumentId($div,refDocId);return false;});if(_this._getShowService()){_this._getShowService().printBriefDescription($referenceLink,refDocId);};},_clickFindGeometryOnMap:function(data,$jq,opt_){var _this=this;if(data&&data.nunaliit_geom){var x=(data.nunaliit_geom.bbox[0]+data.nunaliit_geom.bbox[2])/2;var y=(data.nunaliit_geom.bbox[1]+data.nunaliit_geom.bbox[3])/2;$jq.click(function(){_this.mapAndControl.centerMapOnFeatureId({fid:data._id},x,y);return false;});}else{$jq.remove();};},_clickAddContribution:function(data,$jq,opt_){var _this=this;var referenceId=data._id;var contId=null;if(data.nunaliit_contribution&&data.nunaliit_contribution.nunaliit_type==='contribution'&&data.nunaliit_contribution.reference&&data.nunaliit_contribution.reference.doc){referenceId=data.nunaliit_contribution.reference.doc;contId=data._id;};$jq.click(function(){_this.performContributionReply(referenceId,opt_,contId);return false;});},_clickEdit:function(data,$jq,opt_){var _this=this;if($n2.couchMap.canEditDoc(data)){$jq.click(function(){_this.performDocumentEdit(data,opt_);return false;});}else{$jq.remove();};},_clickDelete:function(data,$jq,opt_){var _this=this;var referenceId=data._id;if($n2.couchMap.canDeleteDoc(data)){$jq.click(function(){_this.performDocumentDelete(data,opt_);return false;});}else{$jq.remove();};},_clickAddLayerFromDefinition:function(data,$jq,opt_){var _this=this;var layerDefinition=data.nunaliit_layer_definition;if(layerDefinition){$jq.click(function(){_this._addAndDisplayLayerFromDefinition(layerDefinition,opt_);return false;});}else{$jq.remove();};},_localize:function(data,$jq,opt_){var _this=this;var text=$jq.text();var locText=$n2.loc(text,'display');if(locText){$jq.text(locText);};},_addAndDisplayLayerFromDefinition:function(layerDefinition,opt_){var olLayer=this.mapAndControl.findLayerFromId(layerDefinition.id);if(!olLayer){this.mapAndControl.addLayer({id:layerDefinition.id,name:layerDefinition.name,couchDb:{viewName:'geom',layerName:layerDefinition.id,db:this.options.db,designDoc:this.options.designDoc}});olLayer=this.mapAndControl.findLayerFromId(layerDefinition.id);};if(olLayer){olLayer.setVisibility(true);};if(layerDefinition.bbox){var bounds=layerDefinition.bbox;this.mapAndControl.setNewExtent(bounds,'EPSG:4326');};},_displayBrief:function($elem,doc){var defaultSchema=this.defaultSchema;if(doc.nunaliit_schema){$n2.schema.DefaultRepository.getSchema({name:doc.nunaliit_schema,onSuccess:function(schema){schema.brief(doc,$elem);},onError:function(){if(defaultSchema){defaultSchema.brief(doc,$elem);}else{};}});}else if(defaultSchema){defaultSchema.brief(doc,$elem);}else{};},_displayRelatedInfo:function(opts_){var opts=$n2.extend({divId:null,doc:null,schema:null},opts_);var _this=this;var $elem=$('#'+opts.divId);var doc=opts.doc;var docId=doc._id;var schema=opts.schema;if(!schema){return;};if(schema.relatedSchemaNames&&schema.relatedSchemaNames.length){for(var i=0,e=schema.relatedSchemaNames.length;i<e;++i){var relatedSchemaName=schema.relatedSchemaNames[i];var contId=$n2.getUniqueId();var $div=$('<div id="'+contId+'"></div>');$elem.append($div);fetchRelatedDocuments(contId,relatedSchemaName,docId);};};function fetchRelatedDocuments(contId,relatedSchemaName,docId){_this.options.designDoc.queryView({viewName:'link-references-schemas',keys:[[docId,relatedSchemaName]],onSuccess:function(rows){var relatedDocIds=[];var seenDocIds={};for(var i=0,e=rows.length;i<e;++i){var id=rows[i].id;if(!seenDocIds[id]){seenDocIds[id]=true;relatedDocIds.push(id);};};_this._displayRelatedDocuments(contId,relatedSchemaName,relatedDocIds);}});}},_displayRelatedDocuments:function(contId,relatedSchemaName,relatedDocIds){var _this=this;var $container=$('#'+contId);if(!relatedDocIds||relatedDocIds.length<1){$container.remove();return;};blindDisplay();function blindDisplay(){var blindId=$n2.getUniqueId();var $blindWidget=$('<div id="'+blindId+'" class="_n2DocumentListParent"><h3></h3><div style="padding-left:0px;padding-right:0px;"></div></div>');$container.append($blindWidget);var bw=$n2.blindWidget($blindWidget,{data:relatedDocIds,onBeforeOpen:beforeOpen});bw.setHtml('<span class="_n2DisplaySchemaName"></span> (<span class="_n2DisplayDocCount"></span>)');$blindWidget.find('._n2DisplaySchemaName').text(relatedSchemaName);$blindWidget.find('._n2DisplayDocCount').text(''+relatedDocIds.length);var schemaRepository=_this._getSchemaRepository();if(schemaRepository){schemaRepository.getSchema({name:relatedSchemaName,onSuccess:function(schema){var $blindWidget=$('#'+blindId);$blindWidget.find('._n2DisplaySchemaName').text(schema.getLabel());}});};function beforeOpen(info){var $div=info.content;var $dataloaded=$div.find('.___n2DataLoaded');if($dataloaded.length>0){return;};var docIds=info.data;$div.empty();$div.append($('<div class="___n2DataLoaded" style="display:none;"></div>'));for(var i=0,e=docIds.length;i<e;++i){var docId=docIds[i];var $docWrapper=$('<div></div>');$div.append($docWrapper);if(0===i){$docWrapper.addClass('n2_search_startResults');};if((e-1)===i){$docWrapper.addClass('n2_search_endResults');};$docWrapper.addClass('_n2DocumentListEntry').addClass('_n2DocumentListEntry_'+$n2.utils.stringToHtmlId(docId)).addClass('olkitSearchMod2_'+(i%2)).addClass('n2SupressNonApprovedMedia_'+$n2.utils.stringToHtmlId(docId)).addClass('n2SupressDeniedMedia_'+$n2.utils.stringToHtmlId(docId));var $doc=$('<div></div>');$docWrapper.append($doc);if(_this._getShowService()){_this._getShowService().printDocument($doc,docId);}else{$doc.text(docId);};if(_this._getRequestService()){var $buttonDiv=$('<div class="displayRelatedButton displayRelatedButton_'+$n2.utils.stringToHtmlId(docId)+'"></div>');$docWrapper.append($buttonDiv);_this._getRequestService().requestDocument(docId);};};};};},addRelatedDocument:function(docId,relatedSchemaNames){var _this=this;this.createRelatedDocProcess.addRelatedDocumentFromSchemaNames({docId:docId,relatedSchemaNames:relatedSchemaNames,onSuccess:function(docId){_this.RefreshClickedFeature();}});},_receiveRequestedDocument:function(doc){var _this=this;var docId=doc._id;$('.displayRelatedButton_'+$n2.utils.stringToHtmlId(docId)).each(function(){var $buttonDiv=$(this);$buttonDiv.empty();_this._addButtons($buttonDiv,doc,{focus:true,geom:true});});if(this.shouldSuppressNonApprovedMedia()){if($n2.couchMap.documentContainsMedia(doc)&&false==$n2.couchMap.documentContainsApprovedMedia(doc)){$('.n2SupressNonApprovedMedia_'+$n2.utils.stringToHtmlId(docId)).each(function(){var $div=$(this);var $parent=$div.parent();$div.remove();_this._fixDocumentList($parent);});};}else if(this.shouldSuppressDeniedMedia()){if($n2.couchMap.documentContainsMedia(doc)&&$n2.couchMap.documentContainsDeniedMedia(doc)){$('.n2SupressDeniedMedia_'+$n2.utils.stringToHtmlId(docId)).each(function(){var $div=$(this);var $parent=$div.parent();$div.remove();_this._fixDocumentList($parent);});};};},_fixDocumentList:function($elem){if($elem.hasClass('_n2DocumentListParent')){var $relatedDiv=$elem;}else{$relatedDiv=$elem.parents('._n2DocumentListParent');};if($relatedDiv.length>0){var $docDiv=$relatedDiv.find('._n2DocumentListEntry');var count=$docDiv.length;$relatedDiv.find('._n2DisplayDocCount').text(''+count);$docDiv.each(function(i){var $doc=$(this);$doc.removeClass('olkitSearchMod2_0');$doc.removeClass('olkitSearchMod2_1');$doc.addClass('olkitSearchMod2_'+(i%2));});};},DisplayClickedDocument:function(docId){var _this=this;var displayDivName=this.getDisplayDivName();if(null!=docId&&null!=displayDivName){var $displayDiv=$('#'+displayDivName);$displayDiv.empty();$displayDiv.text('Document '+docId);this.currentFeature=null;this.options.db.getDocument({docId:docId,onSuccess:function(doc){if(doc.place&&doc.place.nunaliit_type&&doc.place.nunaliit_type==='placename'){_this.DisplayClickedMapFeature(doc,{displayDiv:displayDivName});}else{var $displayDiv=$('#'+displayDivName);$displayDiv.empty();if(null!==_this.options.translateCallback){var retVal=_this.options.translateCallback(doc,{displayDiv:displayDivName});if(null!==retVal){return;};};_this._displayObject($displayDiv,doc,{onUpdated:function(){_this.DisplayClickedDocument(docId)},onDeleted:function(){$displayDiv.empty();}});};}});};},DisplayClickedMapFeature:function(data,options){var _this=this;var $displayDiv=$('#'+options.displayDiv);$displayDiv.empty();if(null!==this.options.translateCallback){var retVal=this.options.translateCallback(data,options);if(null!==retVal){return;};};var displayObjectOptions={showAddContributionButton:true,showRelatedContributions:true,onUpdated:function(){_this.DisplayClickedMapFeature(data,options);},onDeleted:function(){$displayDiv.empty();}};this._displayObject($displayDiv,data,displayObjectOptions);},FeatureUpdated:function(feature){if(this.currentFeature&&feature&&this.currentFeature.fid&&feature.fid==this.currentFeature.fid&&this.currentFeature.feature&&this.currentFeature.options){this.currentFeature.feature=feature;this.RefreshClickedFeature();};},Configure:function(mapAndControl_){this.mapAndControl=mapAndControl_;},ClickedFeatureHandler:function(feature,options_){var _this=this;var options=$.extend({displayDiv:null},options_);if(null!=feature){this.currentFeature={fid:feature.fid,feature:feature,options:options};this.DisplayClickedMapFeature(feature.data,options);};},RefreshClickedFeature:function(){var fid=this.currentFeature?this.currentFeature.fid:null;var $elems=$('.couchDisplay_'+$n2.utils.stringToHtmlId(fid));if($elems.length>0&&this.currentFeature&&this.currentFeature.feature&&this.currentFeature.feature.data){this.DisplayClickedMapFeature(this.currentFeature.feature.data,this.currentFeature.options);};},reportContributions:function(data,options_,contId,contributions){var $div=$('#'+contId);if($div.length>0&&this.mapAndControl.contributions){$div.empty();var map={};for(var i=0,e=contributions.length;i<e;++i){var c=contributions[i];var docId=c._id;var replyTo=null;if(c.nunaliit_contribution&&c.nunaliit_contribution.reply&&c.nunaliit_contribution.reply.nunaliit_type&&c.nunaliit_contribution.reply.nunaliit_type==='reference'&&c.nunaliit_contribution.reply.doc){replyTo=c.nunaliit_contribution.reply.doc;};map[docId]={doc:c,replies:[],replyTo:replyTo};};for(var docId in map){var c=map[docId];if(c.replyTo){if(map[c.replyTo]){map[c.replyTo].replies.push(c);}else{c.replyTo=null;};}};var topContributions=[];for(var docId in map){var c=map[docId];if(null==c.replyTo){topContributions.push(c);};};topContributions.sort(docCreationTimeSort);for(var i=0,e=topContributions.length;i<e;++i){this.reportContribution(data,options_,$div,topContributions[i]);};};},reportContribution:function(data,options_,$elem,contributionObj){var _this=this;var $c=$('<div class="contributionReply"></div>');$elem.append($c);var contributionOptions=$n2.extend({},options_,{suppressContributionReferences:true,showContributionReplyButton:true,showRelatedContributions:false,onDeleted:options_.onUpdated});this._displayObject($c,contributionObj.doc,contributionOptions);if(contributionObj.replies.length>0){contributionObj.replies.sort(docCreationTimeSort);for(var i=0,e=contributionObj.replies.length;i<e;++i){var c=contributionObj.replies[i];this.reportContribution(data,options_,$c,c);};};},performContributionReply:function(referenceId,options_,contId){var _this=this;if($.NUNALIIT_AUTH){if(false==$.NUNALIIT_AUTH.isLoggedIn()){$.NUNALIIT_AUTH.login({onSuccess:function(result,options){_this.performContributionReply(referenceId,options_,contId);}});return;};};var $contributionDialog=$('<div></div>');this.mapAndControl.contributions.buildAddContributionForm({elem:$contributionDialog,referenceDocId:referenceId,replyContributionId:contId,onSuccess:function(){$contributionDialog.dialog('close');options_.onUpdated();},onCancel:function(){$contributionDialog.dialog('close');}});var dialogOptions={autoOpen:true,title:_loc('Add Contribution'),modal:true,width:740,close:function(event,ui){var diag=$(event.target);diag.dialog('destroy');diag.remove();}};$contributionDialog.dialog(dialogOptions);},performDocumentEdit:function(data,options_){var editing=false;if(this.mapAndControl){editing=this.mapAndControl.initiateFeatureEdit(data._id);};if(!editing&&this.options.editor&&this.options.editor.showDocumentForm){var panelName=this.getDisplayDivName();this.options.editor.showDocumentForm(data,{panelName:panelName});};},performDocumentDelete:function(data,options_){var _this=this;if(confirm(_loc('You are about to delete this document. Do you want to proceed?'))){this.options.db.deleteDocument({data:data,onSuccess:function(){if(_this.mapAndControl){_this.mapAndControl.removeFeature(data._id);};_this._dispatch({type:'documentDeleted',docId:data._id});if(options_.onDeleted){options_.onDeleted();};}});};},DisplayDocument:function($set,doc){var _this=this;this._displayObject($set,doc,{onUpdated:function(){_this.DisplayDocument($set,doc);},onDeleted:function(){$set.empty();}});},DisplayDocumentId:function($set,docId){var _this=this;$set.empty();this.options.db.getDocument({docId:docId,onSuccess:function(doc){_this.DisplayDocument($set,doc);},onError:function(err){$set.text(_loc('Unable to retrieve document'));}});},_handleDispatch:function(msg){if(msg.type==='selected'){if(msg.doc){var $div=this.getDisplayDiv();this.DisplayDocument($div,msg.doc);}else if(msg.docId){var $div=this.getDisplayDiv();this.DisplayDocumentId($div,msg.docId);}else if(msg.docs){var $div=this.getDisplayDiv();this.DisplayMultipleDocuments($div,msg.docs);}else if(msg.docIds){var $div=this.getDisplayDiv();this.DisplayMultipleDocumentIds($div,msg.docIds)};}else if(msg.type==='searchResults'){this._displaySearchResults(msg.results);}else if(msg.type==='editClosed'){var docId=msg.doc._id;var deleted=msg.deleted;if(!deleted){var $div=this.getDisplayDiv();this.DisplayDocumentId($div,docId);};}else if(msg.type==='documentDeleted'){var docId=msg.docId;this._handleDocumentDeletion(docId);};},DisplayMultipleDocuments:function($container,docs){var _this=this;var $list=$('<div class="_n2DocumentListParent"></div>');$container.append($list);for(var i=0,e=docs.length;i<e;++i){var doc=docs[i];var $div=$('<div></div>').addClass('_n2DocumentListEntry').addClass('_n2DocumentListEntry_'+$n2.utils.stringToHtmlId(docId)).addClass('olkitSearchMod2_'+(i%2)).addClass('n2SupressNonApprovedMedia_'+$n2.utils.stringToHtmlId(docId)).addClass('n2SupressDeniedMedia_'+$n2.utils.stringToHtmlId(docId));$list.append($div);var $contentDiv=$('<div class="n2s_handleHover"></div>');$div.append($contentDiv);this._getShowService().displayBriefDescription($contentDiv,{},doc);var $buttonDiv=$('<div></div>');$div.append($buttonDiv);this._addButtons($buttonDiv,doc,{focus:true,geom:true});};},DisplayMultipleDocumentIds:function($container,docIds){var _this=this;var $list=$('<div class="_n2DocumentListParent"></div>');$container.append($list);for(var i=0,e=docIds.length;i<e;++i){var docId=docIds[i];var $div=$('<div></div>').addClass('_n2DocumentListEntry').addClass('_n2DocumentListEntry_'+$n2.utils.stringToHtmlId(docId)).addClass('olkitSearchMod2_'+(i%2)).addClass('n2SupressNonApprovedMedia_'+$n2.utils.stringToHtmlId(docId)).addClass('n2SupressDeniedMedia_'+$n2.utils.stringToHtmlId(docId));$list.append($div);var $contentDiv=$('<div class="n2s_handleHover"></div>');$div.append($contentDiv);this._getShowService().printBriefDescription($contentDiv,docId);if(this._getRequestService()){var $buttonDiv=$('<div class="displayRelatedButton displayRelatedButton_'+$n2.utils.stringToHtmlId(docId)+'"></div>');$div.append($buttonDiv);this._getRequestService().requestDocument(docId);};};},_displaySearchResults:function(results){var ids=[];if(results&&results.sorted&&results.sorted.length){for(var i=0,e=results.sorted.length;i<e;++i){ids.push(results.sorted[i].id);};};var $div=this.getDisplayDiv();$div.empty();if(ids.length<1){$div.append($('<div>'+_loc('Search results empty')+'</div>'));}else{this.DisplayMultipleDocumentIds($div,ids)};},_getDispatcher:function(){var d=null;if(this.options.serviceDirectory&&this.options.serviceDirectory.dispatchService){d=this.options.serviceDirectory.dispatchService;};return d;},_dispatch:function(m){var dispatcher=this._getDispatcher();if(dispatcher){var h=dispatcher.getHandle('n2.couchDisplay');dispatcher.send(h,m);};},_handleDocumentDeletion:function(docId){var _this=this;var $elems=$('.couchDisplay_'+$n2.utils.stringToHtmlId(docId));$elems.remove();var $entries=$('._n2DocumentListEntry_'+$n2.utils.stringToHtmlId(docId));$entries.each(function(){var $entry=$(this);var $p=$entry.parent();$entry.remove();_this._fixDocumentList($p);});}});$.olkitDisplay=null;})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str){return $n2.loc(str,'nunaliit2-couch');};var reWordSplit=/[\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/;function SplitSearchTerms(line){if(!line)return null;line=line.toLowerCase();var temp=line.split(reWordSplit);var searchTerms=[];for(var i=0,e=temp.length;i<e;++i){var term=temp[i];if(null!==term&&''!==term&&' '!==term){searchTerms.push(term);};};return searchTerms;};var SearchRequest=$n2.Class({options:null,searchResults:null,initialize:function(searchTerms,opts_){this.options=$n2.extend({designDoc:null,db:null,searchView:'text-search',searchLimit:25,onlyFinalResults:false,strict:false,onSuccess:function(searchResults){},onError:function(err){$n2.reportErrorForced(err);}},opts_);if(typeof(searchTerms)==='string'){searchTerms=SplitSearchTerms(searchTerms);};this.searchResults={terms:[],pending:searchTerms.length,map:{},sorted:[],list:[]};if(!searchTerms.length){this._returnSearchResults();return;};for(var i=0,e=searchTerms.length;i<e;++i){var t=searchTerms[i].toLowerCase();this.searchResults.terms.push(t);};var _this=this;for(var i=0,e=this.searchResults.terms.length;i<e;++i){var term=this.searchResults.terms[i];this.options.designDoc.queryView({viewName:this.options.searchView,startkey:[term,0],endkey:[term,{}],onSuccess:function(rows){_this._receiveSearchResults(rows);},onError:function(err){_this.searchResults=null;_this.options.onError(err);}});};},abortSearch:function(){this.searchResults=null;},_receiveSearchResults:function(rows){var searchResults=this.searchResults;if(!searchResults)return;--searchResults.pending;var termsReceived=searchResults.terms.length-searchResults.pending;if(this.options.strict&&termsReceived>1){for(var i=0,e=rows.length;i<e;++i){var docId=rows[i].id;var index=rows[i].key[1];if(searchResults.map[docId]){var m=searchResults.map[docId];++m.terms;if(m.index>index)m.index=index;}else{};};var docIdsToDelete=[];for(var docId in searchResults.map){if(searchResults.map[docId].terms<termsReceived){docIdsToDelete.push(docId);};};for(var i=0,e=docIdsToDelete.length;i<e;++i){delete searchResults.map[docIdsToDelete[i]];};searchResults.sorted=[];for(var docId in searchResults.map){searchResults.sorted.push(searchResults.map[docId]);};}else{for(var i=0,e=rows.length;i<e;++i){var docId=rows[i].id;var index=rows[i].key[1];if(searchResults.map[docId]){var m=searchResults.map[docId];++m.terms;if(m.index>index)m.index=index;}else{var m={id:docId,index:index,terms:1,contentRequested:false};searchResults.map[docId]=m;searchResults.sorted.push(m);};};};this._returnSearchResults();},_returnSearchResults:function(){var searchResults=this.searchResults;if(!searchResults)return;var _this=this;if(this.options.onlyFinalResults){if(searchResults.pending>0){return;};};searchResults.sorted.sort(function(a,b){if(a.terms>b.terms){return-1;}else if(a.terms<b.terms){return 1;}else{if(a.index<b.index){return-1;}else if(a.index>b.index){return 1;};};return 0;});if((searchResults.terms.length-searchResults.pending)<=1){searchResults.list=searchResults.sorted;}else{searchResults.list=[];if(searchResults.sorted.length>0){var termCount=searchResults.sorted[0].terms;for(var i=0,e=searchResults.sorted.length;i<e;++i){var r=searchResults.sorted[i];if(r.terms>=termCount){searchResults.list.push(r);};};};};this.options.onSuccess(searchResults);}});var LookAheadService=$n2.Class({options:null,lookAheadMap:null,lookAheadCounter:null,initialize:function(opts_){this.options=opts_;this.lookAheadMap={};this.lookAheadCounter=0;},queryPrefix:function(prefix,callback){var _this=this;var words=this._retrievePrefix(prefix);if(words){callback(prefix,words);return;};this.options.designDoc.queryView({viewName:this.options.lookAheadView,listName:this.options.lookAheadList,startkey:prefix,endkey:prefix+'\u9999',top:this.options.lookAheadLimit,group:true,onlyRows:false,reduce:true,onSuccess:function(response){var rows=response.rows;var words=[];for(var i=0,e=rows.length;i<e;++i){words.push(rows[i][0]);};_this._cachePrefix({prefix:prefix,words:words,full:response.all_rows});if(0==words.length){callback(prefix,null);}else{callback(prefix,words);};},onError:function(){callback(prefix,null);}});},queryTerms:function(terms,callback){if(null===terms||0==terms.length){callback(null);return;};var index=terms.length-1;while(index>=0){var lastTerm=terms[index];if(''===lastTerm){--index;}else{var previousWords=null;if(index>0){previousWords=terms.slice(0,index);};break;};};lastTerm=lastTerm.toLowerCase();if(!lastTerm){callback(null);return;};if(lastTerm.length<this.options.lookAheadPrefixMin){callback(null);return;};var previousWordsString='';if(previousWords){previousWordsString=previousWords.join(' ')+' ';};this.queryPrefix(lastTerm,function(prefix,words){if(null===words){callback(null);}else{var results=[];for(var i=0,e=words.length;i<e;++i){results.push(previousWordsString+words[i]);};callback(results);};});},_cachePrefix:function(prefixResult){this.lookAheadMap[prefixResult.prefix]=prefixResult;prefixResult.counter=this.lookAheadCounter;++(this.lookAheadCounter);var keysToDelete=[];var cachedMap=this.lookAheadMap;var limit=this.lookAheadCounter-this.options.lookAheadCacheSize;for(var key in cachedMap){if(cachedMap[key].counter<limit){keysToDelete.push(key);};};for(var i=0,e=keysToDelete.length;i<e;++i){delete cachedMap[keysToDelete[i]];};},_retrievePrefix:function(prefix){if(this.lookAheadMap[prefix]){return this.lookAheadMap[prefix].words;};var sub=prefix.substring(0,prefix.length-1);while(sub.length>=this.options.lookAheadPrefixMin){if(this.lookAheadMap[sub]&&this.lookAheadMap[sub].full){var cachedWords=this.lookAheadMap[sub].words;var words=[];for(var i=0,e=cachedWords.length;i<e;++i){var word=cachedWords[i];if(word.length>=prefix.length){if(word.substr(0,prefix.length)===prefix){words.push(word);};};};return words;};sub=sub.substring(0,sub.length-1);};return null;},getJqAutoCompleteSource:function(){var _this=this;return function(request,cb){_this._jqAutoComplete(request,cb);};},_jqAutoComplete:function(request,cb){var terms=SplitSearchTerms(request.term);var callback=cb;this.queryTerms(terms,callback);}});var SearchInput=$n2.Class({options:null,searchServer:null,textInputId:null,searchButtonId:null,keyPressedSinceLastSearch:null,dispatchHandle:null,initialize:function(opts_,server_){this.options=$n2.extend({textInput:null,searchButton:null,initialSearchText:null,displayDiv:null,displayFn:null,dispatchService:null},opts_);this.searchServer=server_;this.keyPressedSinceLastSearch=false;if(this.options.dispatchService){this.dispatchHandle=this.options.dispatchService.getHandle('n2.couchSearch');};var $textInput=this.options.textInput;var textInputId=$textInput.attr('id');if(!textInputId){textInputId=$n2.getUniqueId();$textInput.attr('id',textInputId);};this.textInputId=textInputId;this.options.textInput=null;if(this.options.searchButton){var $searchButton=this.options.searchButton;var searchButtonId=$searchButton.attr('id');if(!searchButtonId){searchButtonId=$n2.getUniqueId();$searchButton.attr('id',searchButtonId);};this.searchButtonId=searchButtonId;this.options.searchButton=null;};this._install();},getTextInput:function(){return $('#'+this.textInputId);},getSearchButton:function(){if(this.searchButtonId){return $('#'+this.searchButtonId);};return null;},performSearch:function(line,$textInput){var _this=this;if(!$textInput){$textInput=this.getTextInput();};if(!line){line=$textInput.val();}else if($textInput){$textInput.val(line);};var searchRequest=this.searchServer.submitRequest(line,{onSuccess:function(searchResults){_this._processSearchResults(searchResults);},onError:function(err){_this._processSearchError(err);}});this.keyPressedSinceLastSearch=false;this._displayWait();this._closeLookAhead($textInput);},_install:function(){var _this=this;var $textInput=this.getTextInput();if(this.options.initialSearchText){$textInput.val(this.options.initialSearchText);};if($textInput.autocomplete){$textInput.autocomplete({source:this._getJqAutoCompleteSource()});};$textInput.keydown(function(e){_this._keyDown(e);});$textInput.focus(function(e){_this._focus(e);});$textInput.blur(function(e){_this._blur(e);});var $searchButton=this.getSearchButton();if($searchButton){$searchButton.click(function(e){_this._clickSearch(e);});};},_focus:function(e){var $textInput=this.getTextInput();if(this.options.initialSearchText){var value=$textInput.val();if(this.options.initialSearchText===value){$textInput.val('');};};$textInput.select();},_blur:function(e){if(this.options.initialSearchText){var $textInput=this.getTextInput();var value=$textInput.val();if(''===value){$textInput.val(this.options.initialSearchText);};};},_keyDown:function(e){var charCode=null;if(null===e){e=window.event;};if(null!==e){if(e.keyCode){charCode=e.keyCode;};};this.keyPressedSinceLastSearch=true;if(13===charCode||null===charCode){var $textInput=this.getTextInput();var line=$textInput.val();if(line&&line.length>0){this._closeLookAhead($textInput);this.performSearch(line,$textInput);};};},_clickSearch:function(e){var $textInput=this.getTextInput();var line=$textInput.val();if(line&&line.length>0){this._closeLookAhead($textInput);this.performSearch(line,$textInput);};},_closeLookAhead:function($textInput){if(!$textInput){$textInput=this.getTextInput();};if($textInput.autocomplete){$textInput.autocomplete('close');};},_processSearchResults:function(searchResults){var _this=this;if(this.options.displayFn){searchResults.type='results';this.options.displayFn(searchResults);}else if(this.options.dispatchService){this.options.dispatchService.send(this.dispatchHandle,{type:'searchResults',results:searchResults});}else if(this.options.displayDiv){var $display=$('#'+this.options.displayDiv).empty();if(!searchResults)return;if(searchResults.sorted.length<1){$display.append($('<div>'+_loc('Search results empty')+'</div>'));}else{var docIds=[];for(var i=0,e=searchResults.sorted.length;i<e;++i){var docId=searchResults.list[i].id;if(docId){docIds.push(docId);var div=$('<div class="olkitSearchMod2_'+(i%2)
+' n2searchDocId_'+this._escapeForClass(docId)+'"></div>');div.text(docId);$display.append(div);};};this.searchServer.options.db.getDocuments({docIds:docIds,onSuccess:function(docs){for(var i=0,e=docs.length;i<e;++i){var doc=docs[i];if(doc){var $div=$('.n2searchDocId_'+_this._escapeForClass(doc._id));if($div.length>0){$div.empty();$.olkitDisplay.DisplayDocument($div,doc);};};};}});};};},_processSearchError:function(err){if(this.options.displayFn){var display={type:'error',error:err};this.options.displayFn(display);}else{var $display=$('#'+this.options.displayDiv).empty();$display.append($('<div>'+_loc('Search error:')+err+'</div>'));};},_displayWait:function(){if(this.options.displayFn){this.options.displayFn({type:'wait'});}else{var $displayDiv=$('#'+this.options.displayDiv).empty();$displayDiv.append($('<div class="olkit_wait"></div>'));};},_getJqAutoCompleteSource:function(){var _this=this;return function(request,cb){_this._jqAutoComplete(request,cb);};},_jqAutoComplete:function(request,cb){var _this=this;var lookAheadService=this.searchServer.getLookAheadService();lookAheadService._jqAutoComplete(request,function(res){if(_this.keyPressedSinceLastSearch){cb(res);}else{cb(null);};});},_escapeForClass:function(sel){var res=[];for(var i=0,e=sel.length;i<e;++i){var c=sel[i];if(c>='a'&&c<='z'){res.push(c);}
else if(c>='A'&&c<='Z'){res.push(c);}
else if(c>='0'&&c<='9'){res.push(c);}
else{var code=c.charCodeAt(0);var o0=(code&0x07)+0x30;var o1=((code>>3)&0x07)+0x30;var o2=((code>>6)&0x07)+0x30;res.push('_');res.push(String.fromCharCode(o2));res.push(String.fromCharCode(o1));res.push(String.fromCharCode(o0));};};return res.join('');}});var SearchServer=$n2.Class({options:null,lookAheadService:null,initialize:function(opts_){this.options=$n2.extend({designDoc:null,db:null,searchView:'text-search',searchLimit:25,lookAheadView:'text-lookahead',lookAheadList:'text-lookahead',lookAheadLimit:5,lookAheadPrefixMin:3,lookAheadCacheSize:10},opts_);this.lookAheadService=null;},getLookAheadService:function(){if(null===this.lookAheadService){this.lookAheadService=new LookAheadService(this.options);};return this.lookAheadService;},submitRequest:function(searchTerms,opts_){var requestOptions=$n2.extend({designDoc:this.options.designDoc,db:this.options.db,searchView:this.options.searchView,searchLimit:this.options.searchLimit},opts_);return new SearchRequest(searchTerms,requestOptions);},getJqAutoCompleteSource:function(){return this.getLookAheadService().getJqAutoCompleteSource();},installSearch:function(opts_){return new SearchInput(opts_,this);}});$.olkitSearchHandler=function(options_){var options=$.extend({displayDiv:null,displayFn:null,textInputDivName:null,lookAheadDivName:null,designDoc:null,db:null,initialSearchText:null,inputName:'_olkit_searchInput',searchView:'text-search',searchLimit:25,lookAheadView:'text-lookahead',lookAheadList:'text-lookahead',lookAheadLimit:5,lookAheadPrefixMin:3,lookAheadCacheSize:10},options_);var searchServer=new $n2.couchSearch.SearchServer({designDoc:options.designDoc,db:options.db,searchView:options.searchView,searchLimit:options.searchLimit,lookAheadView:options.lookAheadView,lookAheadList:options.lookAheadList,lookAheadLimit:options.lookAheadLimit,lookAheadPrefixMin:options.lookAheadPrefixMin,lookAheadCacheSize:options.lookAheadCacheSize});var input=$('<input id="'+options.inputName+'" type="text" class="search_panel_input"'+' value="'+options.initialSearchText+'"></input>');$("#"+options.textInputDivName).empty().append(input);searchServer.installSearch({textInput:input,searchButton:null,initialSearchText:options.initialSearchText,displayDiv:options.displayDiv,displayFn:options.displayFn});};$n2.couchSearch={SearchServer:SearchServer,SearchRequest:SearchRequest};})(jQuery,nunaliit2);if(!window.$n2){window.$n2=window.nunaliit2;};OpenLayers.Format.Couch=OpenLayers.Class(OpenLayers.Format,{initialize:function(options){OpenLayers.Format.prototype.initialize.apply(this,[options]);},read:function(docs){try{var results=[];for(var i=0,e=docs.length;i<e;++i){var doc=docs[i];var id=null;var geom=null;if(doc._id){id=doc._id;};if(doc.nunaliit_geom.wkt){geom=OpenLayers.Geometry.fromWKT(doc.nunaliit_geom.wkt);if(geom){if(!$n2.olUtils.isValidGeom(geom)){geom=null;};};if(!geom){$n2.log('Invalid WKT: '+doc.nunaliit_geom.wkt);};};if(id&&geom){var f=new OpenLayers.Feature.Vector(geom,doc);f.fid=id;results.push(f);}else{$n2.log('Invalid feature',doc);};};return results;}catch(e){$n2.log('Error during CouchDB format read',e);}
return null;},write:function(features){var result=[];for(var i=0,e=features.length;i<e;++i){var f=features[i];var data=f.data;if(null==data){data={};};if(f.fid){data._id=f.fid;};var geom=f.geometry;if(f.layer.projection&&f.layer.map.projection&&f.layer.projection.getCode()!=f.layer.map.projection.getCode()){geom=geom.clone();geom.transform(f.layer.map.projection,f.layer.projection);};if(!data.nunaliit_geom)data.nunaliit_geom={nunaliit_type:'geometry'};data.nunaliit_geom.wkt=geom.toString();var bbox=geom.getBounds();data.nunaliit_geom.bbox=[bbox.left,bbox.bottom,bbox.right,bbox.top];result.push(data);};return result;},CLASS_NAME:"OpenLayers.Format.Couch"});OpenLayers.Protocol.Couch=OpenLayers.Class(OpenLayers.Protocol,{db:null,designDoc:null,viewName:null,layerName:null,callback:null,scope:null,cache:null,notifications:null,wildcarded:false,initialize:function(options){options=options||{};if(!options.format){options.format=new OpenLayers.Format.Couch();};OpenLayers.Protocol.prototype.initialize.apply(this,arguments);},destroy:function(){OpenLayers.Protocol.prototype.destroy.apply(this);},read:function(options){var tt={init:(new Date()).getTime()};if(this.notifications&&this.notifications.readStart){this.notifications.readStart();};OpenLayers.Protocol.prototype.read.apply(this,arguments);options=OpenLayers.Util.applyDefaults(options,this.options);var resp=new OpenLayers.Protocol.Response({requestType:'read'});var _this=this;var viewQuery={viewName:options.viewName,onSuccess:function(rows){_this.handleReadGeomFids(resp,options,rows,tt);},onError:function(errorMsg){$n2.log(errorMsg);if(_this.notifications&&_this.notifications.readEnd){_this.notifications.readEnd();};}};var bounds=this.getBboxFromFilter(options.filter);var fids=this.getFidsFromFilter(options.filter);var layerName=('string'===typeof(options.layerName)?options.layerName:null);$n2.couchGeom.selectTileViewFomBounds(viewQuery,bounds,layerName,fids);tt.queryFidsStart=(new Date()).getTime();options.designDoc.queryView(viewQuery);return resp;},handleReadGeomFids:function(resp,options,rows,tt){var _this=this;tt.queryFidsEnd=(new Date()).getTime();tt.queryFidsCount=rows.length;var docIds=[];var docs=[];while(rows.length>0){var row=rows.pop();var docId=row.id;if(this.cache){var doc=this.cache.retrieve(docId);if(doc){docs.push(doc);}else{docIds.push(docId);};}else{docIds.push(docId);};};tt.queryDocsCount=0;if(docIds.length>0){tt.queryDocsStart=(new Date()).getTime();this.db.getDocuments({docIds:docIds,onSuccess:function(docs_){tt.queryDocsEnd=(new Date()).getTime();tt.queryDocsCount=docs_.length;for(var i=0,e=docs_.length;i<e;++i){docs.push(docs_[i]);};_this.handleRead(resp,options,docs,tt);},onError:function(errorMsg){$n2.log(errorMsg);if(_this.notifications&&_this.notifications.readEnd){_this.notifications.readEnd();};}});}else{this.handleRead(resp,options,docs,tt);};},handleRead:function(resp,options,docs,tt){var _this=this;if(options.callback){tt.read=(new Date()).getTime();resp.features=this.format.read(docs);tt.sort=(new Date()).getTime();$n2.olUtils.sortFeatures(resp.features);tt.cb=(new Date()).getTime();resp.code=OpenLayers.Protocol.Response.SUCCESS;options.callback.call(options.scope,resp);window.setTimeout(function(){tt.end=(new Date()).getTime();var renderMs=tt.end-tt.cb;var sortMs=tt.cb-tt.sort;var readMs=tt.sort-tt.read;var docsMs=0;if(tt.queryDocsEnd&&tt.queryDocsStart){docsMs=tt.queryDocsEnd-tt.queryDocsStart;};var fidsMs=tt.queryFidsEnd-tt.queryFidsStart;var initMs=tt.queryFidsStart-tt.init;var totalMs=tt.end-tt.init;$n2.log('init:'+initMs+'ms fids('+tt.queryFidsCount+'):'+fidsMs
+'ms docs('+tt.queryDocsCount+'):'+docsMs+'ms format:'+readMs
+'ms sort:'+sortMs+'ms render('+resp.features.length+'):'+renderMs
+'ms total:'+totalMs+'ms');if(_this.notifications&&_this.notifications.readEnd){_this.notifications.readEnd();};},0);};},create:function(features,options){options=OpenLayers.Util.applyDefaults(options,this.options);var documents=this.format.write(features);if(options.layerName){for(var i=0,e=documents.length;i<e;++i){var doc=documents[i];if(!doc.nunaliit_layers){doc.nunaliit_layers=[];};if(doc.nunaliit_layers.indexOf(options.layerName)<0){doc.nunaliit_layers.push(options.layerName);};};};var resp=new OpenLayers.Protocol.Response({reqFeatures:features,requestType:"create"});var _this=this;this.db.bulkDocuments(documents,{onSuccess:function(docIds){_this.handleCreate(resp,options,docIds);},onError:function(errorMsg){$n2.reportError(errorMsg);}});return resp;},handleCreate:function(resp,options,docIds){var features=resp.reqFeatures;var insertedFeatures=[];if(features.length!=docIds.length){$n2.reportError($n2.ERROR_NO_SUPRESS,'Invalid feature bulk create');}else{for(var i=0,e=docIds.length;i<e;++i){var f=features[i];var d=docIds[i];if(d.error){if(d.reason){$n2.reportError($n2.ERROR_NO_SUPRESS,d.error+' : '+d.reason);}else{$n2.reportError($n2.ERROR_NO_SUPRESS,d.error);};}else{f.fid=d.id;if(f.data){f.data._id=d.id;f.data._rev=d.rev;};if(f.attribute){f.attribute._id=d.id;f.attribute._rev=d.rev;};insertedFeatures.push(f);};};};if(options.callback&&insertedFeatures.length>0){resp.features=insertedFeatures;resp.code=OpenLayers.Protocol.Response.SUCCESS;options.callback.call(options.scope,resp);}},update:function(feature,options){options=options||{};options=OpenLayers.Util.applyDefaults(options,this.options);var documents=this.format.write([feature]);var resp=new OpenLayers.Protocol.Response({reqFeatures:feature,requestType:"update"});var _this=this;this.db.updateDocument({data:documents[0],onSuccess:function(docInfo){_this.handleUpdate(resp,options,docInfo);},onError:function(errorMsg){$n2.reportError(errorMsg);}});return resp;},handleUpdate:function(resp,options,docInfo){var feature=resp.reqFeatures;if(feature.data){feature.data._rev=docInfo.rev;};if(feature.attribute){feature.attribute._rev=docInfo.rev;};if(options.callback){resp.features=[feature];resp.code=OpenLayers.Protocol.Response.SUCCESS;options.callback.call(options.scope,resp);}},"delete":function(feature,options){options=options||{};options=OpenLayers.Util.applyDefaults(options,this.options);var resp=new OpenLayers.Protocol.Response({reqFeatures:feature,requestType:"delete"});var _this=this;this.db.deleteDocument({data:feature.data,onSuccess:function(docInfo){_this.handleDelete(resp,options,docInfo);},onError:function(errorMsg){$n2.reportError(errorMsg);}});return resp;},handleDelete:function(resp,options){if(options.callback){resp.code=OpenLayers.Protocol.Response.SUCCESS;options.callback.call(options.scope,resp);}},commit:function(features,options){options=OpenLayers.Util.applyDefaults(options,this.options);var resp=[],nResponses=0;var types={};types[OpenLayers.State.INSERT]=[];types[OpenLayers.State.UPDATE]=[];types[OpenLayers.State.DELETE]=[];var feature,list,requestFeatures=[];for(var i=0,len=features.length;i<len;++i){feature=features[i];list=types[feature.state];if(list){list.push(feature);requestFeatures.push(feature);}}
var nRequests=(types[OpenLayers.State.INSERT].length>0?1:0)+
types[OpenLayers.State.UPDATE].length+
types[OpenLayers.State.DELETE].length;var success=true;var finalResponse=new OpenLayers.Protocol.Response({reqFeatures:requestFeatures});function insertCallback(response){var len=response.features?response.features.length:0;var fids=new Array(len);for(var i=0;i<len;++i){fids[i]=response.features[i].fid;}
finalResponse.insertIds=fids;callback.apply(this,[response]);}
function callback(response){this.callUserCallback(response,options);success=success&&response.success();nResponses++;if(nResponses>=nRequests){if(options.callback){finalResponse.code=success?OpenLayers.Protocol.Response.SUCCESS:OpenLayers.Protocol.Response.FAILURE;options.callback.apply(options.scope,[finalResponse]);}}}
var queue=types[OpenLayers.State.INSERT];if(queue.length>0){resp.push(this.create(queue,OpenLayers.Util.applyDefaults({callback:insertCallback,scope:this},options.create)));}
queue=types[OpenLayers.State.UPDATE];for(var i=queue.length-1;i>=0;--i){resp.push(this.update(queue[i],OpenLayers.Util.applyDefaults({callback:callback,scope:this},options.update)));}
queue=types[OpenLayers.State.DELETE];for(var i=queue.length-1;i>=0;--i){resp.push(this["delete"](queue[i],OpenLayers.Util.applyDefaults({callback:callback,scope:this},options["delete"])));}
return resp;},abort:function(response){if(response){}},callUserCallback:function(resp,options){var opt=options[resp.requestType];if(opt&&opt.callback){opt.callback.call(opt.scope,resp);}},getBboxFromFilter:function(filter){if(!filter)return null;if(filter.type===OpenLayers.Filter.Spatial.BBOX){return[filter.value.left,filter.value.bottom,filter.value.right,filter.value.top]}
if(filter.filters){for(var i=0,e=filter.filters.length;i<e;++i){var bounds=this.getBboxFromFilter(filter.filters[i]);if(bounds)return bounds;}}
return null;},getFidsFromFilter:function(filter){if(!filter)return null;if(filter.CLASS_NAME==='OpenLayers.Filter.FeatureId'){return filter.fids;}
if(filter.filters){for(var i=0,e=filter.filters.length;i<e;++i){var fids=this.getFidsFromFilter(filter.filters[i]);if(fids)return fids;}}
return null;},CLASS_NAME:"OpenLayers.Protocol.Couch"});(function(){var o=OpenLayers.Protocol.Couch.COMP_TYPE_TO_OP_STR={};o[OpenLayers.Filter.Comparison.EQUAL_TO]="eq";o[OpenLayers.Filter.Comparison.NOT_EQUAL_TO]="ne";o[OpenLayers.Filter.Comparison.LESS_THAN]="lt";o[OpenLayers.Filter.Comparison.LESS_THAN_OR_EQUAL_TO]="lte";o[OpenLayers.Filter.Comparison.GREATER_THAN]="gt";o[OpenLayers.Filter.Comparison.GREATER_THAN_OR_EQUAL_TO]="gte";o[OpenLayers.Filter.Comparison.LIKE]="ilike";})();;(function($n2){var configuration=null;var pendingRequests=[];var processingRequests=false;function uploadRequest(request){var userName=null;var sessionContext=$n2.couch.getSession().getContext();if(sessionContext){userName=sessionContext.name;};var nowTime=(new Date()).getTime();var data={nunaliit_type:'translationRequest',str:request.str,lang:request.lang,packageName:request.packageName};if(userName){data.nunaliit_created={name:userName,time:nowTime,action:'created'};data.nunaliit_last_updated={name:userName,time:nowTime,action:'lastUpdated'};configuration.db.createDocument({data:data,onSuccess:verifyRequests,onError:function(errorMsg){$n2.reportError(errorMsg);verifyRequests();}});}else{$n2.log('User not logged in. Translation requests ignored.');};};function verifyRequests(){if(pendingRequests.length<1){processingRequests=false;return;};var request=pendingRequests.shift();var startkey=[request.lang,request.str];configuration.designDoc.queryView({viewName:configuration.lookupViewName,startkey:startkey,endkey:startkey,onSuccess:function(results){if(results.length<1){uploadRequest(request);}else{verifyRequests();}},onError:function(errorMsg){$n2.reportError(errorMsg);verifyRequests();}});};function processPendingRequests(){if(configuration&&pendingRequests.length>0&&false==processingRequests){processingRequests=true;verifyRequests();};};function sendTranslationRequest(request){$n2.log('Translate '+request.str+' to '+request.lang+' ('+request.packageName+')');pendingRequests.push(request);processPendingRequests();};function loadTranslatedStrings(){var lang=$n2.l10n.getLocale().lang;var url=configuration.designDoc.ddUrl
+'_list/'+configuration.scriptList
+'/'+configuration.translatedViewName
+'?startkey="'+lang
+'"&endkey="'+lang
+'"';if($n2.scripts){var coreLocation=$n2.scripts.getCoreScriptLocation();$n2.scripts.loadScript(url,coreLocation);};};var defaultOptions={db:null,designDoc:null,lookupViewName:'l10n-all',translatedViewName:'l10n-translated',scriptList:'l10n'};function Configure(opt_){configuration=$n2.extend({},defaultOptions,opt_);loadTranslatedStrings();processPendingRequests();};$n2.l10n.sendTranslationRequest=sendTranslationRequest;$n2.couchL10n={Configure:Configure};})(nunaliit2);;(function($,$n2){function adjustDocument(doc){var userName=null;var sessionContext=$n2.couch.getSession().getContext();if(sessionContext){userName=sessionContext.name;};var nowTime=(new Date()).getTime();if(userName){if(null==doc.nunaliit_created){doc.nunaliit_created={nunaliit_type:'actionstamp',name:userName,time:nowTime,action:'created'};};doc.nunaliit_last_updated={nunaliit_type:'actionstamp',name:userName,time:nowTime,action:'updated'};};};function isAdmin(){var admin=false;var sessionContext=$n2.couch.getSession().getContext();if(sessionContext&&sessionContext.roles){if(sessionContext.roles.indexOf('_admin')!==-1){admin=true;};if(sessionContext.roles.indexOf('administrator')!==-1){admin=true;};if(typeof(n2atlas)==='object'&&typeof(n2atlas.name)==='string'){var dbAdmin=n2atlas.name+'_administrator';if(sessionContext.roles.indexOf(dbAdmin)!==-1){admin=true;};};};return admin;};function canEditDoc(data){if(isAdmin()){return true;};var userName=null;var sessionContext=$n2.couch.getSession().getContext();if(sessionContext){userName=sessionContext.name;};if(data.nunaliit_created&&data.nunaliit_created.nunaliit_type&&data.nunaliit_created.nunaliit_type==='actionstamp'&&data.nunaliit_created.name===userName){return true;};return false;};function canDeleteDoc(data){if(isAdmin()){return true;};var userName=null;var sessionContext=$n2.couch.getSession().getContext();if(sessionContext){userName=sessionContext.name;};if(data.nunaliit_created&&data.nunaliit_created.nunaliit_type&&data.nunaliit_created.nunaliit_type==='actionstamp'&&data.nunaliit_created.name===userName){return true;};return false;};function OnFeatureEdit(feature){if(!feature)return;var data=feature.data;if(!data){data=feature.attributes;}
if(!data)return;adjustDocument(data);};function documentContainsMedia(doc){var containsMedia=false;if(doc.nunaliit_attachments&&doc.nunaliit_attachments.files){for(var attName in doc.nunaliit_attachments.files){containsMedia=true;};};return containsMedia;};function documentContainsApprovedMedia(doc){var containsApprovedMedia=false;if(doc.nunaliit_attachments&&doc.nunaliit_attachments.files){for(var attName in doc.nunaliit_attachments.files){var att=doc.nunaliit_attachments.files[attName];if(att.status==='approved'||att.status==='attached'){containsApprovedMedia=true;};};};return containsApprovedMedia;};function documentContainsDeniedMedia(doc){var containsDeniedMedia=false;if(doc.nunaliit_attachments&&doc.nunaliit_attachments.files){for(var attName in doc.nunaliit_attachments.files){var att=doc.nunaliit_attachments.files[attName];if(att.status==='denied'){containsDeniedMedia=true;};};};return containsDeniedMedia;};$.olkitMap={OnFeatureEdit:OnFeatureEdit};$n2.couchMap={adjustDocument:adjustDocument,isAdmin:isAdmin,canEditDoc:canEditDoc,canDeleteDoc:canDeleteDoc,documentContainsMedia:documentContainsMedia,documentContainsApprovedMedia:documentContainsApprovedMedia,documentContainsDeniedMedia:documentContainsDeniedMedia};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str){return $n2.loc(str,'nunaliit2-couch');};var addContributionSchema=new $n2.form.Schema({title:null,okButton:true,cancelButton:true,attributes:[{name:'title',label:_loc('Title'),selector:'nunaliit_contribution.title',type:'text',className:'contributionTitle',description:'The title of the contribution'},{name:'description',label:_loc('Description'),selector:'nunaliit_contribution.description',type:'textarea',className:'contributionDescription',description:'The creator of the entity'},{name:'media',label:_loc('Media'),type:'file',description:'Media associated with contribution'}]});var defaultOptions={db:null,designDoc:null,showService:null,uploads:null,searchView:'upload-type-text-search',contributionFromReferenceView:'contributions',addContributionSchema:addContributionSchema};$n2.couchContributions=$n2.Class({options:null,lookAheadCounter:null,lookAheadMap:null,initialize:function(options_){this.options=$n2.extend({},defaultOptions,options_);this.lookAheadCounter=0;this.lookAheadMap={};},performContributionSearch:function(opts_){var opt=$n2.extend({searchTerms:null,uploadType:null,searchLimit:25,docsOnly:true,onSuccess:function(docs){},onError:function(error){}},opts_);var searchTerms=opt.searchTerms;var searchResults={pending:searchTerms.length,map:{},sorted:[]};for(var i=0,e=searchTerms.length;i<e;++i){this.options.designDoc.queryView({viewName:this.options.searchView,startkey:[opt.uploadType,searchTerms[i],0],endkey:[opt.uploadType,searchTerms[i],{}],limit:opt.searchLimit,onSuccess:function(rows){ReportSearchResults(rows);}});};function ReportSearchResults(rows){--searchResults.pending;for(var i=0,e=rows.length;i<e;++i){var doc=rows[i].value;var index=rows[i].key[2];if(searchResults.map[doc._id]){var m=searchResults.map[doc._id];++m.terms;if(m.index>index)m.index=index;}else{var m={doc:doc,id:doc._id,index:index,terms:1};searchResults.map[doc._id]=m;searchResults.sorted.push(m);}};if(searchResults.pending>0)return;searchResults.sorted.sort(function(a,b){if(a.terms>b.terms){return-1;}else if(a.terms<b.terms){return 1;}else{if(a.index<b.index){return-1;}else if(a.index>b.index){return 1;};};return 0;});var result=[];for(var i=0,e=searchResults.sorted.length;i<e;++i){if(i>opt.searchLimit)break;var m=searchResults.sorted[i];if(opt.docsOnly){result.push(m.doc);}else{result.push(m);};};opt.onSuccess(result);};},displayContributionSelection:function($elem,contributionDocs,opts_){var opt=$n2.extend({onSuccess:function(doc){},onError:function(error){}},opts_);$elem.empty();for(var i=0,e=contributionDocs.length;i<e;++i){var contributionDoc=contributionDocs[i];var $div=$('<div class="couchContributionSelect" style="border:1px solid #000000"></div>');$elem.append($div);this.displayContribution($div,contributionDoc);installSelection($div,contributionDoc);}
function installSelection($div,contributionDoc){$div.click(function(){opt.onSuccess(contributionDoc);});}},displayContribution:function($elem,contributionDoc){$elem.empty();var docUrl=this.options.db.getDocumentUrl(contributionDoc);if(contributionDoc.converted){var linkDiv=null;if(contributionDoc.gcrc_upload_type==='image'&&contributionDoc.thumbnail){linkDiv=$('<div class="contribution_media_icon_wrapper"><img src="'+docUrl+'/thumbnail"/></div>');}else if(contributionDoc.gcrc_upload_type==='image'){linkDiv=$('<div class="contribution_media_icon_wrapper"><div class="contribution_media_icon contribution_image_icon"></div></div>');}else if(contributionDoc.gcrc_upload_type==='audio'){linkDiv=$('<div class="contribution_media_icon_wrapper"><div class="contribution_media_icon contribution_audio_icon"></div></div>');}else if(contributionDoc.gcrc_upload_type==='video'&&contributionDoc.thumbnail){linkDiv=$('<div class="contribution_media_icon_wrapper"><img src="'+docUrl+'/thumbnail"/></div>');}else if(contributionDoc.gcrc_upload_type==='video'){linkDiv=$('<div class="contribution_media_icon_wrapper"><div class="contribution_media_icon contribution_video_icon"></div></div>');};if(null!=linkDiv){$elem.append(linkDiv);var cb=createMediaCallback(contributionDoc.gcrc_upload_type,docUrl,contributionDoc);linkDiv.click(cb);};};if(contributionDoc.nunaliit_contribution&&contributionDoc.nunaliit_contribution.nunaliit_type&&contributionDoc.nunaliit_contribution.nunaliit_type=='contribution'){if(contributionDoc.nunaliit_contribution.title){$elem.append($('<div>'+_loc('Title')+': '+contributionDoc.nunaliit_contribution.title+'</div>'));};if(contributionDoc.nunaliit_contribution.description){$elem.append($('<div>'+_loc('Description')+': '+contributionDoc.nunaliit_contribution.description+'</div>'));};};$elem.append($('<div>'+_loc('id')+': '+contributionDoc._id+'</div>'));if(contributionDoc.original){$elem.append($('<div>file: '+contributionDoc.original.name+' ('+contributionDoc.original.mimeType+')</div>'));};var createdByUser=null;var createdTime=null;if(contributionDoc.nunaliit_created){if(contributionDoc.nunaliit_created.name){createdByUser=contributionDoc.nunaliit_created.name;var $createdByDiv=$('<div>'+_loc('Created by')+': <span></span></div>');if(this.options.showService){this.options.showService.printUserName($createdByDiv.find('span'),createdByUser,{showHandle:true});}else{$createdByDiv.find('span').text(createdByUser);};if(contributionDoc.nunaliit_created.time){createdTime=contributionDoc.nunaliit_created.time;var dateStr=(new Date(createdTime)).toString();$createdByDiv.append($('<span> on '+dateStr+'</span>'));};$elem.append($createdByDiv);};};if(contributionDoc.nunaliit_last_updated){if(contributionDoc.nunaliit_last_updated.name){var lastUpdatedByUser=contributionDoc.nunaliit_last_updated.name;var lastUpdatedTime=contributionDoc.nunaliit_last_updated.time;if(lastUpdatedByUser!=createdByUser||lastUpdatedTime!=createdTime){var $lastUpdatedDiv=$('<div>'+_loc('Last updated by')+': <span></span></div>');if(this.options.showService){this.options.showService.printUserName($lastUpdatedDiv.find('span'),lastUpdatedByUser,{showHandle:true});}else{$lastUpdatedDiv.find('span').text(lastUpdatedByUser);};if(lastUpdatedTime){var dateStr=(new Date(lastUpdatedTime)).toString();$lastUpdatedDiv.append($('<span> on '+dateStr+'</span>'));};$elem.append($lastUpdatedDiv);};};};$elem.append($('<div style="clear:both"></div>'));function createMediaCallback(uploadType,docUrl,doc){return function(){var mediaOptions={url:docUrl+'/converted'};if(doc.nunaliit_contribution&&doc.nunaliit_contribution.title){mediaOptions.title=doc.nunaliit_contribution.title;};if(doc.nunaliit_created&&doc.nunaliit_created.name){mediaOptions.author=doc.nunaliit_created.name;};if(doc.nunaliit_contribution&&doc.nunaliit_contribution.description){mediaOptions.description=doc.nunaliit_contribution.description;};if(uploadType==='image'){mediaOptions.type='image';$n2.mediaDisplay.displayMedia(mediaOptions);}else if(uploadType==='video'){mediaOptions.type='video';$n2.mediaDisplay.displayMedia(mediaOptions);}else if(uploadType==='audio'){mediaOptions.type='audio';$n2.mediaDisplay.displayMedia(mediaOptions);};};};},searchTextBox:function(opt_){var _this=this;var opt=$n2.extend({elem:null,lookAheadView:'text-lookahead',lookAheadList:'text-lookahead',lookAheadLimit:5,lookAheadPrefixMin:3,lookAheadCacheSize:10,onSuccess:function(terms){}},opt_);var $elem=opt.elem;if(typeof($elem)==='string'){$elem=$('#'+$elem);}else{$elem=$($elem);};var $lookUpDiv=$('<div class="couchLookahead"></div>');var divider=$('<div class="couchLookaheadDivider"></div>');divider.append($lookUpDiv);var $input=$('<input type="text"/>');var holder=$('<div></div>');holder.append($input).append(divider);$elem.empty().append(holder);var skipKeyUp=false;$input.keypress(SearchInputKeyPressed);$input.keyup(SearchInputKeyUp);function SearchInputKeyPressed(evt){var charCode=null;if(null!=evt&&null!=evt.which){charCode=evt.which;}else if(null!=window.event&&null!=window.event.keyCode){charCode=window.event.keyCode;};if(13==charCode||null==charCode){ProcessSearchInput();};};function SearchInputKeyUp(evt){if(skipKeyUp){skipKeyUp=false;}else{ProcessLookAhead();};};function ProcessSearchInput(){skipKeyUp=true;var searchTerms=GetSearchTerms();opt.onSuccess(searchTerms);CloseLookAhead();};function ProcessLookAhead(){var searchTerms=GetSearchTerms();var index=searchTerms.length-1;if(index>=0){var lastTerm=searchTerms[index];var previousWords=null;if(index>0){previousWords=searchTerms.slice(0,index);};};if(!lastTerm){CloseLookAhead();return;};if(lastTerm.length<opt.lookAheadPrefixMin){CloseLookAhead();return;};var previousWordsString='';if(previousWords){previousWordsString=previousWords.join(' ')+' ';};QueryLookAhead(lastTerm,function(prefix,words){$lookUpDiv.empty();if(words.length>0){$lookUpDiv.css('display','block');}else{$lookUpDiv.css('display','none');};for(var i=0,e=words.length;i<e;++i){var offered=words[i].substring(prefix.length);var line=$('<div class="couchLookaheadLine '
+(i%2?'couchLookaheadLineOdd':'couchLookaheadLineEven')+'">'
+'<span class="couchLookaheadTyped">'
+previousWordsString+prefix+'</span>'
+'<span class="offered">'+offered+'</span>'
+'</div>');installClick(line,previousWordsString+words[i]);$lookUpDiv.append(line);};});function installClick($elem,wordString){$elem.click(function(){$input.val(wordString);var terms=wordString.split(' ');opt.onSuccess(terms);CloseLookAhead();});};};function CloseLookAhead(){$lookUpDiv.css('display','none');};function GetSearchTerms(){var searchTerms=$input.val();searchTerms=searchTerms.split(/[ \t\r\n]+/);return searchTerms;};function QueryLookAhead(prefix,callback){if(_this.lookAheadMap[prefix]){callback(prefix,_this.lookAheadMap[prefix].words);return;};var sub=prefix.substring(0,prefix.length-1);while(sub.length>=opt.lookAheadPrefixMin){if(_this.lookAheadMap[sub]&&_this.lookAheadMap[sub].full){callback(prefix,_this.lookAheadMap[sub].words);return;};sub=sub.substring(0,sub.length-1);};_this.options.designDoc.queryView({viewName:opt.lookAheadView,listName:opt.lookAheadList,startkey:prefix,endkey:prefix+'\u9999',top:opt.lookAheadLimit,group:true,onlyRows:false,reduce:true,onSuccess:function(response){var rows=response.rows;var words=[];for(var i=0,e=rows.length;i<e;++i){words.push(rows[i][0]);};_this.lookAheadMap[prefix]={prefix:prefix,words:words,full:response.all_rows,counter:_this.lookAheadCounter};++_this.lookAheadCounter;var keysToDelete=[];for(var key in _this.lookAheadMap){if(_this.lookAheadMap[key].counter<(_this.lookAheadCounter-opt.lookAheadCacheSize)){keysToDelete.push(key);};};for(var i=0,e=keysToDelete.length;i<e;++i){delete _this.lookAheadMap[keysToDelete[i]];};callback(prefix,words);}});};},searchContributions:function(opt_){var _this=this;var opt=$n2.extend({elem:null,uploadType:null,onSuccess:function(selectedContribution){}},opt_);var $elem=opt.elem;if(typeof($elem)==='string'){$elem=$('#'+$elem);}else{$elem=$($elem);};var $search=$('<div></div>');var $result=$('<div></div>');$elem.empty().append($search).append($result);this.searchTextBox({elem:$search,onSuccess:function(terms){_this.performContributionSearch({searchTerms:terms,uploadType:opt.uploadType,onSuccess:receiveContributions});}});function receiveContributions(contributions){_this.displayContributionSelection($result,contributions,{onSuccess:selectedContribution});}
function selectedContribution(contribution){$elem.empty();opt.onSuccess(contribution);}},getContributionsForReference:function(opt_){var _this=this;var opt=$n2.extend({docId:null,onSuccess:function(contributions){},onError:function(err){$n2.reportError(err);}},opt_);var docId=opt.docId;if(null==docId){opt.onError('DocId must be supplied when contributions are retrieved');return;};this.options.designDoc.queryView({viewName:this.options.contributionFromReferenceView,startkey:docId,endkey:docId,onSuccess:function(rows){var contributions=[];for(var i=0,e=rows.length;i<e;++i){contributions.push(rows[i].value);};opt.onSuccess(contributions);},onError:opt.onError});},buildAddContributionForm:function(opt_){var _this=this;var opt=$n2.extend({elem:null,referenceDocId:null,replyContributionId:null,onSuccess:function(){},onCancel:function(){}},opt_);var $elem=opt.elem;if(typeof($elem)==='string'){$elem=$('#'+$elem);}else{$elem=$($elem);};var contributionDoc={nunaliit_contribution:{nunaliit_type:'contribution'}};if(opt.referenceDocId){contributionDoc.nunaliit_contribution.reference={nunaliit_type:'reference',doc:opt.referenceDocId};};if(opt.replyContributionId){contributionDoc.nunaliit_contribution.reply={nunaliit_type:'reference',doc:opt.replyContributionId};};$n2.couchMap.adjustDocument(contributionDoc);var form=this.options.addContributionSchema.createForm($elem,contributionDoc,{preOK:function(){_this.options.uploads.getWelcome({onSuccess:function(welcomeData){_this.options.db.createDocument({data:contributionDoc,onSuccess:function(docInfo){var $form=$(form.form);$form.prepend($('<input type="hidden" name="id" value="'+docInfo.id+'"/>'));$form.prepend($('<input type="hidden" name="rev" value="'+docInfo.rev+'"/>'));_this.options.uploads.submitForm({form:$form,onSuccess:opt.onSuccess,onError:function(err){$n2.reportError('Error uploading file: '+err);}});},onError:function(err){$n2.reportError('Unable to reach database to submit document: '+err);}});},onError:function(){$n2.reportError('Unable to reach atlas server');}});return false;},postCancel:opt.onCancel});}});})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str){return $n2.loc(str,'nunaliit2-couch');};$n2.couchRequests=$n2.Class({options:null,currentRequests:null,scheduled:null,userListeners:null,documentListeners:null,initialize:function(options_){this.options=$n2.extend({},{db:null,userDb:null,designDoc:null,cacheService:null,directory:null},options_);this.currentRequests={};this.scheduled=false;this.userListeners=[];this.documentListeners=[];},addUserListener:function(listener){if(typeof(listener)==='function'){this.userListeners.push(listener);};},addDocumentListener:function(listener){if(typeof(listener)==='function'){this.documentListeners.push(listener);};},requestUser:function(userName){if(!this.currentRequests.users){this.currentRequests.users={};};this.currentRequests.users[userName]=1;this._schedule();},requestDocument:function(docId,cbFn){if(!this.currentRequests.docs){this.currentRequests.docs={};};if(!this.currentRequests.docs[docId]){this.currentRequests.docs[docId]=[];};if(cbFn){this.currentRequests.docs[docId].push(cbFn);};this._schedule();},_schedule:function(){if(this.scheduled)return;var _this=this;this.scheduled=true;setTimeout(function(){_this.scheduled=false;_this._performRequests();},0);},_performRequests:function(){var _this=this;var requests=this.currentRequests;this.currentRequests={};if(requests.users&&this.options.userDb){var userNames=[];for(var userName in requests.users){userNames.push(userName);};this.options.userDb.getUsers({names:userNames,onSuccess:function(users){_this._callUserListeners(users);}});};var cachedDocs=null;if(requests.docs&&this.options.db){var docIds=[];for(var docId in requests.docs){var cachedDoc=null;if(this.options.cacheService){cachedDoc=this.options.cacheService.retrieve(docId);};if(cachedDoc){if(!cachedDocs){cachedDocs=[];};cachedDocs.push(cachedDoc);}else{docIds.push(docId);};};if(docIds.length){this.options.db.getDocuments({docIds:docIds,onSuccess:function(docs){_this._callDocumentListeners(docs,requests);}});};};if(null!==cachedDocs){this._callDocumentListeners(cachedDocs,requests);};},_callUserListeners:function(userDocs){for(var i=0,e=userDocs.length;i<e;++i){var userDoc=userDocs[i];for(var j=0,f=this.userListeners.length;j<f;++j){var listener=this.userListeners[j];listener(userDoc);};};},_callDocumentListeners:function(docs,requests){for(var i=0,e=docs.length;i<e;++i){var doc=docs[i];this._dispatch({type:'documentVersion',docId:doc._id,rev:doc._rev});for(var j=0,f=this.documentListeners.length;j<f;++j){var listener=this.documentListeners[j];listener(doc);};var docId=doc._id;if(requests.docs&&requests.docs[docId]){for(var j=0,f=requests.docs[docId].length;j<f;++j){var listener=requests.docs[docId][j];listener(doc);};};};},_getDispatcher:function(){var d=null;if(this.options.directory){d=this.options.directory.dispatchService;};return d;},_dispatch:function(m){var dispatcher=this._getDispatcher();if(dispatcher){var h=dispatcher.getHandle('n2.couchRequests');dispatcher.send(h,m);};}});})(jQuery,nunaliit2);;(function($,$n2){function defaultInstallSound(info){};function defaultHandleDocumentSound(info_,cb_){cb_(info_);};var HoverSoundService=$n2.Class({options:null,dispatcher:null,requestService:null,currentFocusSoundDocId:null,dispatchHandle:null,initialize:function(options_){var _this=this;this.options=$n2.extend({db:null,serviceDirectory:null,handleDocumentSound:defaultHandleDocumentSound},options_);this.currentFocusSoundDocId=null;if(this.options.serviceDirectory){this.dispatcher=this.options.serviceDirectory.dispatchService;this.requestService=this.options.serviceDirectory.requestService;};if(this.dispatcher){var f=function(m){_this._handleDispatch(m);};this.dispatchHandle=this.dispatcher.getHandle('n2.couch.sound');this.dispatcher.register(this.dispatchHandle,'focusOn',f);this.dispatcher.register(this.dispatchHandle,'focusOff',f);this.dispatcher.register(this.dispatchHandle,'playHoverSoundOn',f);this.dispatcher.register(this.dispatchHandle,'playHoverSoundOff',f);};},handleFeatureHover:function(feature,opts_){if(!feature)return;var data=feature.attributes;if(!data){data=feature.data;};if(!data){return;};this.findDocumentHoverSound(data,opts_);},findDocumentHoverSound:function(data,opts_){var opts=$.extend({installSoundFn:defaultInstallSound,handleDocumentSound:this.options.handleDocumentSound},opts_);var _this=this;if(!data)return;var info={docId:data._id,doc:data,soundUrl:null,installSoundFn:opts.installSoundFn};opts.handleDocumentSound(info,function(info_){_this._defaultDocumentSound(info_);});},_defaultDocumentSound:function(info){var _this=this;if(info.soundUrl){info.installSoundFn(info);}else{GetHoverSoundUrlFromDocument({db:this.options.db,serviceDirectory:this.options.serviceDirectory,doc:info.doc,onSuccess:function(soundUrl){info.soundUrl=soundUrl;info.installSoundFn(info);}});};},_handleDispatch:function(m){var _this=this;if(m.type==='focusOn'){if(m.doc){if(this.currentFocusSoundDocId){this._removeFocusSound(this.currentFocusSoundDocId);};this.currentFocusSoundDocId=m.doc._id;this.findDocumentHoverSound(m.doc,{installSoundFn:function(info){_this._installFocusSound(info);}});}else if(m.docId){if(this.currentFocusSoundDocId){this._removeFocusSound(this.currentFocusSoundDocId);};this.currentFocusSoundDocId=m.docId;if(this.requestService){this.requestService.requestDocument(m.docId,function(doc){_this.findDocumentHoverSound(doc,{installSoundFn:function(info){_this._installFocusSound(info);}});});};};}else if(m.type==='focusOff'){if(m.doc){this._removeFocusSound(m.doc._id);}else if(m.docId){this._removeFocusSound(m.docId);};}else if(m.type==='playHoverSoundOn'){if(m.doc){this._initiatePlaySound(m.doc._id);this.findDocumentHoverSound(m.doc,{installSoundFn:function(info){_this._installPlaySound(info);}});};}else if(m.type==='playHoverSoundOff'){if(m.doc){this._removePlaySound(m.doc._id);};};},_installFocusSound:function(info){var docId=info.docId;var url=info.soundUrl;if(url&&this.currentFocusSoundDocId===docId){var $div=this._getFocusSoundDiv();this._insertSoundElement($div,url);};},_removeFocusSound:function(docId){if(this.currentFocusSoundDocId===docId){var $div=this._getFocusSoundDiv();$div.empty();this.currentFocusSoundDocId=null;};},_initiatePlaySound:function(docId){var divId='n2CouchPlaySound_'+$n2.utils.stringToHtmlId(docId);var $div=$('#'+divId);if($div.length<1){$div=$('<div id="'+divId+'"></div>');this._getSoundDiv().append($div);};},_installPlaySound:function(info){var docId=info.docId;var url=info.soundUrl;var $div=$('#n2CouchPlaySound_'+$n2.utils.stringToHtmlId(docId));this._insertSoundElement($div,url);},_removePlaySound:function(docId){var $div=$('#n2CouchPlaySound_'+$n2.utils.stringToHtmlId(docId));$div.remove();},_getSoundDiv:function(){var $div=$('#n2CouchSound');if($div.length<1){$div=$('<div id="n2CouchSound"></div>');$('body').append($div);};return $div;},_getFocusSoundDiv:function(){var $div=$('#n2CouchFocusSound');if($div.length<1){var $parent=this._getSoundDiv();$div=$('<div id="n2CouchFocusSound"></div>');$parent.append($div);};return $div;},_insertSoundElement:function($div,url){$div.html('<embed src="'+url+'" hidden="true" autostart="true" loop="false"/>');}});var GetHoverSoundUrlFromDocument=function(opts_){var opts=$n2.extend({db:null,serviceDirectory:null,doc:null,onSuccess:function(soundUrl){},onError:function(err){}},opts_);var data=opts.doc;var requestService=null;if(opts&&opts.serviceDirectory){requestService=opts.serviceDirectory.requestService;};if(!requestService){opts.onError('Request service not available');return;};if(data.sound&&data.sound.nunaliit_type&&data.sound.nunaliit_type==='reference'&&data.sound.doc){var docUrl=opts.db.getDocumentUrl(data.sound.doc);var soundUrl=docUrl+'/converted';opts.onSuccess(soundUrl);return;};if(data.nunaliit_attachments&&data.nunaliit_attachments.nunaliit_type==='attachment_descriptions'&&data.nunaliit_attachments.files){var hoverSoundAttName=null;for(var attName in data.nunaliit_attachments.files){var attDesc=data.nunaliit_attachments.files[attName];if(attDesc&&attDesc.data&&attDesc.data.hoverSound){hoverSoundAttName=attName;break;};};if(hoverSoundAttName){var docUrl=opts.db.getDocumentUrl(data._id);var soundUrl=docUrl+'/'+attName;opts.onSuccess(soundUrl);return;};};if(data.nunaliit_hoverSound&&data.nunaliit_hoverSound.nunaliit_type==='reference'&&data.nunaliit_hoverSound.doc){var soundDocId=data.nunaliit_hoverSound.doc;requestService.requestDocument(soundDocId,function(doc){if(doc&&doc.nunaliit_attachments&&doc.nunaliit_attachments.files){for(var attName in doc.nunaliit_attachments.files){var attDesc=doc.nunaliit_attachments.files[attName];if(doc._attachments&&doc._attachments[attName]&&attDesc.fileClass=='audio'){var docUrl=opts.db.getDocumentUrl(doc._id);var soundUrl=docUrl+'/'+attName;opts.onSuccess(soundUrl);return;};};};opts.onError('Can not find sound url');});return;};opts.onError('Can not find sound url');};var DocumentContainsHoverSound=function(data){if(data.sound&&data.sound.nunaliit_type&&data.sound.nunaliit_type==='reference'&&data.sound.doc){return true;};if(data.nunaliit_attachments&&data.nunaliit_attachments.nunaliit_type==='attachment_descriptions'&&data.nunaliit_attachments.files){var hoverSoundAttName=null;for(var attName in data.nunaliit_attachments.files){var attDesc=data.nunaliit_attachments.files[attName];if(attDesc&&attDesc.data&&attDesc.data.hoverSound){hoverSoundAttName=attName;break;};};if(hoverSoundAttName){return true;};};if(data.nunaliit_hoverSound&&data.nunaliit_hoverSound.nunaliit_type==='reference'&&data.nunaliit_hoverSound.doc){return true;};return false;};$n2.couchSound={HoverSoundService:HoverSoundService,GetHoverSoundUrlFromDocument:GetHoverSoundUrlFromDocument,DocumentContainsHoverSound:DocumentContainsHoverSound};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str){return $n2.loc(str,'nunaliit2-couch');};var Notifier=$n2.Class({options:null,initialize:function(options_){this.options=$n2.extend({dbChangeNotifier:null,directory:null},options_);var _this=this;if(this.options.dbChangeNotifier){this.options.dbChangeNotifier.addListener(function(changes){_this._dbChanges(changes);});};},_dbChanges:function(changes){$n2.log('update',changes);var lastSeq=changes.last_seq;var results=changes.results;var dispatcher=this._getDispatcher();if(dispatcher){var dHandle=dispatcher.getHandle('n2.couchServerSide');for(var i=0,e=results.length;i<e;++i){var updateRecord=results[i];var isAdded=false;var latestRev=null;if(updateRecord.changes){for(var l=0,k=updateRecord.changes.length;l<k;++l){var latestRev=updateRecord.changes[l].rev;if(latestRev.substr(0,2)==='1-'){isAdded=true;};};};if(latestRev){dispatcher.send(dHandle,{type:'documentVersion',docId:updateRecord.id,rev:latestRev});};if(updateRecord.deleted){dispatcher.send(dHandle,{type:'documentDeleted',docId:updateRecord.id});}else if(isAdded){dispatcher.send(dHandle,{type:'documentCreated',docId:updateRecord.id});}else{dispatcher.send(dHandle,{type:'documentUpdated',docId:updateRecord.id});};};};},_getDispatcher:function(){var d=null;if(this.options.directory){d=this.options.directory.dispatchService;};return d;}});$n2.couchServerSide={Notifier:Notifier,DefaultNotifier:null};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str){return $n2.loc(str,'nunaliit2-couch');};var index=0;var loginStateListeners=[];var lastAuthSessionCookie=null;var addListeners=function(listeners){var cUser=getCurrentUser();if(typeof(listeners)=='function'){addListener(listeners);}else if($n2.isArray(listeners)){for(var loop=0;loop<listeners.length;++loop){var listener=listeners[loop];if(typeof(listener)==='function'){addListener(listener);};};};function addListener(listener){loginStateListeners.push(listener);try{listener(cUser);}catch(e){log('$.NUNALIIT_AUTH: EXCEPTION caught in listener (add): '+e);};};};var notifyListeners=function(){var user=getCurrentUser();var userName=null;if(user){userName=user.name;};$n2.cookie.setCookie({name:'NunaliitAuth',value:userName,path:'/'});if(user){_dispatch({type:'login',user:user});}else{_dispatch({type:'logout'});};for(var loop=0;loop<loginStateListeners.length;++loop){var listener=loginStateListeners[loop];if(listener){try{listener(user);}catch(e){log('$.NUNALIIT_AUTH: EXCEPTION caught in listener (notify): '+e);};};};};var _userLogin=function(options,anonymousFlag,username,password){var loginRetries=0,loginRetryLimit=3;function doLogin(){$n2.couch.getSession().login({name:username,password:password,onSuccess:onSuccess,onError:onError});};function retryLogin(){++loginRetries;if(loginRetries<=loginRetryLimit){doLogin();return(true);};return(false);};function clearLoginForm(){if(!options.autoAnonymousLogin||!anonymousFlag){options.dialog.dialog('close');};};function doErrorNotification(causeObj){if(options.autoAnonymousLogin&&anonymousFlag){var retrying=retryLogin();if(retrying){return;};};var err={message:'Invalid e-mail and/or password'};if(null!=causeObj){err.cause=causeObj;};clearLoginForm();options.onError(err,options);notifyListeners();};function onSuccess(result){var context=$n2.couch.getSession().getContext();log("Login successful",context,options);if(context&&context.name){clearLoginForm();options.onSuccess(context,options);notifyListeners();}else{doErrorNotification(null);};};function onError(xmlHttpRequest,textStatus,errorThrown){log("Login error",xmlHttpRequest,textStatus,errorThrown);doErrorNotification({message:textStatus});};if(anonymousFlag){username=options.anonymousUser;password=options.anonymousPw;};doLogin();};var defaultError=function(err,options){var acc=[];if(err){acc.push(''+err.message);var cause=err.cause;while(cause){acc.push('\n>'+cause.message);cause=cause.cause;};}else{acc.push('<Unknown error>');};alert(acc.join(''));};var initOptions={};var defaultOptions={onSuccess:function(result,options){},onError:defaultError,anonymousLoginAllowed:false,anonymousUser:'anonymous',anonymousPw:'anonymous',autoAnonymousLogin:false,prompt:_loc('Please login'),userString:_loc('user name'),directory:null};var init=function(options_){initOptions=$.extend({},defaultOptions,{autoRefresh:true,refreshIntervalInSec:120},options_);if(initOptions.listeners){addListeners(initOptions.listeners);delete initOptions.listeners;};var initOnSuccess=initOptions.onSuccess;delete initOptions.onSuccess;var initOnError=initOptions.onError;delete initOptions.onError;var optWithCallbacks=$.extend({},initOptions,{onSuccess:initOnSuccess,onError:initOnError});$n2.couch.getSession().refreshContext({onSuccess:onSuccess,onError:onError});$n2.couch.getSession().addChangedContextListener(notifyListeners);if(initOptions.autoRefresh&&initOptions.refreshIntervalInSec>0&&typeof(setInterval)==='function'){setInterval(function(){$n2.couch.getSession().refreshContext({onError:function(){}});},(1000*initOptions.refreshIntervalInSec));setInterval(function(){var cookie=$n2.cookie.getCookie('NunaliitAuth');if(cookie!==lastAuthSessionCookie){lastAuthSessionCookie=cookie;$n2.couch.getSession().refreshContext({onError:function(){}});};},2000);};function onSuccess(context){$n2.log("Login(adjustCookies) successful",context,initOptions);if(!context.name&&initOptions.autoAnonymousLogin){_userLogin(optWithCallbacks,true);}else{initOnSuccess(context,optWithCallbacks);notifyListeners();};};function onError(error){log('Login(adjustCookies) error: '+error);if(initOptions.autoAnonymousLogin){_userLogin(optWithCallbacks,true);}else{var err={message:'Problem initializing authentication library',cause:{message:error}};initOnError(err,optWithCallbacks);notifyListeners();};};};var autoAnonLogin=function(options_){var options=$.extend({},defaultOptions,initOptions,options_);_userLogin(options,true);};function createLoginDialog(dialogId,options){var $dialog=$('#'+dialogId);$dialog.html(['<div class="n2Auth_login">','<div class="n2Auth_login_user_line">','<div class="n2Auth_login_label"></div>','<div class="n2Auth_login_input"><input class="n2Auth_user_input n2Auth_input_field" type="text"/></div>','<div class="n2Auth_login_end"></div>','</div>','<div class="n2Auth_login_pw_line">','<div class="n2Auth_login_label"></div>','<div class="n2Auth_login_input"><input class="n2Auth_pw_input n2Auth_input_field" type="password"/></div>','<div class="n2Auth_login_end"></div>','</div>','<div class="n2Auth_login_button_line">','<button class="n2Auth_button_login"></button>','<button class="n2Auth_button_cancel"></button>','<div class="n2Auth_login_end"></div>','</div>','<div class="n2Auth_login_create_line">','<a class="n2Auth_button_createUser" href="#"></a>','<div class="n2Auth_login_end"></div>','</div>','</div>'].join(''));$dialog.find('.n2Auth_login_user_line .n2Auth_login_label').text(_loc('user name'));$dialog.find('.n2Auth_login_pw_line .n2Auth_login_label').text(_loc('password'));$dialog.find('.n2Auth_button_login').text(_loc('Login')).button({icons:{primary:'ui-icon-check'}}).click(function(){performLogin();return false;});$dialog.find('.n2Auth_button_cancel').text(_loc('Cancel')).button({icons:{primary:'ui-icon-cancel'}}).click(function(){var $dialog=$('#'+dialogId);$dialog.dialog('close');});$dialog.find('.n2Auth_button_createUser').text(_loc('Create a new user')).click(function(){createUserCreationDialog(dialogId,options);return false;});$dialog.find('.n2Auth_input_field').keydown(function(e){var charCode=null;if(null===e){e=window.event;};if(null!==e){if(e.keyCode){charCode=e.keyCode;};};if(13===charCode){performLogin();};});if(options.prompt){$dialog.dialog('option','title',options.prompt);}else{$dialog.dialog('option','title',_loc('Please login'));};function performLogin(){var $dialog=$('#'+dialogId);var user=$dialog.find('.n2Auth_user_input').val();var password=$dialog.find('.n2Auth_pw_input').val();_userLogin(options,false,user,password);};};function createUserCreationDialog(dialogId,options){var $dialog=$('#'+dialogId);$dialog.html(['<div class="n2Auth_create">','<div class="n2Auth_create_user_line">','<div class="n2Auth_create_label"></div>','<div class="n2Auth_create_input"><input class="n2Auth_user_input n2Auth_input_field" type="text"/></div>','<div class="n2Auth_create_end"></div>','</div>','<div class="n2Auth_create_display_line">','<div class="n2Auth_create_label"></div>','<div class="n2Auth_create_input"><input class="n2Auth_display_input n2Auth_input_field" type="text"/></div>','<div class="n2Auth_create_end"></div>','</div>','<div class="n2Auth_create_pw_line">','<div class="n2Auth_create_label"></div>','<div class="n2Auth_create_input"><input class="n2Auth_pw_input n2Auth_input_field" type="password"/></div>','<div class="n2Auth_create_end"></div>','</div>','<div class="n2Auth_create_pw2_line">','<div class="n2Auth_create_label"></div>','<div class="n2Auth_create_input"><input class="n2Auth_pw_input2 n2Auth_input_field" type="password"/></div>','<div class="n2Auth_create_end"></div>','</div>','<div class="n2Auth_create_button_line">','<button class="n2Auth_button_create"></button>','<button class="n2Auth_button_cancel"></button>','</div>','</div>'].join(''));$dialog.find('.n2Auth_create_user_line .n2Auth_create_label').text(_loc('user name'));$dialog.find('.n2Auth_create_display_line .n2Auth_create_label').text(_loc('display name'));$dialog.find('.n2Auth_create_pw_line .n2Auth_create_label').text(_loc('password'));$dialog.find('.n2Auth_create_pw2_line .n2Auth_create_label').text(_loc('confirm password'));$dialog.find('.n2Auth_button_create').text(_loc('Create User')).button({icons:{primary:'ui-icon-check'}}).click(function(){performUserCreation();return false;});$dialog.find('.n2Auth_button_cancel').text(_loc('Cancel')).button({icons:{primary:'ui-icon-cancel'}}).click(function(){createLoginDialog(dialogId,options);return false;});$dialog.find('.n2Auth_input_field').keydown(function(e){var charCode=null;if(null===e){e=window.event;};if(null!==e){if(e.keyCode){charCode=e.keyCode;};};if(13===charCode){performUserCreation();};});$dialog.dialog('option','title',_loc('User Creation'));function performUserCreation(){var $dialog=$('#'+dialogId);var user=$dialog.find('.n2Auth_user_input').val();var display=$dialog.find('.n2Auth_display_input').val();var password=$dialog.find('.n2Auth_pw_input').val();var password2=$dialog.find('.n2Auth_pw_input2').val();if(null==user||user.length<3){alert(_loc('User name should have at least 3 characters'));return false;};if(password!=password2){alert(_loc('The two passwords should match'));return false;};if(null==password||password.length<6){alert(_loc('Password should have at least 6 characters'));return false;};if(null==display||display.length<1){display=user;};$n2.couch.getUserDb().createUser({name:user,password:password,display:display,onSuccess:function(){_userLogin(options,false,user,password);},onError:function(err){alert(_loc('Unable to create user: ')+err);}});};};var showLoginForm=function(options_){var options=$.extend({},defaultOptions,initOptions,options_);var myIndex=index;++index;options.index=myIndex;var dialogId=$n2.getUniqueId();var $dialog=$('<div id="'+dialogId+'"></div>');options.dialog=$dialog;$(document.body).append($dialog);createLoginDialog(dialogId,options);var dialogOptions={autoOpen:true,modal:true,width:'auto',close:function(event,ui){var diag=$('#'+dialogId);diag.remove();}};if(options.prompt){dialogOptions.title=options.prompt;}
$dialog.dialog(dialogOptions);};var logout=function(options_){var options=$.extend({},defaultOptions,initOptions,options_);$n2.couch.getSession().logout({onSuccess:onSuccess});function onSuccess(result){log("Logout successful",result,options);options.onSuccess(result,options);notifyListeners();};};var getCurrentUser=function(){var context=getAuthContext();if(null==context.name){return null;}
if(context.userDoc){return context.userDoc;}
return context;};var getAuthContext=function(){return $n2.couch.getSession().getContext();};function isDeleteAllowed(){return isAdmin();}
function isUpdateAllowed(contribCreatorDisplayName){var allowed=false;var user=getCurrentUser();if(null!=user){if(user.admin){allowed=true;}else if(!user.anonymous&&""!=contribCreatorDisplayName&&user.display==contribCreatorDisplayName){allowed=true;}}
return(allowed);}
var isLoggedIn=function(){var authContext=getAuthContext();if(authContext&&authContext.name){return true;};return false;};var isUser=function(){if(!isLoggedIn())return false;var user=getCurrentUser();if(user.anonymous)return false;return true;};var isAdmin=function(){if(!isLoggedIn())return false;var user=getCurrentUser();if(!user.roles)return false;for(var i=0,e=user.roles.length;i<e;++i){if(user.roles[i]==='_admin'){return true;};};return false;};var isAnonymous=function(){if(!isLoggedIn())return false;var user=getCurrentUser();for(var i=0,e=user.roles.length;i<e;++i){if(user.roles[i]==='anonymous'){return true;};};return false;};function userLoggedInAndNotAnonymous(){if(!isLoggedIn())return false;if(isAnonymous())return false;return true;}
function autoAnonymousBehaviour(){return(isDefined(initOptions.autoAnonymousLogin)&&initOptions.autoAnonymousLogin);}
function _getDispatcher(){var d=null;if(initOptions.directory){d=initOptions.directory.dispatchService;};return d;};function _dispatch(m){var dispatcher=_getDispatcher();if(dispatcher){var h=dispatcher.getHandle('n2.couchAuth');dispatcher.send(h,m);};};$.NUNALIIT_AUTH={getUser:getCurrentUser,getAuthContext:getAuthContext,init:init,login:showLoginForm,logout:logout,addListener:addListeners,isDeleteAllowed:isDeleteAllowed,isUpdateAllowed:isUpdateAllowed,isLoggedIn:isLoggedIn,isUser:isUser,isAdmin:isAdmin,isAnonymous:isAnonymous,userLoggedInAndNotAnonymous:userLoggedInAndNotAnonymous,autoAnonymousBehaviour:autoAnonymousBehaviour,autoAnonLogin:autoAnonLogin};})(jQuery,nunaliit2);;(function($,$n2){var MapFeatureStyles=$n2.Class({defaultStyle:{normal:{fillColor:'#ffffff',strokeColor:'#ee9999',strokeWidth:2,fillOpacity:0.4,strokeOpacity:1,strokeLinecap:"round",strokeDashstyle:"solid",pointRadius:6,pointerEvents:"visiblePainted"},clicked:{strokeColor:"#ff2200"},hovered:{fillColor:"#0000ff"},hoveredClicked:{fillColor:"#0000ff",strokeColor:"#ff2200"}},initialDeltas:{base:null,point:null,line:null,polygon:null},basicStyles:null,stylesFromLayer:null,stylesFromSchema:null,initialize:function(userStyles){if(userStyles){this.initialDeltas.base=(userStyles.base?userStyles.base:null);this.initialDeltas.point=(userStyles.point?userStyles.point:null);this.initialDeltas.line=(userStyles.line?userStyles.line:null);this.initialDeltas.polygon=(userStyles.polygon?userStyles.polygon:null);};this.basicStyles=this._computeStyleSet({});this.stylesFromLayer={};if(userStyles&&userStyles.layers){for(var layerName in userStyles.layers){var layerDef=userStyles.layers[layerName];var layerSet=this._computeStyleSet(layerDef);this.stylesFromLayer[layerName]=layerSet;};};this.stylesFromSchema={};if(userStyles&&userStyles.schemas){for(var schemaName in userStyles.schemas){var schemaDef=userStyles.schemas[schemaName];var schemaSet=this._computeStyleSet(schemaDef);this.stylesFromSchema[schemaName]=schemaSet;};};},_computeStyleSet:function(setDelta){var computedSet={};computedSet.point=this._computeStyle(this.defaultStyle,this.initialDeltas.base,setDelta.base,this.initialDeltas.point,setDelta.point);computedSet.line=this._computeStyle(this.defaultStyle,this.initialDeltas.base,setDelta.base,this.initialDeltas.line,setDelta.line);computedSet.polygon=this._computeStyle(this.defaultStyle,this.initialDeltas.base,setDelta.base,this.initialDeltas.polygon,setDelta.polygon);return computedSet;},_computeStyle:function(baseStyle,delta1_,delta2_){var computedStyle={};computedStyle.normal=$n2.extend({},baseStyle.normal);for(var i=1,e=arguments.length;i<e;++i){var delta=arguments[i];if(delta&&delta.normal){$n2.extend(computedStyle.normal,delta.normal);};};computedStyle.hovered=$n2.extend({},computedStyle.normal,baseStyle.hovered);computedStyle.clicked=$n2.extend({},computedStyle.normal,baseStyle.clicked);computedStyle.hoveredClicked=$n2.extend({},computedStyle.normal,baseStyle.hoveredClicked);for(var i=1,e=arguments.length;i<e;++i){var delta=arguments[i];if(delta&&delta.hovered){$n2.extend(computedStyle.hovered,delta.hovered);};if(delta&&delta.clicked){$n2.extend(computedStyle.clicked,delta.clicked);};if(delta&&delta.hoveredClicked){$n2.extend(computedStyle.hoveredClicked,delta.hoveredClicked);};};computedStyle.normal=new OpenLayers.Style(computedStyle.normal);computedStyle.hovered=new OpenLayers.Style(computedStyle.hovered);computedStyle.clicked=new OpenLayers.Style(computedStyle.clicked);computedStyle.hoveredClicked=new OpenLayers.Style(computedStyle.hoveredClicked);return computedStyle;},getStyleMapForLayerInfo:function(layerInfo){var _this=this;var styleMap=new OpenLayers.StyleMapCallback(function(feature,intent){var effectiveIntent=null;if(null==effectiveIntent&&feature.isHovered){if(feature.isClicked){effectiveIntent='hoveredClicked';}else{effectiveIntent='hovered';};};if(null==effectiveIntent&&feature.isClicked){effectiveIntent='clicked';};if(null==effectiveIntent){effectiveIntent='normal';};var geomType=feature.geometry._n2Type;if(!geomType){if(feature.geometry.CLASS_NAME.indexOf('Line')>=0){geomType=feature.geometry._n2Type='line';}else if(feature.geometry.CLASS_NAME.indexOf('Polygon')>=0){geomType=feature.geometry._n2Type='polygon';}else{geomType=feature.geometry._n2Type='point';};};var layerName=layerInfo.name;var schemaName=null;if(feature&&feature.data&&feature.data.nunaliit_schema){schemaName=feature.data.nunaliit_schema;};var style=null;if(schemaName&&_this.stylesFromSchema[schemaName]){style=_this.stylesFromSchema[schemaName][geomType][effectiveIntent];};if(null==style&&layerName&&_this.stylesFromLayer[layerName]){style=_this.stylesFromLayer[layerName][geomType][effectiveIntent];};if(null==style){style=_this.basicStyles[geomType][effectiveIntent];};return style.createSymbolizer(feature);});return styleMap;}});var Module=$n2.Class({moduleDoc:null,atlasDb:null,initialize:function(moduleDoc,atlasDb){this.moduleDoc=moduleDoc;this.atlasDb=atlasDb;},getModuleInfo:function(){var moduleInfo=null;if(this.moduleDoc){moduleInfo=this.moduleDoc.nunaliit_module;};return moduleInfo;},getMapInfo:function(){var mapInfo=null;var moduleInfo=this.getModuleInfo();if(moduleInfo){mapInfo=moduleInfo.map;};return mapInfo;},getDisplayInfo:function(){var displayInfo=null;var moduleInfo=this.getModuleInfo();if(moduleInfo){displayInfo=moduleInfo.display;};return displayInfo;},getEditInfo:function(){var editInfo=null;var moduleInfo=this.getModuleInfo();if(moduleInfo){editInfo=moduleInfo.edit;};return editInfo;},displayIntro:function($elem){var introInfo=null;var moduleInfo=this.getModuleInfo();if(moduleInfo){introInfo=moduleInfo.introduction;};if(!introInfo){$elem.empty();return false;}else{if('html'===introInfo.type&&introInfo.content){$elem.html(introInfo.content);return true;}else if('text'===introInfo.type&&introInfo.content){$elem.text(introInfo.content);return true;}else if('attachment'===introInfo.type&&introInfo.attachmentName&&this.atlasDb){var displayId=$n2.getUniqueId();$elem.empty().append($('<div id="'+displayId+'"></div>'));var docUrl=this.atlasDb.getDocumentUrl(this.moduleDoc);var attUrl=docUrl+'/'+introInfo.attachmentName;$.ajax({url:attUrl,type:'get',async:true,success:function(intro){$('#'+displayId).html(intro);},error:function(XMLHttpRequest,textStatus,errorThrown){$n2.log('Unable to obtain module intro: '+textStatus);}});return true;}else{$elem.empty();return false;};}}});var ModuleDisplay=$n2.Class({config:null,moduleName:null,module:null,mapControl:null,titleName:null,sidePanelName:null,filterPanelName:null,searchPanelName:null,styles:null,initialize:function(opts_){var opts=$n2.extend({moduleName:null,config:null,titleName:'title',mapName:'map',sidePanelName:'side',filterPanelName:'filters',searchPanelName:'searchInput',onSuccess:function(){},onError:function(err){$n2.reportErrorForced(errorMsg);}},opts_);var _this=this;this.moduleName=opts.moduleName;this.moduleDoc=opts.moduleDoc
if(!this.moduleName&&!this.moduleDoc){opts.onError('"moduleName" or "moduleDoc" must be specified');return;};this.config=opts.config;if(!this.config){opts.onError('"config" must be specified');return;};this.sidePanelName=opts.sidePanelName;this.filterPanelName=opts.filterPanelName;this.searchPanelName=opts.searchPanelName;var config=this.config;var atlasDb=config.atlasDb;var atlasDesign=config.atlasDesign;if(!$n2.isDefined(this.moduleDoc)){atlasDb.getDocument({docId:this.moduleName,onSuccess:moduleDocumentLoaded,onError:function(err){opts.onError('Unable to load module: '+err);}});}else{moduleDocumentLoaded(this.moduleDoc);};function moduleDocumentLoaded(moduleDoc){if(!moduleDoc.nunaliit_module){opts.onError('Loaded document does not include module information');return;};_this.module=new Module(moduleDoc,atlasDb);var moduleInfo=_this.module.getModuleInfo();var mapInfo=_this.module.getMapInfo();var displayInfo=_this.module.getDisplayInfo();var editInfo=_this.module.getEditInfo();_this.styles=new MapFeatureStyles((mapInfo?mapInfo.styles:null));_this._initSidePanel();if(moduleInfo&&moduleInfo.title){document.title=''+moduleInfo.title;$('#'+opts.titleName).text(moduleInfo.title);}else{document.title='Nunaliit Atlas';$('#'+opts.titleName).text('Nunaliit Atlas');};$.olkitDisplay=new $n2.couchDisplay({db:atlasDb,designDoc:atlasDesign,displayPanelName:opts.sidePanelName,showService:_this.config.show,editor:_this.config.couchEditor,uploadService:_this.config.uploadServer,serviceDirectory:_this.config.directory});var defaultDisplaySchemaName='object';if(displayInfo&&displayInfo.defaultSchemaName){defaultDisplaySchemaName=displayInfo.defaultSchemaName;};config.directory.schemaRepository.getSchema({name:defaultDisplaySchemaName,onSuccess:function(schema){if($.olkitDisplay.setSchema){$.olkitDisplay.setSchema(schema);};}});var defaultEditSchemaName='object';if(editInfo&&editInfo.defaultSchemaName){defaultEditSchemaName=editInfo.defaultSchemaName;};config.directory.schemaRepository.getSchema({name:defaultEditSchemaName,onSuccess:function(schema){config.couchEditor.options.defaultEditSchema=schema;}});if(editInfo&&editInfo.newDocumentSchemaNames){if('ALL_SCHEMAS'===editInfo.newDocumentSchemaNames){config.couchEditor.options.schema=$n2.CouchEditor.Constants.ALL_SCHEMAS;}else if(editInfo.newDocumentSchemaNames.length){config.directory.schemaRepository.getSchemas({names:editInfo.newDocumentSchemaNames,onSuccess:function(schemas){config.couchEditor.options.schema=schemas;},onError:function(err){$n2.log('Error obtaining new edit document schemas: '+err);}});};};var searchInput=$('<input type="text" class="search_panel_input" value="search the atlas"></input>');$('#'+_this.searchPanelName).empty().append(searchInput);config.directory.searchService.installSearch({textInput:searchInput,initialSearchText:'search the atlas',dispatchService:config.directory.dispatchService});defineMap();};function defineMap(){var mapInfo=_this.module.getMapInfo();var addPointsOnly=false;if(mapInfo&&mapInfo.addPointsOnly){addPointsOnly=mapInfo.addPointsOnly;};var toggleClick=false;if(mapInfo&&mapInfo.toggleClick){toggleClick=mapInfo.toggleClick;};var dbSearchEngine={relMediaPath:'./'};if(mapInfo&&mapInfo.dbSearchEngine){dbSearchEngine=mapInfo.dbSearchEngine;};var mapOptions={dbSearchEngine:dbSearchEngine,mapIdentifier:opts.mapName,mapCoordinateSpecifications:{initialBounds:null},uniqueIdentifier:'_id',addPointsOnly:addPointsOnly,overlays:[],toggleClick:toggleClick,toggleClickFn:function(){_this._initSidePanel();},sidePanelName:opts.sidePanelName,filterPanelName:opts.filterPanelName,saveFeature:config.couchEditor,mapDisplay:null,directory:config.directory};if(mapInfo&&mapInfo.overlays){for(var i=0,e=mapInfo.overlays.length;i<e;++i){var layerInfo=mapInfo.overlays[i];var layerDefiniton={name:layerInfo.name,type:layerInfo.type,featurePopupHtmlFn:config.popupHtmlFn,featurePopupDelay:0,styleMapFn:function(layerInfo_){return _this.styles.getStyleMapForLayerInfo(layerInfo_);},useHoverSound:true};if('couchdb'===layerInfo.type){layerDefiniton.options=$n2.extend({viewName:'geom',layerName:null,db:atlasDb,designDoc:atlasDesign},layerInfo.options);}else{layerDefiniton.options=layerInfo.options;};if(layerInfo.featurePopupDelayMs){layerDefiniton.featurePopupDelay=layerInfo.featurePopupDelayMs;};if(typeof(layerInfo.useHoverSound)==='boolean'){layerDefiniton.useHoverSound=layerInfo.useHoverSound;};mapOptions.overlays.push(layerDefiniton);};};if(mapInfo&&mapInfo.backgrounds){mapOptions.mapDisplay={backgrounds:mapInfo.backgrounds};};var initialBounds=null;if(mapInfo&&mapInfo.coordinates){initialBounds=mapInfo.coordinates.initialBounds;};if(!initialBounds){opts.onError('Initial map extent not specified');return;};if(mapInfo&&mapInfo.coordinates&&mapInfo.coordinates.autoInitialBounds){computeAutoInitialBounds(mapOptions,initialBounds,mapInfo.coordinates.autoInitialBounds);}else{initialBoundsComputed(mapOptions,initialBounds);};};function computeAutoInitialBounds(mapOptions,initialBounds,autoInitialBounds){var layerBoundingBox=null;var layersPending=0;for(var i=0,e=mapOptions.overlays.length;i<e;++i){var layerDef=mapOptions.overlays[i];if(layerDef.type==='couchdb'){++layersPending;var layerName=layerDef.options.layerName;var designDoc=layerDef.options.designDoc;designDoc.queryView({viewName:'geom-layer',startkey:layerName,endkey:layerName,onlyRows:true,reduce:true,onSuccess:function(rows){if(rows.length>0){reportLayer(rows[0].value);}else{reportLayer(null);};},onError:function(errorMsg){$n2.log('Error computing bounds for layer '+layerName+': '+errorMsg);reportLayer(null);}});};};testDone();function reportLayer(bounds){--layersPending;if(null!=bounds){if(null==layerBoundingBox){layerBoundingBox=bounds;}else{if(layerBoundingBox[0]>bounds[0])layerBoundingBox[0]=bounds[0];if(layerBoundingBox[1]>bounds[1])layerBoundingBox[1]=bounds[1];if(layerBoundingBox[2]<bounds[2])layerBoundingBox[2]=bounds[2];if(layerBoundingBox[3]<bounds[3])layerBoundingBox[3]=bounds[3];};};testDone();};function testDone(){if(layersPending>0){return;};if(null==layerBoundingBox){initialBoundsComputed(mapOptions,initialBounds);}else if(layerBoundingBox[0]>=initialBounds[0]&&layerBoundingBox[1]>=initialBounds[1]&&layerBoundingBox[2]<=initialBounds[2]&&layerBoundingBox[3]<=initialBounds[3]){initialBoundsComputed(mapOptions,initialBounds);}else if((layerBoundingBox[2]-layerBoundingBox[0])<(initialBounds[2]-initialBounds[0])||(layerBoundingBox[3]-layerBoundingBox[1])<(initialBounds[3]-initialBounds[1])){if((layerBoundingBox[2]-layerBoundingBox[0])<(initialBounds[2]-initialBounds[0])){var l=(initialBounds[2]-initialBounds[0])/2;var m=(layerBoundingBox[2]+layerBoundingBox[0])/2;layerBoundingBox[0]=m-l;layerBoundingBox[2]=m+l;};if((layerBoundingBox[3]-layerBoundingBox[1])<(initialBounds[3]-initialBounds[1])){var l=(initialBounds[3]-initialBounds[1])/2;var m=(layerBoundingBox[3]+layerBoundingBox[1])/2;layerBoundingBox[1]=m-l;layerBoundingBox[3]=m+l;};initialBoundsComputed(mapOptions,layerBoundingBox);}else{initialBoundsComputed(mapOptions,layerBoundingBox);};};};function initialBoundsComputed(mapOptions,initialBounds){mapOptions.mapCoordinateSpecifications.initialBounds=initialBounds;_this.mapControl=nunaliit2.mapAndControls(mapOptions);$n2.log('map & control',_this.mapControl);_this.mapControl.contributions=config.contributions;_this.mapControl.requests=config.requests;opts.onSuccess(_this);};},_initSidePanel:function(){var $elem=$('#'+this.sidePanelName);var intro_html=this.module.displayIntro($elem);}});$n2.couchModule={ModuleDisplay:ModuleDisplay};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str){return $n2.loc(str,'nunaliit2');};var Export=$n2.Class('Export',{serverUrl:null,initialize:function(opts_){var opts=$n2.extend({url:null},opts_);this.serverUrl=opts.url;},checkAvailable:function(opts_){var opts=$n2.extend({onAvailable:function(){},onNotAvailable:function(){}},opts_);if(!this.serverUrl){opts.onNotAvailable();return;};var _this=this;$.ajax({url:this.serverUrl+'welcome',type:'GET',dataType:'json',success:function(data,textStatus,jqXHR){if(data&&data.ok){opts.onAvailable();}else{opts.onNotAvailable();};},error:function(jqXHR,textStatus,errorThrown){opts.onNotAvailable();}});},exportByDocIds:function(opts_){var opts=$n2.extend({docIds:null,targetWindow:null,geometryType:'all',onError:$n2.reportError},opts_);if(!opts.docIds){onError('docIds must be provided when exporting by docIds');};var target='';if(opts.targetWindow){target=' target="'+opts.targetWindow+'"';};var url=this.serverUrl+'export';var $form=$('<form action="'+url+'" method="POST"'+target+'></form>');$('<input type="hidden" name="format" value="geojson"></input>').appendTo($form);$('<input type="hidden" name="method" value="doc-id"></input>').appendTo($form);$('<input type="hidden" name="filter"></input>').val(opts.geometryType).appendTo($form);for(var i=0,e=opts.docIds.length;i<e;++i){var docId=opts.docIds[i];$('<input type="hidden" name="name"></input>').val(docId).appendTo($form);};$('body').append($form);$form.submit();}});$n2.couchExport={Export:Export};})(jQuery,nunaliit2);;(function($,$n2){var _loc=function(str){return $n2.loc(str,'nunaliit2-couch');};var DispatchSupport=$n2.Class('DispatchSupport',{options:null,dispatcherHandle:null,docCreatedCb:null,docUpdatedCb:null,initialize:function(opts_){this.options=$n2.extend({directory:null},opts_);var _this=this;this.docCreatedCb=function(doc){_this._docUploaded(doc,true);};this.docUpdatedCb=function(doc){_this._docUploaded(doc,false);};var dispatcher=this._getDispatcher();if(dispatcher){this.dispatcherHandle=dispatcher.getHandle('n2.couchDispatchSupport');var f=function(m){_this._handleDispatch(m);};dispatcher.register(this.dispatcherHandle,'documentCreated',f);dispatcher.register(this.dispatcherHandle,'documentUpdated',f);};},_handleDispatch:function(m){if('documentCreated'===m.type){var requestService=this._getRequestService();if(requestService){requestService.requestDocument(m.docId,this.docCreatedCb);};}else if('documentUpdated'===m.type){var requestService=this._getRequestService();if(requestService){requestService.requestDocument(m.docId,this.docUpdatedCb);};};},_docUploaded:function(doc,created){if(doc.nunaliit_geom){var type=created?'featureCreated':'featureUpdated';this._dispatch({type:type,docId:doc._id,doc:doc});};},_getDispatcher:function(){var d=null;if(this.options.directory){d=this.options.directory.dispatchService;};return d;},_dispatch:function(m){var dispatcher=this._getDispatcher();if(dispatcher){dispatcher.send(this.dispatcherHandle,m);};},_getRequestService:function(){var r=null;if(this.options.directory){r=this.options.directory.requestService;};return r;}});$n2.couchDispatchSupport={DispatchSupport:DispatchSupport};})(jQuery,nunaliit2);